c
c----------------------------------------------------------------
c
      program reibis
c
c  Convert restart data from IBIS simulation output to input
c  data for continued IBIS simulation
c
      include 'parm.inc'
c
c  namelist variables
c
      character*4 type
      character*1024 fnm
      double precision umax,time
      integer nt,ccount,lcount
c
c  immersed boundary point variables
c
      integer npt, iclose,categor, activ1, activ2
      double precision xcm, ycm
      double precision x, y, xr, yt, dlp, swp, csp, sp, sthp
c
c  link variables
c
      integer q1,q2,p1,p2,r1,r2
      double precision stfb,sbrk,rstb
c
c  fluid variables
c
      double precision u(0:nxp2,0:nyp1,2)
      integer pmark(np)
      double precision px(np), py(np)
c
c  local variables
c
      integer ient,inum,ipt,jpt,ilink,nlnk,j,i
      integer jfil,jpoly,jplat,nlinke
c
c  open the restart data file
c
      open(unit=12,file='ibisdat/rs.data',form='unformatted')
c
c  write the name list data
c
      read(12) umax,nt,time,ccount,lcount
c
c  write data for the namelist file
c
      open(unit=13,file='ibisdat/rsinit.dat')
      write(13,*)' umax       = ', umax,','
      write(13,*)' ntstart    = ', nt,','
      write(13,*)' time       = ', time,','
      write(13,*)' ccount     = ', ccount,','
      write(13,*)' lcount     = ', lcount,','
      close(13)
c
c  read/write the entity data
c
      open(unit=13,file='ibisdat/rsibpts.dat',status='unknown')
c
      read(12) inum
      read(12) jfil,jpoly,jplat,nlinke
      write(13,*) jfil,jpoly,jplat,nlinke

      do ient = 1, inum

        read(12) type
        write(13,1004) type

        read(12) npt, iclose, categor, activ1, activ2,
     x      xcm, ycm
        write(13,1005) npt, iclose,categor, activ1, activ2,
     x      xcm, ycm

        do jpt = 1, npt-1
          read(12) ipt, x, y, xr, yt,
     x        dlp, swp, csp, sp, sthp
          write(13,1006) 1, x, y, xr, yt,
     x        dlp, swp, csp, sp, sthp
        enddo
        read(12) ipt, x, y, xr, yt,
     x        dlp, swp, csp, sp, sthp
        write(13,1006) 0, x, y, xr, yt,
     x        dlp, swp, csp, sp, sthp
      enddo
      close(13)
c
c  write the link data
c
      open(unit=13,file='ibisdat/rslink.dat',status='unknown')
      read(12) nlnk
      write(13,*) nlnk
      do ilink = 1, nlnk
        read(12) q1,q2,p1,p2,r1,r2,stfb,sbrk,rstb
        write(13,1007) q1,q2,p1,p2,r1,r2,stfb,sbrk,rstb
      enddo
      close(13)
c
c  write the fluid data
c
      open(unit=13,file='ibisdat/rsfluid.dat',status='unknown')
      read (12) u
c
      do j = 1, ny
        do i = 1, nx
          write(13,1008) u(i,j,1), u(i,j,2)
        enddo
      enddo
      close(13)
c
c  write the fluid marker data
c
      do j = 1,np
        px(j) = 0.0d0
        py(j) = 0.0d0
        pmark(j) = 0
        read (12) px(j), py(j), pmark(j)
      enddo
      close(12)

      open(unit=13,file='ibisdat/rspart.dat',status='unknown')
      do j=1, np
        write(13,1009) px(j), py(j), pmark(j)
      enddo
      close(13)
c
 1004 format (A4)
 1005 format (5(i6,1x),2e25.17)
 1006 format (i6,9e25.17)
 1007 format (6(i6,1x),3e25.17)
 1008 format (2e25.17)
 1009 format (2e16.7,1x,i3)
      end



