c
      subroutine sprdinit
c
c  index map of 4x4 square to length 16 one dimensional array.
c  interpolation spread
c
      integer jx,jy
      common/sprdmap/ jx(16),jy(16)
c
      integer i,ix,iy
c
      do 10 i=1,16
         iy = (i - 1)/4
         ix = (i - 4*iy -1)
         jy(i)=iy+1
         jx(i)=ix+1
   10 continue
      return
      end
c
c------------------------------------------------------------
c
c spread5 -- modified from spread4 11/9/98
c
      subroutine spread(npts,nxp2,nyp1,f)
c
      implicit none
c
c  global include
c
      include 'domain.inc'

      integer jx,jy
      common/sprdmap/ jx(16),jy(16)
c
c  global variables
c
      integer npts,nxp2,nyp1
      double precision f(0:nxp2,0:nyp1,2)
c
c  local variables
c 
      integer jmarr,kmarr
      double precision f1,f2,xsprd,ysprd
      double precision xwt(4)
      double precision ywt(4)
      double precision wt(16)
c
c  body force globals
c
      double precision xpt(1)
      common /enxpt/ xpt

      double precision ypt(1)
      common /enypt/ ypt
c
      double precision fs(1)
      common /sfs/ fs
c
c  local variables
c
      integer i,ii
      integer j,jmp,jxii,jyii
      integer k,kmp,n,nx,ny
c
      double precision wt1x,wt1y,wt2x,wt2y
      double precision argx,argy
      double precision cy1,cy2,sy1,sy2
      double precision cx1,cx2,sx1,sx2
      double precision cx,cy,rh,sx,sy,xper100,yper100
c
      nx   = nxp2 - 2
      ny   = nyp1 - 1
c
c once only ccccccccccccccccccccccccccccccccccccccccc
c
      xper100 = xlength*100.d0
      yper100 = ylength*100.d0
      rh   = 1.d0/h
      wt1x = 2.0d0*datan(1.0d0)*rh
      wt1y = 2.0d0*datan(1.0d0)*rh
      wt2x = .25d0*rh
      wt2y = .25d0*rh
      cy1  = dcos(wt1y*h)
      sy1  = dsin(wt1y*h)
      cy2  = dcos(2.d0*wt1y*h)
      sy2  = dsin(2.d0*wt1y*h)
      cx1  = dcos(wt1x*h)
      sx1  = dsin(wt1x*h)
      cx2  = dcos(2.d0*wt1x*h)
      sx2  = dsin(2.d0*wt1x*h)
c
c once only done ccccccccccccccccccccccccccccccccccc
c
      do 1 j=0,nx
        do 1 k=0,ny
          f(j,k,1)=0.0D+00
          f(j,k,2)=0.0D+00
 1    continue
c
      do 100 n=1,npts
         xsprd=xpt(n)+xper100
         ysprd=ypt(n)+yper100
         jmarr=idint(xsprd*rh)
         kmarr=idint(ysprd*rh)
         f1 = dlibp*fs(2*n-1)
         f2 = dlibp*fs(2*n  )
c
c  compute weights
c
         argy=wt1y*(ysprd-dble(idint(ysprd*rh))*h)
         cy = dcos(argy)
         sy = dsin(argy)
         ywt(1)=wt2y*(1.0d0 + cy*cy1 - sy*sy1)
         ywt(2)=wt2y*(1.0d0 + cy)
         ywt(3)=wt2y*(1.0d0 + cy*cy1 + sy*sy1)
         ywt(4)=wt2y*(1.0d0 + cy*cy2 + sy*sy2)
         argx=wt1x*(xsprd-dble(idint(xsprd*rh))*h)
         cx = dcos(argx)
         sx = dsin(argx)
         xwt(1)=wt2x*(1.0d0 + cx*cx1 - sx*sx1)
         xwt(2)=wt2x*(1.0d0 + cx)
         xwt(3)=wt2x*(1.0d0 + cx*cx1 + sx*sx1)
         xwt(4)=wt2x*(1.0d0 + cx*cx2 + sx*sx2)
c
         do 20 ii=1,16
            jxii = jx(ii)  
            jyii = jy(ii)  
            wt(ii) = xwt(jxii)*ywt(jyii)
            jmp=mod((jmarr-2+jxii)+100*nx,nx)
            kmp=mod((kmarr-2+jyii)+100*ny,ny)
            f(jmp,kmp,1)=f(jmp,kmp,1)+wt(ii)*f1
            f(jmp,kmp,2)=f(jmp,kmp,2)+wt(ii)*f2
 20      continue
 100  continue
c
c extend periodically
c
      do 160 j=0,ny
         f(nx,j,1)=f(0,j,1)
         f(nx,j,2)=f(0,j,2)
 160  continue
      do 170 i=0,nx
         f(i,ny,1)=f(i,0,1)
         f(i,ny,2)=f(i,0,2)
 170  continue
      return
      end

c
c------------------------------------------------------------
c
c xmove4 - modified from xmove3  11/8/98
c
      subroutine xmove (npts,nxp2,nyp1,u)
c
      implicit none
c
c  global include
c
      include 'domain.inc'

      integer jx,jy
      common/sprdmap/ jx(16),jy(16)
c
c  global variables
c
      integer npts,nxp2,nyp1
      double precision u(0:nxp2,0:nyp1,2)
c
c
c  body force globals
c
      double precision xpt(1)
      common /enxpt/ xpt

      double precision ypt(1)
      common /enypt/ ypt

      double precision us1(1)
      common /usv1/ us1

      double precision us2(1)
      common /usv2/ us2

c
c  local variables
c
c
c local variables
c
      double precision xwt(4)
      double precision ywt(4)
      double precision wt(16)
      double precision xsprd,ysprd
c
      integer jmarr,kmarr
      integer ii,jmp,jxii,jyii
      integer kmp,nx,ny
      integer n
c
      double precision wt1x,wt1y,wt2x,wt2y
      double precision rh,h2
      double precision argx,argy
      double precision cy1,cy2,sy1,sy2
      double precision cx1,cx2,sx1,sx2
      double precision cx,cy,sx,sy,xper100,yper100
c
      nx   = nxp2 - 2
      ny   = nyp1 - 1
c
c once only ccccccccccccccccccccccccccccccccccccccccc
c
      xper100 = xlength*100.d0
      yper100 = ylength*100.d0
      rh   = 1.d0/h
      wt1x = 2.0d0*datan(1.0d0)*rh
      wt1y = 2.0d0*datan(1.0d0)*rh
      wt2x = .25d0*rh
      wt2y = .25d0*rh
      h2   = h*h
      cy1  = dcos(wt1y*h)
      sy1  = dsin(wt1y*h)
      cy2  = dcos(2.d0*wt1y*h)
      sy2  = dsin(2.d0*wt1y*h)
      cx1  = dcos(wt1x*h)
      sx1  = dsin(wt1x*h)
      cx2  = dcos(2.d0*wt1x*h)
      sx2  = dsin(2.d0*wt1x*h)
c
c once only done ccccccccccccccccccccccccccccccccccc
c
      do 100 n=1,npts
c
c add large multiple of period to x,y so x>0 and y>0
c to avoid testing
c
         xsprd=xpt(n)+xper100
         ysprd=ypt(n)+yper100
         jmarr=idint(xsprd*rh)
         kmarr=idint(ysprd*rh)
c
c  compute weights
c
         argy=wt1y*(ysprd-dble(idint(ysprd*rh))*h)
         cy = dcos(argy)
         sy = dsin(argy)
         ywt(1)=wt2y*(1.0d0 + cy*cy1 - sy*sy1)
         ywt(2)=wt2y*(1.0d0 + cy)
         ywt(3)=wt2y*(1.0d0 + cy*cy1 + sy*sy1)
         ywt(4)=wt2y*(1.0d0 + cy*cy2 + sy*sy2)
         argx=wt1x*(xsprd-dble(idint(xsprd*rh))*h)
         cx = dcos(argx)
         sx = dsin(argx)
         xwt(1)=wt2x*(1.0d0 + cx*cx1 - sx*sx1)
         xwt(2)=wt2x*(1.0d0 + cx)
         xwt(3)=wt2x*(1.0d0 + cx*cx1 + sx*sx1)
         xwt(4)=wt2x*(1.0d0 + cx*cx2 + sx*sx2)
c
        us1(n)=0.d0
        us2(n)=0.d0
        do 20 ii=1,16
           jxii = jx(ii)  
           jyii = jy(ii)  
           wt(ii) = xwt(jxii)*ywt(jyii)
           jmp=mod((jmarr-2+jxii)+100*nx,nx)
           kmp=mod((kmarr-2+jyii)+100*ny,ny)
           us1(n)=us1(n)+wt(ii)*u(jmp,kmp,1)
           us2(n)=us2(n)+wt(ii)*u(jmp,kmp,2)
 20     continue
        xpt(n)=xpt(n)+dlt*us1(n)*h2
        ypt(n)=ypt(n)+dlt*us2(n)*h2
 100  continue
c
      return
      end

