c
      subroutine grad
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'domain.inc'
      include 'force.inc'
c
c  local variables
c
      integer i,iend,ione,jent,icat
      double precision dist,sm
c
c  initiate the gradients
c
      do 10 i=1,npts
         gfrc1(i)=0.0D+00
         gfrc2(i)=0.0D+00
 10   continue
c
c  calculate the forces
c
      do 50 jent=1,ment
         ione = first(jent)
         iend = last(jent)
         icat = cat(jent)
         if (icat.eq.0) goto 50
c
c   use work vectors
c
         do 15 i=ione,iend
           xwrk(i)   = xpt(i)
           ywrk(i)   = ypt(i)
           dlwrk(i)  = dl(i)
           swwrk(i)  = sw(i)
           cswrk(i)  = cs(i)
           swrk(i)   = s(i)
 15      continue
c
c  do different things for different types of things
c    affects the ends of the work arrays
c
c    open polygons - make sure the distance function
c      is ok
c
         if ( icat .eq. -3 ) then
           xwrk(ione-2)  = (2.0d0*xpt(ione+1)) - xpt(ione+2)
           xwrk(ione-1)  = (2.0d0*xpt(ione)) - xpt(ione+1)
           xwrk(iend+1)  = (2.0d0*xpt(iend)) - xpt(iend-1)
           xwrk(iend+2)  = (2.0d0*xpt(iend-1)) - xpt(iend-2)
           ywrk(ione-2)  = (2.0d0*ypt(ione+1)) - ypt(ione+2)
           ywrk(ione-1)  = (2.0d0*ypt(ione)) - ypt(ione+1)
           ywrk(iend+1)  = (2.0d0*ypt(iend)) - ypt(iend-1)
           ywrk(iend+2)  = (2.0d0*ypt(iend-1)) - ypt(iend-2)
           dlwrk(ione-1) = dl(iend)
           dlwrk(iend+1) = dl(ione)
           swwrk(ione-1) = sw(iend)
           swwrk(iend+1) = sw(ione)
           cswrk(ione-1) = cs(iend)
           cswrk(iend+1) = cs(ione)
           swrk(ione-1)  = s(iend)
           swrk(iend+1)  = s(ione)
c
c    closed polygons - make periodic in x and y
c
         elseif ( icat .eq. -2 ) then
           xwrk(ione-2) = xpt(iend-1)
           xwrk(ione-1) = xpt(iend)
           xwrk(iend+1) = xpt(ione)
           xwrk(iend+2) = xpt(ione+1)
           ywrk(ione-2) = ypt(iend-1)
           ywrk(ione-1) = ypt(iend)
           ywrk(iend+1) = ypt(ione)
           ywrk(iend+2) = ypt(ione+1)
           dlwrk(ione-1) = dl(iend)
           dlwrk(iend+1) = dl(ione)
           swwrk(ione-1) = sw(iend)
           swwrk(iend+1) = sw(ione)
           cswrk(ione-1) = cs(iend)
           cswrk(iend+1) = cs(ione)
           swrk(ione-1)  = s(iend)
           swrk(iend+1)  = s(ione)
c
c    tubes - make periodic in x only
c
         elseif ( icat .eq. -1 ) then
           xwrk(ione-2) = xpt(iend-1)-xlength
           xwrk(ione-1) = xpt(iend)-xlength
           xwrk(iend+1) = xpt(ione)+xlength
           xwrk(iend+2) = xpt(ione+1)+xlength
           ywrk(ione-2) = ypt(iend-1)
           ywrk(ione-1) = ypt(iend)
           ywrk(iend+1) = ypt(ione)
           ywrk(iend+2) = ypt(ione+1)
           dlwrk(ione-1) = dl(iend)
           dlwrk(iend+1) = dl(ione)
           swwrk(ione-1) = sw(iend)
           swwrk(iend+1) = sw(ione)
           cswrk(ione-1) = cs(iend)
           cswrk(iend+1) = cs(ione)
           swrk(ione-1)  = s(iend)
           swrk(iend+1)  = s(ione)
c
c    circles - make periodic in x and y
c
         else
           xwrk(ione-2) = xpt(iend-1)
           xwrk(ione-1) = xpt(iend)
           xwrk(iend+1) = xpt(ione)
           xwrk(iend+2) = xpt(ione+1)
           ywrk(ione-2) = ypt(iend-1)
           ywrk(ione-1) = ypt(iend)
           ywrk(iend+1) = ypt(ione)
           ywrk(iend+2) = ypt(ione+1)
           dlwrk(ione-1) = dl(iend)
           dlwrk(iend+1) = dl(ione)
           swwrk(ione-1) = sw(iend)
           swwrk(iend+1) = sw(ione)
           cswrk(ione-1) = cs(iend)
           cswrk(iend+1) = cs(ione)
           swrk(ione-1)  = s(iend)
           swrk(iend+1)  = s(ione)
         endif
c
c  Calculate stretching forces on entity jent
c
         do 20 i=ione,iend+1
           sm = dist(xwrk(i-1),ywrk(i-1),xwrk(i),ywrk(i))
           wrk(i) = (sm-dlwrk(i-1))*swwrk(i-1)/sm
 20      continue
         do 25 i=ione,iend
           gfrc1(i) = gfrc1(i)
     x              + (wrk(i)*(xwrk(i)-xwrk(i-1)))
     x              + (wrk(i+1)*(xwrk(i)-xwrk(i+1)))
           gfrc2(i) = gfrc2(i) 
     x              + (wrk(i)*(ywrk(i)-ywrk(i-1)))
     x              + (wrk(i+1)*(ywrk(i)-ywrk(i+1)))
 25      continue
c
c  Calculate bending forces
c
         do 30 i=ione-1,iend+1
            wrk(i) = ((xwrk(i+1)*(ywrk(i)-ywrk(i-1)))
     x              + (xwrk(i)*(ywrk(i-1)-ywrk(i+1)))
     x              + (xwrk(i-1)*(ywrk(i+1)-ywrk(i)))
     x              - cswrk(i))*swrk(i)
 30      continue
         do 35 i=ione,iend
            gfrc1(i) = gfrc1(i)
     x              + (wrk(i-1)*(ywrk(i-1)-ywrk(i-2)))
     x              + (wrk(i)*(ywrk(i-1)-ywrk(i+1)))
     x              + (wrk(i+1)*(ywrk(i+2)-ywrk(i+1)))
            gfrc2(i) =  gfrc2(i) 
     x              + (wrk(i-1)*(xwrk(i-2)-xwrk(i-1)))
     x              + (wrk(i)*(xwrk(i+1)-xwrk(i-1)))
     x              + (wrk(i+1)*(xwrk(i+1)-xwrk(i+2)))
 35      continue
c
c  Calculate tethering forces
c
         do 40 i=ione, iend
            gfrc1(i) =  gfrc1(i) + (sth(i)*(xpt(i)-xt(i)))
            gfrc2(i) =  gfrc2(i) + (sth(i)*(ypt(i)-yt(i)))
 40      continue
c
 50   continue
 9990 format(5f15.7)
      return
      end

c
      subroutine gradlink
c
      implicit none
      include 'ibp.inc'
      include 'links.inc'
c
c  local variables
c
      integer i
      double precision sm,xi,xp,xp1,yp,yp1,dist
c
c  compute forces
c
      do 10 i=1,nlink
        xp1 = xpt(n1(i))
        yp1 = ypt(n1(i))
        xp  = xpt(n2(i))
        yp  = ypt(n2(i))
        sm  = dist(xp1,yp1,xp,yp)
        xi  = (sm-rest(n1(i)))*stiff(n1(i))
        if (sm.gt.1.0d-8) then
          xi  = xi/sm
        else
          xi = 0.0d0
        endif
        gfrc1(n1(i))=xi*(xp1-xp)+gfrc1(n1(i))
        gfrc1(n2(i))=-xi*(xp1-xp)+gfrc1(n2(i))
        gfrc2(n1(i))=xi*(yp1-yp)+gfrc2(n1(i))
        gfrc2(n2(i))=-xi*(yp1-yp)+gfrc2(n2(i))
 10   continue
      return
      end
c
c
      subroutine fadd(nxp2,nyp1,f)
c
c  add the background force
c
      implicit none
      include 'domain.inc'
      include 'fluid.inc'
c
      integer nxp2,nyp1
      double precision f(0:nxp2,0:nyp1,1:2)
c
      integer i,j
c
      do j = ibtube, ittube
        do i = 1, nxp2-2
          f(i,j,1)= fbpx+f(i,j,1)
          f(i,j,2)= fbpy+f(i,j,2)
        enddo
      enddo
c
      return
      end
