c
      subroutine chgcatb(listf,listb,i,p1,pz1,p2,pz2)
c
c    we have a 1-d array, listf, of platelets divided into
c    categories;  the number listf(j) gives the index of
c    the next platelet of listf in the same category as j
c    or if listf(j)=0, then j is the last platelet in this
c    category.  we also have a 1-d array, listb, which lists
c    the same categories as listf but with the ordering
c    within each category reversed compared with listf
c    this routine allows us to change a platelet from one
c    category to another
c    note:  the index j corresponds to platelet number j
c    in both lists
c
c     listf is the forward list described
c     listb is the reverse ordered list
c     i is the platelet whose category is to change;
c    p1 and pz1 are the initial and final pointers
c    respectively for the category i is in; and p2 is the
c    initial pointer for the category it will be placed in.
c    note:  initial and final are relative to listf, reverse
c    these for listb
c
      integer   i,pz2,p1,p2,pz1,listf,listb
      dimension listf(1),listb(1)
c
c   check if i is the only platelet in category 1
c
      if(listf(i).eq.(0).and.listb(i).eq.(0))go to 18
c
c     check if i is the last platelet in category 1
c
      if(listf(i).eq.0)go to 10
c
c   check if i is beginning of category 1
c
      if(listb(i).eq.0) go to 15
c
c    if none of these, then delete i from category 1
c   put contents of listf(i) in box whose address is listf(i)
c
      listf(listb(i))=listf(i)
c
c    change listb to reflect deletion of i from category 1
c    put contents of listb(i) in position in listb that had
c    address listb(i), namely that with index listf(listb(i))
c
c    listb(listf(listb(i)))=listb(i)
      listb(listf(i))=listb(i)
      go to 25
c
c    i is the last element in category 1; so need to move end
c    pointer to location which had address i and to put a zero
c    there;  on listb the ith element is just ignored
c
   10 continue
      listf(listb(i))=0
      pz1=listb(i)
      go to 25
c
c    i is first element in category 1, move pointer to 2nd
c    element, set listb element corresponding to this second
c    element to zero
c
   15 continue
      p1=listf(i)
      listb(listf(i))=0
      go to 25
c
c    i is the only element in category 1
c
   18 continue
      p1=0
      pz1=0
c
   25 continue
c
c   now add i to beginning of category 2 in listf;
c
      listb(i)=0
      if(p2.gt.0)go to 30
      pz2=i
      go to 33
   30 listb(p2)=i
   33 listf(i)=p2
      p2=i
      return
      end
c
      subroutine chgcate(listf,listb,i,p1,pz1,p2,pz2)
c
c    we have a 1-d array, listf, of platelets divided into
c    categories;  the number listf(j) gives the index of
c    the next platelet of listf in the same category as j
c    or if listf(j)=0, then j is the last platelet in this
c    category.  we also have a 1-d array, listb, which lists
c    the same categories as listf but with the ordering
c    within each category reversed compared with listf
c    this routine allows us to change a platelet from one
c    category to another
c    note:  the index j corresponds to platelet number j
c    in both lists
c
c     listf is the forward list described
c     listb is the reverse ordered list
c     i is the platelet whose category is to change;
c     p1 and pz1 are the initial and final pointers
c    respectively for the category i is in; and pz2 is the
c    final pointer for the category it will be placed in.
c    note:  initial and final are relative to listf, reverse
c    these for listb
c
      integer   i,pz2,p1,p2,pz1,listf,listb
      dimension listf(1),listb(1)
c
c   check if i is the only platelet in category 1
c
      if(listf(i).eq.(0).and.listb(i).eq.(0))go to 18
c
c     check if i is the last platelet in category 1
c
      if(listf(i).eq.0)go to 10
c
c   check if i is beginning of category 1
c
      if(listb(i).eq.0) go to 15
c
c    if none of these, then delete i from category 1
c   put contents of listf(i) in box whose address is listf(i)
c
      listf(listb(i))=listf(i)
c
c    change listb to reflect deletion of i from category 1
c    put contents of listb(i) in position in listb that had
c    address listb(i), namely that with index listf(listb(i))
c
c    listb(listf(listb(i)))=listb(i)
      listb(listf(i))=listb(i)
      go to 25
c
c    i is the last element in category 1; so need to move end
c    pointer to location which had address i and to put a zero
c    there;  on listb the ith element is just ignored
c
   10 continue
      listf(listb(i))=0
      pz1=listb(i)
      go to 25
c
c    i is first element in category 1, move pointer to 2nd
c    element, set listb element corresponding to this second
c    element to zero
c
   15 continue
      p1=listf(i)
      listb(listf(i))=0
      go to 25
c
c    i is the only platelet in category 1
c
   18 continue
      p1=0
      pz1=0
c
c   now add i to end of category 2 in listf; put address i at old end
c   put 0 at address i in listf; begin listb category 2 at i,
c   and put address of old beginning in location i in listb
c
   25 continue
      listf(i)=0
      if(pz2.gt.0) go to 30
      p2=i
      go to 33
   30 listf(pz2)=i
   33 listb(i)=pz2
      pz2=i
      return
      end
c
      subroutine map
c
c this subroutine constructs a map and inverse map
c from the list of indices of entities present in
c the domain to the numbers 1,2,3,...,nent.
c
c it maps the beginning and ending pointers (firstb,lastb) for xb
c to arrays (first,last) which are pointers for the arrays (x,y)
c
c it maps the coordinates of entities present from xb to (x,y)
c
c it maps the entity stiffnesses (sb,swb) and bending angles (csb)
c to arrays (s,sw) and (cs) respectively based on the map
c
c it constructs arrays n1,n2,stiff from the linked-list information
c on interentity links
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'links.inc'
c
c  local variables
c
      integer i,icnt,ient,j,jcnt,lcnt,nfst
      integer nst,nstb,num,npt
c
      icnt=0
      nfst=1
      do 10 ient=1,ment
         if(categor(ient).ne.0)then
            icnt=icnt+1
            pmap   (icnt)=ient
            invpmap(ient)=icnt
            first(icnt)  =nfst
            last (icnt)  =nfst+(lastb(ient)-firstb(ient))
            cat(icnt)    =categor(ient)
            nfst         =last(icnt)+1
         endif
 10   continue
c
c check that at end icnt = nent
c
      if(icnt.ne.nent)then
          write(6,*)' MAP  icnt=',icnt,' nent=',nent
          stop
      endif
c
c map coordinates
c
      do 20 j=1,nent
         ient=pmap(j)
         num =lastb(ient)-firstb(ient)+1
         nstb=firstb(ient)-1
         nst =first (j)-1
         do 15 i=1,num
            npt = nstb+i
            xpt (nst+i) = xb((2*npt)-1)
            ypt (nst+i) = xb(2*npt)
            xt  (nst+i) = xteth(npt)
            yt  (nst+i) = yteth(npt)
            dl  (nst+i) = dlp(npt)
            sw  (nst+i) = swp(npt)
            cs  (nst+i) = csp(npt)
            s   (nst+i) = sp (npt)
            sth (nst+i) = sthp(npt)
 15      continue
 20   continue
c
c map link information, construct n1,n2,stiff
c
c sweep through linked-list of links
c
      lcnt = lkl
      jcnt=0
 25   continue
        if(lcnt.eq.0)goto 30
          jcnt=jcnt+1
          n1(jcnt)    = first(invpmap(p1(lcnt)))+r1(lcnt)
          n2(jcnt)    = first(invpmap(p2(lcnt)))+r2(lcnt)
          lent1(jcnt) = p1(lcnt)
          lent2(jcnt) = p2(lcnt)
          rl1  (jcnt) = r1(lcnt)
          rl2  (jcnt) = r2(lcnt)
          stiff(jcnt) = stiffb(lcnt)
          rest (jcnt) = restb (lcnt)
          lcnt        = listlkf(lcnt)
        goto 25
 30   continue
c
      return
      end
c
      subroutine revmap
c
c this subroutine puts the coordinates (x,y) into the 
c proper place in the array xb
c
c  global include
c
      implicit none
      include 'ibp.inc'
c
c  local variables
c
      integer i,ient,j,nst,nstb,num
c
c map coordinates
c
      do j=1,nent
         ient=pmap(j)
         num =lastb(ient)-firstb(ient)+1
         nstb=firstb(ient)-1
         nst =first (j)-1
         do i=1,num
            xb(2*(nstb+i)-1) = xpt(nst+i)
            xb(2*(nstb+i)  ) = ypt(nst+i)
            usb1(nstb+i)     = us1(nst+i)
            usb2(nstb+i)     = us2(nst+i)
            gfrcb1(nstb+i)   = gfrc1(nst+i)
            gfrcb2(nstb+i)   = gfrc2(nst+i)
         enddo
      enddo
      return
      end
c
c------------------------------------------------------------------
c
      subroutine addmap(xpt,ypt,n,xadd,yadd,nadd,kpt)
c
c this subroutine puts the coordinates (x,y) into the proper place
c in the array xb
c
      implicit none
c
c  global variables
c
      integer n,nadd,kpt
      double precision xadd(nadd),yadd(nadd)
      double precision xpt(n),ypt(n)
c
c  local variables
c
      integer i
c
c map coordinates
c
      do i= 1, nadd
         xpt(kpt+i) = xadd(i)
         ypt(kpt+i) = yadd(i)
      enddo
      return
      end
c
c------------------------------------------------------------------
c
      subroutine delmap(xpt,ypt,n,xdel,ydel,ndel,kpt)
c
c this subroutine replaces the coordinates mapped by addmap
c
c  global include
c
      implicit none
c
c  global variables
c
      integer n,ndel,kpt
      double precision xdel(ndel),ydel(ndel)
      double precision xpt(n),ypt(n)
c
c  local variables
c
      integer i
c
c map coordinates
c
      do i= 1, ndel
         xdel(i) = xpt(kpt+i)
         ydel(i) = ypt(kpt+i)
      enddo
      return
      end
c
c------------------------------------------------------------------
c
      subroutine period(nxp2,nyp1,ph)
c
c extend ph periodically
c global include
c
      implicit none
c
      integer nxp2,nyp1
      double precision ph(0:nxp2,0:nyp1)
c
c  local variables
c
      integer i,j,nx,ny
c
      nx = nxp2-2
      ny = nyp1-1
c
      do 100 i=1,nx
         ph(i,0) = ph(i,ny)
         ph(i,nyp1) = ph(i,1)
 100  continue
      do 120 j=1,ny
         ph(0,j) = ph(nx,j)
         ph(nx+1,j) = ph(1,j)
 120  continue
c
c extend for corner points also
c
      ph(0    ,0   ) = ph(nx,ny)
      ph(nx+1 ,0   ) = ph( 1,ny)
      ph(0    ,nyp1) = ph(nx, 1)
      ph(nx+1 ,nyp1) = ph( 1, 1)
c
      return
      end
