c
      subroutine init(nxp2,nyp1,f,u,sinsq,bzero,sfluid,a,z,rsf,
     x    mlink,mlkpt,mpts,mwhere,np,npdx,npdy,nring,nxx,nyy)

c  Modified initialization routine for Fogelsons code
c   incorporates output from little language
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'domain.inc'
      include 'fluid.inc'
      include 'graph.inc'
      include 'links.inc'
      include 'plat.inc'
      include 'active.inc'
c
c  global variables
c
      integer rsf,nxp2,nyp1,np,npdx,npdy,nring,nxx,nyy
      integer mlink,mlkpt,mpts,mwhere,nx,ny
      double precision sfluid(3),a
      double precision bzero(0:nxp2,0:nyp1)
      double precision f(0:nxp2,0:nyp1,1:2)
      double precision u(0:nxp2,0:nyp1,1:2)
      double precision z(0:nxp2,0:nyp1)
      double precision sinsq(0:nxp2,0:nyp1)
c
c  local variables
c
      character*100 type
      integer i,j,jpt,k,knp,listp,inp,inext,rsflag
      integer kk,jl,lk1,lk2,nl,lkmin,lkmax,ltype,getnum
      double precision ang,pi,stf,brk,rst
      double precision si,sj,tpvnx,tpvny,yy
c
c  initialize the namelist
c
      namelist /IBPTS/ rsflag,
     x    colorf,linef,fluidf,ibptsf,linkf,partf,
     x    xmin,xmax,ymin,ymax,dlt,h,mu,ro,umax,fbpx,fbpy,
     x    ntstart,ntmax,time,
     x    ccount,cfreq,lcount,lfreq,ivdens,usave,fsave,
     x    ipbx,ipby,ibtube,ittube,btubil,btubir,ttubil,ttubir,
     x    pwalk,iplat,maxlink,pltdif,pdens,scoh,scgap,
     x    sadh,sagap,sbreaka,sbreakc,stiffa,stiffc,rlinkc,
     x    rlinka

c
c  global velocity info
c
      data vmax, vmaxg / 0.d0, 0.d0 /
      data vimax, vimaxg / 0.d0, 0.d0 /
      data fmax, fmaxg / 0.d0, 0.d0 /
      data fimax, fimaxg / 0.d0, 0.d0 /
c
c  data from the ibis parser
c
      open (12,file='ibisdat/init.dat',status='old')
      read(12,IBPTS)
      close(12)
      rsf = rsflag

c
c  retrieve the domain information
c
      nx = nxp2-2
      ny = nyp1-1
      xlength = xmax - xmin
      ylength = ymax - ymin
      ycent   = ylength/2.0d0
c
c  compute grid information  -- CHECK ON ITUBE
c
      dlibp   = h/2
      ytop    = h*ittube
      ybot    = h*ibtube
c
c  get the fluid information
c
      if ( umax.ne.0.0 .and. rsf.eq.0 )  umax0 = 1
c
c typical platelet dimensions
c
      pi     = 4.D+00*datan(1.D+00)
      ang    = 2.D+00*pi/dble(nring)
      if (nring.gt.1) then
        diam = dlibp/dsin(.5D+00*ang)
      else
        diam = 1.0d0
      endif
c
c  rescale adhesion and cohesion data
c
      scoh    = scoh*diam
      scgap   = scgap*diam
      sadh    = sadh*diam
      sagap   = sagap*diam
      sbreaka = sbreaka*dlibp
      sbreakc = sbreakc*dlibp
      stiffa  = stiffa/dlibp
      stiffc  = stiffc/dlibp
c
c x portion of injured walls
c   xadhmin - minimum x injury location >= zero
c   xadhmin - maximum x injury location
c
      xadhmax = max(btubir,ttubir)*h
      if (btubil.gt.0 .and. ttubil.eq.0 ) then
        xadhmin = btubil*h
      elseif (btubil.eq.0 .and. ttubil.gt.0 ) then
        xadhmin = ttubil*h
      else
        xadhmax = min(btubil,ttubil)*h
      endif
c
c  load the tube injury locations
c
      afirstb(1) = btubil
      alastb(1) = btubir
      afirstb(2) = ttubil
      alastb(2) = ttubir
c
c number of entities
c
      open (100,file=ibptsf,status='unknown')
      read (100,*) jfil,jplat,jpoly,nlinke
      nent = jplat + jfil + jpoly
c
c filaments first, pointers into xb and spring information
c
      jpt = 0
      if (jfil .gt. 0) then
        pf  = 1
        pzf = jfil
        do 30, j = pf, pzf
          knp        = 0
          listb(j)   = j - 1
          listf(j)   = j + 1
          firstb(j)  = jpt + 1
          activ3(j)  = jpt + 1
          read(100,1000) type
          read(100,*) inp, iclose(j), categor(j), 
     x         activ1(j), activ2(j),
     x         xcm(j), ycm(j)
          xcm(j) = xcm(j) - xmin
          ycm(j) = ycm(j) - ymin
 20       continue
            jpt      = jpt + 1
            knp      = knp + 1
            read (100,*) inext, xb(2*jpt-1), xb(2*jpt),
     x                   xteth(jpt),  yteth(jpt),
     x                   dlp(jpt),    swp(jpt),
     x                   csp(jpt),    sp(jpt),
     x                   sthp(jpt)
            xb(2*jpt-1) = xb(2*jpt-1) - xmin
            xb(2*jpt) = xb(2*jpt) - ymin
            xteth(jpt) = xteth(jpt) - xmin
            yteth(jpt) = yteth(jpt) - ymin
            if ( inext.eq.1 ) goto 20
 25       continue
          if ( knp.ne.inp ) then
            write (6,*)
     x       'Filament point count does not match number of points'
          endif
          lastb(j)   = jpt
          activ4(j) = jpt
 30     continue
        listf(pzf)  =  0
      else
        pf  = 0
        pzf = 0
      endif
c
c polygon pointers
c  polygon links list parameters, pointers into xb
c   and spring information
c
      knp = 0
      if (jpoly .gt. 0) then
        pg  = jfil + 1
        pzg = pg + jpoly - 1
        listp = pzg
c 
c compute polygons positions
c
        do 45, j = pg, pzg
          knp        = 0
          listb(j)   = j - 1
          listf(j)   = j + 1
          firstb(j)  = jpt + 1
          centx(j)   = 0.0d0
          centy(j)   = 0.0d0
          activ3(j) = jpt+1
          read(100,1000) type
          read(100,*) inp, iclose(j), categor(j), 
     x         activ1(j), activ2(j), 
     x         xcm(j), ycm(j)
          xcm(j) = xcm(j) - xmin
          ycm(j) = ycm(j) - ymin
 35       continue
            jpt      = jpt + 1
            knp      = knp + 1
            read (100,*) inext, xb(2*jpt-1), xb(2*jpt),
     x                   xteth(jpt),  yteth(jpt),
     x                   dlp(jpt),    swp(jpt),
     x                   csp(jpt),    sp(jpt),
     x                   sthp(jpt)
            xb(2*jpt-1) = xb(2*jpt-1) - xmin
            xb(2*jpt) = xb(2*jpt) - ymin
            xteth(jpt) = xteth(jpt) - xmin
            yteth(jpt) = yteth(jpt) - ymin
            centx(j) = centx(j) + xb(2*jpt-1)
            centy(j) = centy(j) + xb(2*jpt)
            if ( inext.eq.1 ) goto 35
 40       continue
          if ( knp.ne.inp ) write (6,*)
     x       'Polygon point count does not match number of points'
c
c Finish the list data for polygons
c    centers are center of mass
c
          lastb(j)   = jpt
          activ4(j) = jpt
          centx(j)   = centx(j)/dble(knp)
          centy(j)   = centy(j)/dble(knp)
 45     continue
        listb(pg)  = 0
        listf(pzg) = 0
      else
        pg   = 0
        pzg  = 0
        listp = pzf
      endif
c
c activated platelet pointers - currently all platelets
c    links list parameters and pointers into xb
c
      if (jplat .gt. 0) then
        pac  = listp + 1
        pzac = pac + jplat - 1
        do 60 j=pac,pzac
          knp        = 0
          listb(j)   = j - 1
          listf(j)   = j + 1
          firstb(j)  = jpt + 1
          activ3(j) = jpt + 1
          read(100,1000) type
          read(100,*) inp, iclose(j), categor(j), 
     x         activ1(j), activ2(j), 
     x         xcm(j), ycm(j)
          xcm(j) = xcm(j) - xmin
          ycm(j) = ycm(j) - ymin
c
c  put in the immersed boundary points with spring info
c
 50       continue
            knp  = knp + 1
            jpt  = jpt + 1
            read (100,*) inext, xb(2*jpt-1), xb(2*jpt),
     x                   xteth(jpt),  yteth(jpt),
     x                   dlp(jpt),    swp(jpt),
     x                   csp(jpt),    sp(jpt),
     x                   sthp(jpt)
            xb(2*jpt-1) = xb(2*jpt-1) - xmin
            xb(2*jpt) = xb(2*jpt) - ymin
            xteth(jpt) = xteth(jpt) - xmin
            yteth(jpt) = yteth(jpt) - ymin
            if ( inext.eq.1 ) goto 50
 55       continue
          if ( knp.ne.inp ) then

            write (6,*)
     x       'Circle point count does not match number of points'
          endif
          lastb(j)   = jpt
          activ4(j) = jpt
          centx(j)   = xcm(j)
          centy(j)   = ycm(j)
 60     continue
        listb(pac)  = 0
        listf(pzac) = 0
      else
        pac  = 0
        pzac = 0
      endif
c
c unactivated platelet pointers - currently none
c
      pua  = 0
      pzua = 0
c
c linked platelet pointers - currently none
c
      pl   = 0
      pzl  = 0
c
c available space pointers and link list parameters
c
      pas  = nent+1
      pzas = ment
      do 65, j = pas, ment
        listf(j)   = j+1
        listb(j)   = j-1
        categor(j) = 0
        firstb(j)  = max0(lastb(j-1)+1,1)
        lastb (j)  = firstb(j)+(nring-1)
 65   continue
      listf(ment) = 0
      listb(pas)  = 0
      npts = jpt
c
      close (100)
c
c initialize link structure
c
      do j = 1, mpts
         status(j) = 0
      enddo
      do j = 1, mwhere
         numlink(j)=0
      enddo
c
      kk = 0
      k = 1
      if ( linkf(1:4) .ne. 'null' ) then
c
        open (12,file=linkf,status='old')
        if ( rsf .eq. 0 ) then
          do j = 1, nlinke
            read (12,*) lk1,lk2,nl,stf,brk,rst,ltype
            do jl = 1, nl
              listlkf(k) = k+1
              listlkb(k) = k-1
              k = k+1
            enddo
            lkmin = min0(getnum(lk1),getnum(lk2))
            lkmax = max0(getnum(lk1),getnum(lk2))
            if ( ltype .eq. 1 ) then
              call join (lkmin,lkmax,nl,stf,brk,rst,kk,mpts)
            elseif ( ltype .eq. 2 ) then
              call connect (lkmin,lkmax,nl,stf,brk,rst,kk)
            elseif ( ltype .eq. 3 ) then
              call spoke (getnum(lk1),getnum(lk2),nl,stf,brk,rst,kk)
            elseif ( ltype .ge. 4 ) then
              call bridge (lkmin,lkmax,nl,stf,brk,rst,kk,ltype)
            endif
          enddo
          listlkf(k) = 0
          listlkb(1) = 0
          nlink = kk
        elseif ( rsf .eq. 1 ) then
          read (12,*) nlink
          do j = 1, nlink
            read (12,*) q1(j),q2(j),p1(j),p2(j),
     x         r1(j),r2(j),stiffb(j),sbreak(j),restb(j)
            listlkf(j) = j+1
            listlkb(j) = j-1
            status(firstb(p1(j))+r1(j)) = 1
            status(firstb(p2(j))+r2(j)) = 1
            lcat(j) = 1
          enddo
          listlkf(k) = 0
          listlkb(1) = 0
        endif
c
        close(12)

      endif
c
      lkl   = min0(1,nlink)
      lkzl  = nlink
      lkas  = nlink+1
      lkzas = mlink
c
      do j = lkas, mlink
        listlkf(j) = j+1
        listlkb(j) = j-1
        lcat(j) = 0
        p1(j) = 0
        p2(j) = 0
        r1(j) = 0
        r2(j) = 0
        stiffb(j) = 0.0D+00
        restb (j) = 0.0D+00
        sbreak(j) = 0.0D+00
      enddo
      listlkf(mlink) = 0
      listlkb(lkas ) = 0
c
c  wall bound aggregate links
c  
      nas=1
      nzas=mlkpt
      do j=1,ment
         fstlnk(j)=0
         lstlnk(j)=0
      enddo
      do j=1,mlkpt
         nxtlnkf(j)=j+1
         nxtlnkb(j)=j-1
         pltlnk (j)=0
      enddo
      nxtlnkf(nzas)=0
      nxtlnkb(nas )=0
c
c  define parameters for energy minimization
c  
      lam=9.D+00/64.D+00 *(dlt**2)*dlibp/(h*h) *2.0D+00
c
c  Flow initialization stuff
c  trig functions for fft2d
c
      tpvnx=2.D+00*pi/dble(nx)
      tpvny=2.D+00*pi/dble(ny)
      do i=1,nx
        si=(dsin(tpvnx*(i-1)))**2
        do j=1,ny
          sj=(dsin(tpvny*(j-1)))**2
          sinsq(i,j)=-(4.D+00*(si+sj))
          bzero(i,j)=0.D+00
        enddo
      enddo
      sinsq(1,1)=1.D+00
      sinsq(1,ny/2+1)=1.D+00
      sinsq(nx/2+1,1)=1.D+00
      sinsq(nx/2 +1,ny/2+1)=1.D+00
c
c navier-stokes parameters
c
      sfluid(1)=dlt/(2*h)
      sfluid(2)=mu*dlt/(h*h)
      sfluid(3)=1.D+00/(2*h)
      a=ro+2*sfluid(2)
c
c initialize the pressure and velocity fields
c
      do j=1,nyp1
        do i=1,nxp2
          z(i,j)=0.D+00
        enddo
      enddo
c
      do k = 1, 2
        do j = 0, nyp1
          do i = 0, nxp2
            u(i,j,k)=0.0D+00
          enddo
        enddo
      enddo
c
c if starting with zero flow, skip this!
c
      fluxx=0.0D+00
      if (umax0.gt.0) then
        do 350 i = 1, nx
           do 340 j = ibtube, ittube
             yy       = (4.D+00*dble(j)*h/ylength - 2.D+00)
             u(i,j,1) = umax*(1.0D+00 - yy**2)
 340       continue
           u(i,0,1) = u(i,ny,1)
 350    continue
        do 360 j = 0, ny
          u(0,j,1) = u(nx,j,1)
          u(0,j,2) = u(nx,j,2)
 360    continue
      endif
c
c if fluid file provided, then read it
c
      if ( fluidf(1:4) .ne. 'null' ) then
        open (12, file=fluidf, status='old')
        do j = 1, ny
          do i = 1, nx
            read(12,*) u(i,j,1), u(i,j,2)
          enddo
        enddo
        close (12)
      endif
c
c compute maximum speed
c
      do j = 1, ny
        fluxx=fluxx + h*u(2,j,1)
        do i = 0, nx
           vmax = max(vmax,sqrt(u(i,j,1)**2 + u(i,j,2)**2))
        enddo
      enddo
c
c initialize background force density for poisuelle flow
c
      do 410 j=1,ibtube-1
        do 410 i=0,nx
          f(i,j,1)=0.0d0
          f(i,j,2)=0.0d0
 410  continue
      do 420 j=ibtube, ittube
        do 420 i=0,nx
          f(i,j,1)= fbpx
          f(i,j,2)= fbpy
 420  continue
      do 430 j=ittube+1,ny
        do 430 i=0,nx
          f(i,j,1)=0.0d0
          f(i,j,2)=0.0d0
 430  continue
c
c  graphics initialization
c
      i = 0
      if (npdx .eq. 0) then
        npx = nxx
      else
        npx = (nxx+1)/npdx
      endif
      if (npdy .eq. 0) then
        npy = nyy
      else
        npy = (nyy+1)/npdy
      endif
      pdx = xlength/dble(npx)
      pdy = ylength/dble(npy)
      nactm = 0
      if ( partf(1:4) .ne. 'null' ) then
        open (12,file=partf,status='old')
 490    continue
          i = i + 1
          read (12,*,end=500) px(i), py(i), pmark(i)
          px(i) = px(i) - xmin
          py(i) = py(i) - ymin
          nactm = nactm+1
          goto 490
 500    continue
        close (12)
      else
        do j = 1, npx
          do k = 1, npy
            i = i + 1
            px(i) = (dble(j)-0.5d0)*pdx
            py(i) = (dble(k)-0.5d0)*pdy
            pmark(i) = 2
            nactm = nactm+1
          enddo
        enddo
      endif
      do k = i, np
        px(k) = xlength/2.0d0
        py(k) = ylength/2.0d0
        pmark(k) = 0
      enddo
      dx = xlength/dble(nxx)
      dy = ylength/dble(nyy)

      do k = 1, 16
        icolr(k) = k-1
      enddo
      do k = 1, ment
        icoli(k) = mod(k-1,223)+32
      enddo
c
c  report some results
c
      write(6,*)' '
      write(6,*)' *** COMPUTATIONAL DOMAIN DATA *** '
      write(6,*)' *** xmin *** ',xmin
      write(6,*)' *** xmax *** ',xmax
      write(6,*)' *** ymin *** ',ymin
      write(6,*)' *** ymax *** ',ymax
      write(6,*)' *** delta t *** ',dlt
      write(6,*)' *** timesteps *** ',ntmax
      write(6,*)' *** end time *** ', ntmax*dlt
      write(6,*)' *** delta x_grid *** ', h
      write(6,*)' *** grid points *** ', nx, ny
      write(6,*)' '
      write(6,*)' *** IMMERSED BOUNDARY POINTS *** '
      write(6,*)' *** number of entities *** ', nent
      write(6,*)' *** number of points *** ', npts
      write(6,*)' '
      write(6,*)' *** FLUID DATA *** '
      write(6,*)' *** Umax *** ', umax
      write(6,*)' *** mu *** ', mu
      write(6,*)' *** rho *** ', ro
      write(6,*)' '
      write(6,*)' *** GRAPHICS DATA *** '
      write(6,*)' *** color plot size *** = ', nxx, nyy
      write(6,*)' *** color plot frequency *** = ', cfreq
      write(6,*)' *** line plot frequency *** = ', lfreq
      write(6,*)' '
c
c  platelet data
c
      if (iplat .eq. 1) then
        write(6,*)' '
        write(6,*)' *** INTER-ENTITY LINK DATA *** '
        write(6,*)' *** max number of links *** =', maxlink
        write(6,*)' *** plat-plat link strength *** =', stiffa
        write(6,*)' *** plat-wall link strength *** =', stiffc
        write(6,*)' *** adhesive link rest length *** =',rlinka
        write(6,*)' *** cohesive link rest length *** =',rlinkc
        write(6,*)' *** adhesive link break length *** =',sbreaka
        write(6,*)' *** cohesive link break length *** =',sbreakc
        write(6,*)' *** center of mass cohere length *** =',scoh
        write(6,*)' *** center of mass adhere length *** =',sadh
        write(6,*)' *** ib point dist cohere length *** =',scgap
        write(6,*)' *** ib point dist adhere length *** =',sagap
        write(6,*)' '
        write(6,*)' *** PLATELET DATA *** '
        write(6,*)' *** points on a ring *** = ',nring
        write(6,*)' *** walk length parameter *** = ',pltdif
        write(6,*)' *** platelet density *** = ', pdens
      endif
c
      return
 1008 format(7(1x,e15.7))
 1000 format (a4)
      end
c
      subroutine join(ient,jent,nl,stf,brk,rstl,kk,mpts)
c
c This subroutine forms nl links between entity ient and
c entity jent.  It creates at most one link per immersed
c boundary point.
c
c  global include
c
      implicit none
c
c     global common variables
c
      include 'domain.inc'
      include 'graph.inc'
      include 'ibp.inc'
      include 'links.inc'
c
c  global variables
c
      integer ient,jent,nl,kk,qm1,qm2,mpts
      double precision stf,brk,rstl
c
c  local variables
c
      integer ic,imin,jc,jmin,nc,nwhere
      double precision dist,sdist,smin
c
      do 10, ic = 1, mpts
        stat1(ic) = 0
 10   continue
      do 20, ic = 1, mpts
        stat2(ic) = 0
 20   continue
c
c Form the links.  Check to see the points are non-linked or 
c linked.  From the unlinked points on the two entities, find 
c the closest pair, one on each entity.  Link that pair.
c
      nwhere = ((ient-2)*(ient-1))/2 + jent
      numlink(nwhere) = nl
      do 80, nc = 1, nl
        imin=0
        jmin=0
        smin=1000.D+00
        do 60 ic=firstb(ient),lastb(ient)
          if ( stat1(ic).eq.0 ) then
            do 40 jc=firstb(jent),lastb(jent)
              if ( stat2(jc).eq.0 ) then
                sdist = dist(xb(2*ic-1),xb(2*ic),
     x                       xb(2*jc-1),xb(2*jc))
                if(sdist.lt.smin)then
                  smin = sdist
                  imin = ic - firstb(ient)
                  jmin = jc - firstb(jent)
                  qm1  = ic
                  qm2  = jc
                endif
              endif
 40         continue
          endif
 60     continue
c
c Form link between point imin on ient and point jmin on jent
c
        kk = kk + 1
        p1(kk) = ient
        r1(kk) = imin
        q1(kk) = qm1
        p2(kk) = jent
        r2(kk) = jmin
        q2(kk) = qm2
        stat1(qm1) = qm2
        stat2(qm2) = qm1
        stiffb(kk) = stf
        sbreak(kk) = brk*h
        restb (kk) = rstl*h
        lcat(kk) = 1
        status(firstb(ient)+imin) = 1
        status(firstb(jent)+jmin) = 1
 80   continue
c
      return
      end
c
      subroutine bridge(ient,jent,nl,stf,brk,rstl,kk,type)
c
c This subroutine forms a bridge work of links between 
c entity ient and entity jent.  It creates three links per 
c immersed boundary point.
c
c  global include
c
      implicit none
c
c     global common variables
c
      include 'domain.inc'
      include 'graph.inc'
      include 'ibp.inc'
      include 'links.inc'
c
c  global variables
c
      integer ient,jent,nl,kk,type
      double precision stf,brk,rstl
c
c  local variables
c
      integer ic,jc,nc,nwhere,incl,incr,inc,nloop
      double precision dist
c
c Form the 3 links from every point on ient to jent.
c Links are formed sequentially.
c
      nwhere = ((ient-2)*(ient-1))/2 + jent
      numlink(nwhere) = nl
c
      nloop = lastb(jent)-firstb(jent)
c
      do nc = 0, nloop
c
        ic = firstb(ient) + nc
c
c  if its not a closed structure handle it differently
c
        incl = -1
        incr = 1
        if (nc.eq.0 .and. type.gt.4) then
           incl = 0
           incr = 1
        elseif (nc.eq.nloop .and. type.gt.4) then
           incl = -1
           incr = 0
        endif        
c
c Create three links at every interior point by forming
c links between nearest points and next nearest points
c
        do inc = incl,incr
          jc = firstb(jent) + nc + inc
          if ( jc .lt. firstb(jent) ) jc = lastb(jent)
          if ( jc .gt. lastb(jent) ) jc = firstb(jent)
          kk = kk + 1
          p1(kk) = ient
          r1(kk) = ic - firstb(ient)
          q1(kk) = ic
          p2(kk) = jent
          r2(kk) = jc - firstb(jent)
          q2(kk) = jc
          lcat(kk) = 1
          stiffb(kk) = stf
          sbreak(kk) = brk*h
          restb (kk) = dist(xb(2*ic-1),xb(2*ic),
     x                       xb(2*jc-1),xb(2*jc))*rstl
        enddo
      enddo
c
      return
      end
c
      subroutine spoke(ient,jent,nl,stf,brk,rstl,kk)
c
c This subroutine forms a spoke work of links between 
c entity ient and entity jent.  Entity ient is assumed
c to have one immersed boundary point, and this routine
c creates one link for every immersed boundary point
c in entity jent
c
c  global include
c
      implicit none
c
c     global common variables
c
      include 'domain.inc'
      include 'graph.inc'
      include 'ibp.inc'
      include 'links.inc'
c
c  global variables
c
      integer ient,jent,nl,kk
      double precision stf,brk,rstl
c
c  local variables
c
      integer ic,jc,nc,nwhere
      double precision dist
c
      nwhere = ((ient-2)*(ient-1))/2 + jent
      numlink(nwhere) = nl
      ic = firstb(ient)
c
c Create one link at every point on jent
c
      do nc = 0, lastb(jent)-firstb(jent)

        jc = firstb(jent) + nc
        kk = kk + 1
        p1(kk) = ient
        r1(kk) = 0
        q1(kk) = ic
        p2(kk) = jent
        r2(kk) = jc - firstb(jent)
        q2(kk) = jc
        stiffb(kk) = stf
        sbreak(kk) = brk*h
        restb (kk) = dist(xb(2*ic-1),xb(2*ic),
     x                    xb(2*jc-1),xb(2*jc))*rstl
        lcat(kk) = 1

      enddo
c
      return
      end
c
      subroutine connect(ient,jent,nl,stf,brk,rstl,kk)
c
c This subroutine forms a one to one connection of links between 
c entity ient and entity jent.  It creates one link per 
c immersed boundary point.
c
      implicit none
c
c     global common variables
c
      include 'domain.inc'
      include 'graph.inc'
      include 'ibp.inc'
      include 'links.inc'
c
c  global variables
c
      integer ient,jent,nl,kk
      double precision stf,brk,rstl
c
c  local variables
c
      integer ic,jc,nc,nwhere,nloop
      double precision dist
c
c Form the 3 links from every point on ient to jent.
c Links are formed sequentially.
c
      nwhere = ((ient-2)*(ient-1))/2 + jent
      numlink(nwhere) = nl
c
      nloop = lastb(jent)-firstb(jent)
c
c Create one link at immersed boundry points
c
      do nc = 0, nloop
c
        ic = firstb(ient) + nc
c
c Form links between nearest points and next nearest points
c
        jc = firstb(jent) + nc
        kk = kk + 1
        p1(kk) = ient
        r1(kk) = ic - firstb(ient)
        q1(kk) = ic
        p2(kk) = jent
        r2(kk) = jc - firstb(jent)
        q2(kk) = jc
        stiffb(kk) = stf
        sbreak(kk) = brk*h
        restb (kk) = dist(xb(2*ic-1),xb(2*ic),
     x                    xb(2*jc-1),xb(2*jc))*rstl
        lcat(kk) = 1

      enddo
c
      return
      end
c
c
      integer function getnum(name)
c
c   given the name of an entity, return its number
c
      include 'ibp.inc'
c
      integer i,name
c
      do i = 1, ment
        if (activ2(i).eq.name) then
          getnum=i
          return
        endif
      enddo
c
      return
      end
