c
      subroutine navs (nxp2,nyp1,u,f,p,psi,
     *        bzero,sinsq,z,
     *        b,c,r,work1,work2,yh,yp,
     *        a,dlt,h,ro,sfluid)
c
      implicit none
c
      integer nxp2, nyp1
      double precision a,dlt,h,ro,sfluid(3)
c
      double precision u(0:nxp2,0:nyp1,1:2)
      double precision f(0:nxp2,0:nyp1,1:2)
      double precision p(0:nxp2,0:nyp1)
      double precision psi(0:nxp2,0:nyp1)
c
      double precision bzero(0:nxp2,0:nyp1)
      double precision sinsq(0:nxp2,0:nyp1)
      double precision z(0:nxp2,0:nyp1)
c
      double precision b(0:nxp2,0:nyp1)
      double precision c(0:nxp2,0:nyp1)
      double precision r(0:nxp2,0:nyp1)
      double precision work1(0:nxp2,0:nyp1)
      double precision work2(0:nxp2,0:nyp1)
      double precision yh(0:nxp2,0:nyp1)
      double precision yp(0:nxp2,0:nyp1)
c
      double precision lamx(1)
      common /xlam/ lamx

      double precision lamy(1)
      common /ylam/ lamy
c
c  local variables
c
      integer i,j,nc,nx,ny,nxp1
      double precision pro,xl,yl
c
      nx = nxp2-2
      ny = nyp1-1
      nxp1 = nxp2-1
c
      do i=1,nx
        z(i,1   )=0.0D+00
        z(i,ny-1)=0.0D+00
      enddo
c
      do j=1,ny
        do i=0,nxp2
          bzero(i,j)=0.0D+00
        enddo
      enddo
c
c for each fixed y-value, we solve a periodic system
c of linear equations which will give us the first
c fractional step solution.
c
      do nc=1,2
c
        do j=1,ny
          do i=1,nx
            pro=ro*u(i,j,1)*sfluid(1)
            c(i,j)=-pro - sfluid(2)
            b(i,j)= pro - sfluid(2)
            r(i,j)= ro*u(i,j,nc)+dlt*f(i,j,nc)
          enddo
        enddo
c
c  we solve first with correct r.h.s. but zero b.c.'s
c
        call tridgx(nxp2,nyp1,a,b,c,r,yp,work1,work2)
c
c  we now solve with zero r.h.s. and b.c. u(0,y,t)=u(1,y,t)=1
c
        do j=1,ny
          z(1,j)=-c(1,j)
          z(nx-1,j)=-b(nx-1,j)
        enddo
        call tridgx(nxp2,nyp1,a,b,c,z,yh,work1,work2)
c
c the correct linear combo. of particular and homogeneous
c solutions is found by using the equation at endpoint...
c
        do j=1,ny
          xl=r(nx,j)-c(nx,j)*yp(nx-1,j)-b(nx,j)*yp(1,j)
          yl=c(nx,j)*yh(nx-1,j)+a+b(nx,j)*yh(1,j)
          lamy(j)=xl/yl
        enddo
c
        do j=1,ny
          f(nx,j,nc)=lamy(j)
          do i=1,nx-1
            f(i,j,nc)=lamy(j)*yh(i,j) + yp(i,j)
          enddo
        enddo
      enddo

      do j=1,ny
         z(1   ,j)=0.0D+00
         z(nx-1,j)=0.0D+00
      enddo
c
c now comes our second fractional step.  for each
c fixed value of x we calculate f(x,y,ncomp) by
c solving another periodic linear system in the
c same manner as above.......
c
      do nc=1,2
c
        do j=1,ny
          do i=1,nx
            pro=sfluid(1)*ro*u(i,j,2)
            c(i,j)=-pro -sfluid(2)
            b(i,j)= pro - sfluid(2)
            r(i,j)=ro*f(i,j,nc)
          enddo
        enddo
c
        call tridgy(nxp2,nyp1,a,b,c,r,yp,work1,work2)
c
        do i=1,nx
          z(i,1   )=-c(i,1)
          z(i,ny-1)=-b(i,ny-1)
        enddo
c
        call tridgy(nxp2,nyp1,a,b,c,z,yh,work1,work2)
c
        do i=1,nx
           xl=r(i,ny)-c(i,ny)*yp(i,ny-1)-b(i,ny)*yp(i,1)
           yl=c(i,ny)*yh(i,ny-1)+a+b(i,ny)*yh(i,1)
           lamx(i)=xl/yl
        enddo

        do i=1,nx
          do j=1,ny-1
            f(i,j,nc)=lamx(i)*yh(i,j)+yp(i,j)
          enddo
          f(i,ny,nc)=lamx(i)
        enddo
      enddo

c
c make f periodic in x
c
      do j=1,ny
        f(0   ,j,1)=f(nx,j,1)
        f(nxp1,j,1)=f(1 ,j,1)
        f(0   ,j,2)=f(nx,j,2)
        f(nxp1,j,2)=f(1 ,j,2)
      enddo
c
c div calculates the divergence of 2nd frac. step
c
      call div(sfluid(3),f,p,nxp2,nyp1)
c
c add sources and sinks into the fluid field
c
      do j = 1,ny
        do i = 0,nx
          p(i,j) = p(i,j) - psi(i,j)
        enddo
      enddo
c
      call fft2d(p,bzero,-1,nxp2,nyp1)
      do j=1,ny
        do i=1,nx
          p(i,j)=p(i,j)/sinsq(i,j)*h*h*4.D+00
          bzero(i,j)=bzero(i,j)/sinsq(i,j)*h*h*4.D+00
        enddo
      enddo
      call fft2d(p,bzero,+1,nxp2,nyp1)
      call newu(u,h,f,p,nxp2,nyp1)
c
      return
      end
c
c------------------------------------------------------------
c
      subroutine newu(u,h,f,p,nxp2,nyp1)
c
      integer i,j,nx,ny,nxp1
      double precision h,s
c
      integer nxp2,nyp1
      double precision p,u,f
c
      dimension u(0:nxp2,0:nyp1,2)
      dimension f(0:nxp2,0:nyp1,2)
      dimension p(0:nxp2,0:nyp1)
c
      nx = nxp2-2
      nxp1 = nxp2-1
      ny = nyp1-1
c
      s=1.D+00/(2*h)
      do i=2,ny-1
         u(1 ,i ,2)=f(1 ,i ,2)-s*(p(1  ,i+1)-p(1  ,i-1))
         u(nx,i ,2)=f(nx,i ,2)-s*(p(nx ,i+1)-p(nx ,i-1))
      enddo
c
      do i=2,nx-1
         u(i ,1 ,1)=f(i ,1 ,1)-s*(p(i+1,1  )-p(i-1,1  ))
         u(i ,ny,1)=f(i ,ny,1)-s*(p(i+1,ny )-p(i-1,ny ))
      enddo
c
      do i=2,nx-1
        do j=2,ny-1
          u(i,j,1)=f(i,j,1)-s*(p(i+1,j  )-p(i-1,j  ))
          u(i,j,2)=f(i,j,2)-s*(p(i  ,j+1)-p(i  ,j-1))
        enddo
      enddo
c
      do j=1,ny
         u(1 ,j ,1)=f(1 ,j ,1)-s*(p(2,j)-p(nx  ,j   ))
         u(nx,j ,1)=f(nx,j ,1)-s*(p(1,j)-p(nx-1,j   ))
      enddo
c
      do j=1,nx
         u(j ,1 ,2)=f(j ,1 ,2)-s*(p(j,2)-p(j   ,ny  ))
         u(j ,ny,2)=f(j ,ny,2)-s*(p(j,1)-p(j   ,ny-1))
      enddo
c
      do j=1,ny
          u(0   ,j,1)=u(nx,j,1)
          u(nxp1,j,1)=u(1 ,j,1)
          u(0   ,j,2)=u(nx,j,2)
          u(nxp1,j,2)=u(1 ,j,2)
      enddo
c
      do i=1,nx
          u(i,   0,1)   =u(i,ny,1)
          u(i,   0,2)   =u(i,ny,2)
      enddo
c
      u(0   ,0   ,1)=u(nx,ny,1)
      u(nxp1,0   ,1)=u(1 ,ny,1)
      u(0   ,0   ,2)=u(nx,ny,2)
      u(nxp1,0   ,2)=u(1 ,ny,2)
c
      return
      end
c
c------------------------------------------------------------
c
      subroutine div(s3,f,d,nxp2,nyp1)
c
      implicit none
c
      integer  i,j,nx,ny

      integer nxp2, nyp1
      double precision d,s3,f
      dimension   f(0:nxp2,0:nyp1,2),d(0:nxp2,0:nyp1)
c
      nx = nxp2-2
      ny = nyp1-1
c
      do i=2,nx-1
        do j=2,ny-1
           d(i,j)=s3*(f(i+1,j  ,1)-f(i-1,j  ,1)+
     +              f(i  ,j+1,2)-f(i  ,j-1,2))
        enddo
      enddo
c
      do j=2,ny-1
         d(1 ,j )=s3*(f(2  ,j  ,1)-f(nx  ,j   ,1)+
     +                f(1  ,j+1,2)-f(1   ,j-1 ,2))
         d(nx,j )=s3*(f(1  ,j  ,1)-f(nx-1,j   ,1)+
     +                f(nx ,j+1,2)-f(nx  ,j-1 ,2))
      enddo
c
      do i=2,nx-1
         d(i ,1 )=s3*(f(i+1,1  ,1)-f(i-1 ,1   ,1)+
     +                f(i  ,2  ,2)-f(i   ,ny  ,2))
         d(i ,ny)=s3*(f(i+1,ny ,1)-f(i-1 ,ny  ,1)+
     +                f(i  ,1  ,2)-f(i   ,ny-1,2))
      enddo
c
      d(1 ,1 )=s3*(f(2 ,1 ,1)-f(nx  ,1   ,1)
     +            +f(1 ,2 ,2)-f(1   ,ny  ,2))
      d(1 ,ny)=s3*(f(2 ,ny,1)-f(nx  ,ny  ,1)
     +            +f(1 ,1 ,2)-f(1   ,ny-1,2))
      d(nx,1 )=s3*(f(1 ,1 ,1)-f(nx-1,1   ,1)
     +            +f(nx,2 ,2)-f(nx  ,ny  ,2))
      d(nx,ny)=s3*(f(1 ,ny,1)-f(nx-1,ny  ,1)
     +            +f(nx,1 ,2)-f(nx  ,ny-1,2))
c
      return
      end
c
c------------------------------------------------------------
c
      subroutine fft2d(a,b,isign,nxp2,nyp1)
c
c*****two-dimensional fourier transform of a complex array a+ib.
c     (that is, the real part is stored in a and the immaginary
c     part is stored in b.)
c     the transform is computed in place, overwriting a and b.
c     vectorization is achieved as follows:
c     when computing transform in x-direction, vectorize over y;
c     when computing transform in y-direction, vectorize over x.
c
c     the data a and b are nx x ny,
c     where nx and ny are specified in the parameter statement below.
c     these nx x ny data are stored in arrays
c     with dimensions 0...nxp2, 1...ny
c
c     the argument isign may be any positive or negative integer (not 0)
c     its sign determines the sign of the exponent in the fourier transf
c
c     normalization is performed for either value of isign.
c     the normalization is division by sqrt(nx*ny).
c
c     although the program computes the complex fourier transform, the
c     arithmetic is written out in terms of the real and imaginary parts
c
c     the code is a vector version of the one-dimensional fft
c     program of cooley, lewis, and welch, ieee transactions e-12,
c     no. 1 (march 1965), cited by dahlquist & bjork, numerical methods,
c     prentice hall, englewood cliffs, new jersey, p416
c
      implicit none
c
      double precision a,b
      integer isign,nxp2,nyp1
      dimension a(0:nxp2,0:nyp1),b(0:nxp2,0:nyp1)
c
      integer  i,ip,iv,j,k,l,l2nx,l2ny,nx,ny
      integer  le,le1,nxm1,nym1,nxv2,nyv2
c
      double precision     ang,fnxny,rfnxny,dsign
      double precision     tu1,u1,u2,w1,w2
c
c
c  Fast Fourier Transform local variables
c
      double precision t1x(1)
      common /tx1/ t1x

      double precision t2x(1)
      common /tx2/ t2x

      double precision t3x(1)
      common /tx3/ t3x

      double precision t4x(1)
      common /tx4/ t4x

      double precision t1y(1)
      common /ty1/ t1y

      double precision t2y(1)
      common /ty2/ t2y

      double precision t3y(1)
      common /ty3/ t3y

      double precision t4y(1)
      common /ty4/ t4y
c
      dsign=dble(isign/iabs(isign))
c
      nx = nxp2-2
      ny = nyp1-1
c
      do i = 1, 100
        if (2**i.eq.nx) then
          l2nx = i
          go to 998
        endif
      enddo
 998  continue
      do i = 1, 100
        if (2**i.eq.ny) then
          l2ny = i
          go to 999
        endif
      enddo
 999  continue
c
      nxv2=nx/2
      nxm1=nx-1
      nyv2=ny/2
      nym1=ny-1
c
c*****fourier transform in x-direction:
c*****bit-reversal permutation:
c
      j=1
      do 7 i=1,nxm1
      if(i.ge.j)goto 5
      do 91 iv=1,ny
        t1y(iv)=a(j,iv)
        t3y(iv)=b(j,iv)
        t2y(iv)=a(i,iv)
        t4y(iv)=b(i,iv)
 91   continue
      do 92 iv=1,ny
        a(i,iv)=t1y(iv)
        b(i,iv)=t3y(iv)
        a(j,iv)=t2y(iv)
        b(j,iv)=t4y(iv)
 92   continue
    5 k=nxv2
    6 if(k.ge.j)goto 7
      j=j-k
      k=k/2
      goto 6
    7 j=j+k
c
c*****main loop:
c
      do 20 l=1,l2nx
      le=2**l
      le1=le/2
      u1=1.D+00
      u2=0.D+00
      ang=dsign*3.14159265358979D+00/le1
      w1=dcos(ang)
      w2=dsin(ang)
      do 20 j=1,le1
      do 10 i=j,nx,le
      ip=i+le1
      do 93 iv=1,ny
        t1y(iv)=a(i,iv)
        t3y(iv)=b(i,iv)
        t2y(iv)=a(ip,iv)*u1-b(ip,iv)*u2
        t4y(iv)=a(ip,iv)*u2+b(ip,iv)*u1
 93   continue
      do 94 iv=1,ny
        a(ip,iv)=t1y(iv)-t2y(iv)
        b(ip,iv)=t3y(iv)-t4y(iv)
        a(i ,iv)=t1y(iv)+t2y(iv)
        b(i ,iv)=t3y(iv)+t4y(iv)
 94   continue
   10 continue
      tu1=u1*w1-u2*w2
      u2 =u1*w2+u2*w1
   20 u1=tu1
c
c*****fourier transform in y-direction:
c*****bit-reversal permutation:
c
      j=1
      do 107 i=1,nym1
      if(i.ge.j)goto 105
      do 191 iv=1,nx
        t1x(iv)=a(iv,j)
        t3x(iv)=b(iv,j)
        t2x(iv)=a(iv,i)
        t4x(iv)=b(iv,i)
 191  continue
      do 192 iv=1,nx
        a(iv,i)=t1x(iv)
        b(iv,i)=t3x(iv)
        a(iv,j)=t2x(iv)
        b(iv,j)=t4x(iv)
 192  continue
  105 k=nyv2
  106 if(k.ge.j)goto 107
      j=j-k
      k=k/2
      goto 106
  107 j=j+k
c
c*****main loop:
c
      do 120 l=1,l2ny
      le=2**l
      le1=le/2
      u1=1.D+00
      u2=0.D+00
      ang=dsign*3.14159265358979D+00/le1
      w1=dcos(ang)
      w2=dsin(ang)
      do 120 j=1,le1
      do 110 i=j,ny,le
      ip=i+le1
      do 193 iv=1,nx
        t1x(iv)=a(iv,i)
        t3x(iv)=b(iv,i)
        t2x(iv)=a(iv,ip)*u1-b(iv,ip)*u2
        t4x(iv)=a(iv,ip)*u2+b(iv,ip)*u1
 193  continue
      do 194 iv=1,nx
        a(iv,ip)=t1x(iv)-t2x(iv)
        b(iv,ip)=t3x(iv)-t4x(iv)
        a(iv,i )=t1x(iv)+t2x(iv)
        b(iv,i )=t3x(iv)+t4x(iv)
 194  continue
  110 continue
      tu1=u1*w1-u2*w2
      u2 =u1*w2+u2*w1
  120 u1=tu1
c
c     normalization loop:
c
      fnxny=dsqrt(dble(nx*ny))
      rfnxny=1.0D+00/fnxny
      do 200 i=1,nx
      do 200 iv=1,ny
        a(i,iv)=a(i,iv)*rfnxny
        b(i,iv)=b(i,iv)*rfnxny
  200 continue
c
      return
      end
c
c------------------------------------------------------------
c
      subroutine tridgx(nxp2,nyp1,a,b,c,w,y,work1,work2)
c
      implicit none
      integer i,j,nx,ny
c
      integer nxp2, nyp1
      double precision a,b,c,w,y
      double precision work1,work2
c
      dimension b(0:nxp2,0:nyp1)
      dimension c(0:nxp2,0:nyp1)
      dimension y(0:nxp2,0:nyp1)
      dimension w(0:nxp2,0:nyp1)
c
      dimension work1(0:nxp2,0:nyp1)
      dimension work2(0:nxp2,0:nyp1)
c
      nx = nxp2-2
      ny = nyp1-1
c
      do j=1,ny
         work2(1,j) = a
      enddo

      do i=1,nx-2
        do j=1,ny
          y(i,j) = c(i+1,j)/work2(i,j)
          work2(i+1,j) = a - y(i,j)*b(i,j)
        enddo
      enddo

      do j=1,ny
        work1(1,j)=w(1,j)
      enddo

      do i=2,nx-1
        do j=1,ny
          work1(i,j)= w(i,j) - work1(i-1,j)*y(i-1,j)
        enddo
      enddo


      do j=1,ny
         y(nx-1,j)=work1(nx-1,j)/work2(nx-1,j)
      enddo

      do i=nx-2,1,-1
        do j=1,ny
          y(i,j)=( work1(i,j)-y(i+1,j)*b(i,j) )/work2(i,j)
        enddo
      enddo

      return
      end
c
c------------------------------------------------------------
c
      subroutine tridgy(nxp2,nyp1,a,b,c,w,y,work1,work2)
c
      implicit none
      integer i,j,nx,ny
c
      integer nxp2, nyp1
      double precision a,b,c,w,y
      double precision work1,work2
c
      dimension b(0:nxp2,0:nyp1)
      dimension c(0:nxp2,0:nyp1)
      dimension y(0:nxp2,0:nyp1)
      dimension w(0:nxp2,0:nyp1)
c
      dimension work1(0:nxp2,0:nyp1)
      dimension work2(0:nxp2,0:nyp1)
c
      nx = nxp2-2
      ny = nyp1-1
c
      do i=1,nx
         work2(i,1) = a
      enddo

      do j=1,ny-2
        do i=1,nx
          y(i,j) = c(i,j+1)/work2(i,j)
          work2(i,j+1) = a - y(i,j)*b(i,j)
        enddo
      enddo

      do i=1,nx
         work1(i,1)=w(i,1)
      enddo

      do j=2,ny-1
        do i=1,nx
          work1(i,j)=w(i,j)-work1(i,j-1)*y(i,j-1)
        enddo
      enddo

      do i=1,nx
         y(i,ny-1) = work1(i,ny-1)/work2(i,ny-1)
      enddo

      do j=ny-2,1,-1
        do i=1,nx
          y(i,j) = ( work1(i,j) - y(i,j+1)*b(i,j) ) / work2(i,j)
        enddo
      enddo

      return
      end
