c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
      subroutine cplot (it,alpha,nxx,nyy,mlink,np)
c
c  Produces a raw byte array of fluid simulation
c    Package
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'links.inc'
      include 'domain.inc'
      include 'graph.inc'
c
c  global variables
c
      integer it,nxx,nyy,mlink,np
      byte alpha(nxx,nyy)
c
c  local variables
c
      integer i,ient,j,kjx,kjy,bary
      double precision x1,x2,y1,y2
      character*1024 fnm
c
c  set the background color
c
      do 25 j = 1, nyy
        do 25 i = 1, nxx
          alpha(i,j) = icolr(1)
 25   continue
      do 30 j = 1, nyy
        alpha(1,j) = icolr(2)
        alpha(nxx,j) = icolr(2)
 30   continue
      do 35 i = 1, nxx
        alpha(i,1) = icolr(2)
        alpha(i,nyy) = icolr(2)
 35   continue
c
c  mark the entities.  first the closed entities
c
      do 50, ient = 1, ment
        if (iclose(ient).ge.1 .and. categor(ient).ne.0 ) 
     x          call cpoly(ient,alpha,nxx,nyy)
 50   continue
      do 55, ient = 1, ment
        if (iclose(ient).eq.0 .and. categor(ient).ne.0 ) 
     x          call cpoly(ient,alpha,nxx,nyy)
 55   continue
c
c  mark the links
c
      do 75 i=1,mlink
        if (lcat(i).eq.1) then
          if ( bary(xb(2*q1(i)-1),xb(2*q1(i)))+
     x       bary(xb(2*q2(i)-1),xb(2*q2(i))).eq.0 ) then
            x1 = xb(2*q1(i)-1)/dx
            x2 = xb(2*q2(i)-1)/dx
            y1 = xb(2*q1(i))/dx
            y2 = xb(2*q2(i))/dx
            call mline (x1,y1,x2,y2,icolr(4),alpha,nxx,nyy)
          endif
        endif
 75   continue
c
c  mark the particles
c
      do 100, i = 1, np
        if (pmark(i).ne.0) then
          kjx = max0(idint(px(i)/dx),1)
          kjx = min0(kjx,nxx)
          kjy = max0(idint(py(i)/dy),1)
          kjy = min0(kjy,nyy)
          alpha(kjx,kjy) = pmark(i)
        endif
 100  continue
c
c  Output the data
c
      write(fnm,'(A,".",i4.4)') colorf(1:index(colorf,' ')-1),it
      write(6,999) fnm
      open(unit=55,file=fnm,status='unknown',form='unformatted')
      write (55) alpha
      close(55)
c
c  Update information for visual.dat
c
      open(unit=60,file='ibisdat/cplot.dat',status='unknown')
      write (60,*) it
      close(60)
c
      return
 999  format('  Saving color data in ',A40)
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine cpoly (ient,alpha,nxx,nyy)
c
c  Plots the polygons
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'domain.inc'
      include 'graph.inc'
c
c  global variables
c
      integer ient,nxx,nyy
      byte alpha(nxx,nyy)
c
c  local variables
c
      integer ione,iend,ixx,iyy,j,iflag,bary
      double precision x1,x2,y1,y2
c
c run around the curve.
c 
      iflag = 0
      ione = firstb(ient)
      iend = lastb(ient)
      if ( categor(ient) .eq. 1) iend = iend-1
      do 20 j = ione, iend-1
        if ( bary(xb(2*j-1),xb(2*j)) +
     x       bary(xb(2*j+1),xb(2*j+2)) .eq.0 ) then
          x1 = xb(2*j-1)/dx
          x2 = xb(2*j+1)/dx
          y1 = xb(2*j)/dy
          y2 = xb(2*j+2)/dy
          call mline (x1,y1,x2,y2,icolr(5),alpha,nxx,nyy)
        else
          iflag = 1
        endif
 20   continue
c
c  if the object is closed then complete curve and
c  mark the interior of the polygon
c
      if (iclose(ient) .eq. 1) then
        if ( bary(xb(2*ione-1),xb(2*ione))+
     x       bary(xb(2*iend-1),xb(2*iend)) .eq.0 ) then
          x1 = xb(2*ione-1)/dx
          x2 = xb(2*iend-1)/dx
          y1 = xb(2*ione)/dy
          y2 = xb(2*iend)/dy
          call mline (x1,y1,x2,y2,icolr(5),alpha,nxx,nyy)
        else
          iflag = 1
        endif
        ixx = idint(centx(ient)/dx)
        iyy = idint(centy(ient)/dy)
        if ( iflag .eq. 0 ) 
     x     call minter (ixx,iyy,icoli(ient),alpha,nxx,nyy)
      elseif (iclose(ient) .eq. 2) then
        ixx = nxx/2
        iyy = nyy/2
        if ( iflag .eq. 0 ) 
     x     call minter (ixx,iyy,icoli(ient),alpha,nxx,nyy)
      endif
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine minter(ix,iy,coli,alpha,nxx,nyy)
c
c
c  mark the interior of the closed object
c
c  given that (iint,jint) is in the interior, ckeck the
c    four nearest neighbors.  If they are in the interior
c    then
c       1. mark them if they aren't already marked
c       2. store their location as new known interior points
c    Then take the last found unmarked point in the interior
c    and repeat.  The loop is a do-while type construction.
c
      implicit none
      include 'graph.inc'
c
      integer ix,iy,nxx,nyy
      byte alpha(nxx,nyy),coli
c
      integer colb,nlist,ii(4),jj(4),k
c
      nlist = 0
      data ii /1, -1, 0, 0/
      data jj /0, 0, 1, -1/
c
      colb = alpha(ix,iy)
      alpha(ix,iy) = coli
 40   continue
        do 50, k = 1, 4
          if ( alpha(ix+ii(k),iy+jj(k)) .eq. colb ) then
            alpha(ix+ii(k),iy+jj(k)) = coli
            nlist = nlist + 1
            list1(nlist) = ix+ii(k)
            list2(nlist) = iy+jj(k)
          endif
 50     continue
        if (nlist.eq.0) goto 60
        ix = list1(nlist)
        iy = list2(nlist)
        nlist = nlist - 1
        goto 40
 60   continue
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine mline (x1,y1,x2,y2,col,alpha,nxx,nyy)
c
c  Mark the boundary points making sure of no gap
c
c  global includes
c
      implicit none
      include 'graph.inc'
c
c  global variables
c
      integer nxx,nyy
      byte alpha(nxx,nyy),col
      double precision x1,x2,y1,y2
c
c  local variables
c
      integer j,k,n,nd
      double precision d,dist,f0,f1
c
      d  = dist(x1,y1,x2,y2)
      nd = idint(d+1.0d0)
      do 10, n = 0, nd
        f0 = dble(n)/dble(nd)
        f1 = 1.0d0 - f0
        j  = idint((f0*x1)+(f1*x2))
        k  = idint((f0*y1)+(f1*y2))
        alpha(j,k) = col
 10   continue
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      double precision function dist(x1,y1,x2,y2)
c
c  Calculate the distance between points
c
      double precision x1,y1,x2,y2
      dist = dsqrt(((x1-x2)**2)+((y1-y2)**2))
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      integer function bary(x,y)
c
c  Make sure (x,y) is in the domain
c
      implicit none
      include 'domain.inc'
c
      double precision x,y
c
c  local variables
c
      double precision distx,disty,area,b(4),bmin
c
c  distance from corner to x,y
c
      distx = xlength-x
      disty = ylength-y
c
c  rectangular barycentric coordinates
c
      area = xlength*ylength
      b(1) = x*y/area
      b(2) = distx*y/area
      b(3) = x*disty/area
      b(4) = distx*disty/area
c
c  check to see if they are all positive - i.e.
c  in the domain
c
      bary = 0
      bmin = dmin1(b(1),b(2),b(3),b(4))
      if (bmin .le. 0.0d0) bary = 1
c
      return
      end
c
c-------------------------------------------------------
c
      subroutine partwalk(np)
c
c  randomly move the fluid markers with gaussian random
c  numbers, mean zero, variance one.
c
c-------------------------------------------------------
c
      implicit none
      include 'graph.inc'
      include 'domain.inc'
c
      integer np
c
c  local variables
c
      integer i
      double precision ran1p,r1,r2,rg,var,tpi
c
c  random walk
c
      tpi = 8.0d0*atan(1.0d0)
      do i = 1, np
        var = 2.D+00*pwalk*dlt
        rg  = dsqrt(-2.D+00*var*dlog(max(ran1p(),1.d-8)))
        r1  = rg*dcos(tpi*ran1p())
        r2  = rg*dsin(tpi*ran1p())
        px(i) = px(i) + r1
        py(i) = py(i) + r2
      enddo
c
      return
      end
c
c-------------------------------------------------------
c
      subroutine part(np,npdx,npdy,nxx,nyy)
c
c  deal with the fluid markers at the boundaries
c    via method specified by user
c
c-------------------------------------------------------
c
      implicit none
      include 'graph.inc'
      include 'domain.inc'
c
      integer np,npdx,npdy,nxx,nyy
c
c  local variables
c
      integer i,pnew
      double precision xloc, yloc
c
c  the periodic case, just map particles one domain length
c    x-direction first
c
      if (ipbx.eq.0) then
        pfluxx = 0.0d0
        do 50, i = 1, np
          if (px(i).gt.xlength) px(i) = px(i)-xlength
          if (px(i).lt.0.0d0) px(i) = xlength + px(i)
 50     continue
      endif
c
c  y-direction
c
      if (ipby.eq.0) then
        pfluxy = 0.0d0
        do 100, i = 1, np
          if (py(i).gt.ylength) py(i) = py(i)-ylength
          if (py(i).lt.0.0d0) py(i) = ylength + py(i)
 100    continue
      endif
c
c  the flux case - remove particles that leave
c    x-direction first
c
      if (ipbx.eq.1) then
        do 150, i = 1, np
          if (px(i).gt.xlength .or. px(i).lt.0.0d0) then
            pmark(i) = 0
            px(i) = xlength/2.0d0
            nactm = nactm-1
          endif
 150    continue
      endif
c
c  y-direction
c
      if (ipby.eq.1) then
        do 200, i = 1, np
          if (py(i).gt.ylength .or. py(i).lt.0.0d0) then
            pmark(i) = 0
            py(i) = ylength/2.0d0
            nactm = nactm-1
          endif
 200    continue
      endif
c
c  add a new particles at left or right if its time
c
      npx = (nxx+1)/npdx
      npy = (nyy+1)/npdy
      pdx = xlength/dble(npx)
      pdy = ylength/dble(npy)

      if (ipbx.eq.1) then
        if ( abs(pfluxx) .gt. pdx ) then
          xloc = pdx/2.0d0
          if ( pfluxx.lt.0.0 ) xloc = xlength - (pdx/2.0d0)
          pfluxx = 0.0d0
          pnew = 0
          do 250, i = 1, np
            if (pmark(i).eq.0 .and. pnew.le.npy) then
              px(i) = xloc
              py(i) = (pnew*pdy) + (pdy/2.0d0)
              pmark(i) = 2
              nactm = nactm+1
              pnew = pnew + 1
            endif
 250      continue
        endif
      endif
c
c  add a new particles at top or bottom if its time
c
      if (ipby.eq.1) then
        if ( abs(pfluxy) .gt. pdy ) then
          yloc = pdy/2.0d0
          if ( pfluxy.lt.0.0 ) yloc = ylength - yloc
          pfluxy = 0.0d0
          pnew = 0
          do 300, i = 1, np
            if (pmark(i).eq.0 .and. pnew.lt.npx) then
              px(i) = (pnew*pdx) + (pdx/2.0d0)
              py(i) = yloc
              pmark(i) = 2
              nactm = nactm+1
              pnew = pnew + 1
            endif
 300      continue
        endif
      endif
c
      return
      end
c
c-------------------------------------------------------
c
      subroutine prtsrc(ntsrc,np)
c
c  deal with the fluid markers at the boundaries
c    via method specified by user
c
c-------------------------------------------------------
c
      implicit none
c
      include 'graph.inc'
      include 'domain.inc'
      include 'sink.inc'
c
c  global variables
c
      integer ntsrc,np
c
c  local variables
c
      integer i,j,isink,isource,ksrc
      double precision d,dist,dpx,dpy
c
c  find the sources and sinks
c
      isink = 0
      isource = 0
      do i=1,ntsrc
        if ( src(i) .lt. 0.0d0 ) then
          isink = isink + 1
          sink(isink) = i
        elseif ( src(i) .gt. 0.0d0 ) then
          isource = isource + 1
          source(isource) = i
        endif
      end do
c
c  check all the particles for distance from sinks
c    move from near sinks to near source if close 
c    enough to the sink
c
      ksrc = 0
      do i = 1, np
        if (pmark(i).ne.0) then
          do j = 1, isink
            d  = dist(xsourc(sink(j)),ysourc(sink(j)),px(i),py(i))
            if ( d .le. h/4.0d0 ) then
              ksrc = ksrc+1
              if (ksrc.gt.isource) ksrc = 1
              dpx = xsourc(sink(j))-px(i)
              dpy = ysourc(sink(j))-py(i)
              px(i) = xsourc(source(ksrc))+dpx
              py(i) = ysourc(source(ksrc))+dpy
            endif
          enddo
        endif
      enddo
c
      return
      end
c
c---------------------------------------------------------
c
      subroutine output(it,nxp2,nyp1,f,u,mlink,np)
c
c writes out data for plotting and other use
c
c  global include
c
      implicit none
c
c  global commons
c
      include 'ibp.inc'
      include 'links.inc'
      include 'plat.inc'
      include 'domain.inc'
      include 'graph.inc'
      include 'fluid.inc'
c
c  global variables
c
      integer it,nxp2,nyp1,mlink,np
      double precision f(0:nxp2,0:nyp1,2)
      double precision u(0:nxp2,0:nyp1,2)
c
c  local variables
c
      character*1024 fnm
      integer i,i1,i2,j, klink, kpart, kpoint, inside, iside, nx, ny
      double precision h2, vlmax, flmax, q, vlmin, flmin, xout, yout
      double precision x1, y1, x2, y2, maptox, maptoy
c
      nx = nxp2-2
      ny = nyp1-1
c
c  terminal message
c
      write(fnm,'(A,".*.",i4.4)') linef(1:index(linef,' ')-1),it
      write(6,998) fnm
c
c  local max/min initialize
c
      vlmax = 0.0d0
      flmax = 0.0d0
      vlmin = vmaxg
      flmin = fmaxg
c
c  write out field vectors file
c
      h2 = h*h
      write(fnm,'(A,".v.",i4.4)') linef(1:index(linef,' ')-1),it
      open(unit=18,file=fnm,status='unknown')
      do j = 1, ny, ivdens
        yout = ymin + (h*j)
        do i = 1, nx, ivdens
          xout = xmin + (h*i)
          write(18,1008) xout, yout, u(i,j,1), u(i,j,2),
     x        f(i,j,1)*h2, f(i,j,2)*h2
          vlmax = dmax1(vlmax,sqrt(u(i,j,1)**2 + u(i,j,2)**2)) 
          flmax = dmax1(flmax,h2*sqrt(f(i,j,1)**2 + 
     x                  f(i,j,2)**2)) 
          vlmin = dmin1(vlmin,sqrt(u(i,j,1)**2 + u(i,j,2)**2)) 
          flmin = dmin1(flmin,h2*sqrt(f(i,j,1)**2 + 
     x                  f(i,j,2)**2)) 
        enddo
      enddo
      close(18)
c
c  write out ibp file
c
      kpoint = 0
      write(fnm,'(A,".i.",i4.4)') linef(1:index(linef,' ')-1),it
      open(unit=18,file=fnm,status='unknown')
      do j=1,ment
        if ( categor(j).ne.0 ) then
          i1=firstb(j)
          i2=lastb (j)
          if ( i2-i1 .ge. 1 ) then
            do i=i1,i2
              xout = maptox(xb(2*i-1)+xmin)
              yout = maptoy(xb(2*i)+ymin)
              write(18,1006) xout,yout,usb1(i)*h2,usb2(i)*h2
     x            ,-gfrcb1(i),-gfrcb2(i)
              kpoint = kpoint + 1
              q = sqrt((usb1(i)*h2)**2 + (usb2(i)*h2)**2)
              vlmax = dmax1(vlmax,q)
              flmax = dmax1(flmax,sqrt(gfrcb1(i)**2 + gfrcb2(i)**2))
              vlmin = dmin1(vlmin,q)
              flmin = dmin1(flmin,sqrt(gfrcb1(i)**2 + gfrcb2(i)**2))
            enddo
          endif
        endif
      enddo
      close(18)
c
c  write out link file
c    first the intra entity links
c
      klink = 0
      write(fnm,'(A,".l.",i4.4)') linef(1:index(linef,' ')-1),it
      open(unit=18,file=fnm,status='unknown')
      do j=1,ment
        if ( categor(j).ne.0 ) then
          i1=firstb(j)
          i2=lastb (j)
          if ( i2-i1 .ge. 1 ) then
            do i=i1,i2-1
              x1 = xb(2*i-1)+xmin
              y1 = xb(2*i)+ymin
              x2 = xb(2*i+1)+xmin
              y2 = xb(2*i+2)+ymin
              iside = inside(x1,y1)+inside(x2,y2)
              if (iside.le.1) then
                write(18,1007) x1,y1,x2,y2
                klink = klink+1
              elseif (iside.eq.2) then
                write(18,1007) maptox(x1),maptoy(y1),
     x                 maptox(x2),maptoy(y2)
                klink = klink+1
              endif
            enddo
            if ( iclose(j).ne.0 ) then
              x1 = xb(2*i1-1)+xmin
              y1 = xb(2*i1)+ymin
              x2 = xb(2*i2-1)+xmin
              y2 = xb(2*i2)+ymin
              iside = inside(x1,y1)+inside(x2,y2)
              if (iside.le.1) then
                write(18,1007) x1,y1,x2,y2
                klink = klink+1
              elseif (iside.eq.2) then
                write(18,1007) maptox(x1),maptoy(y1),
     x                 maptox(x2),maptoy(y2)
                klink = klink+1
              endif
            endif
c
c  plot periodic lines
c
            if ( categor(j).eq.-1 ) then
              x1 = xb(2*i1-1)+xmin
              y1 = xb(2*i1)+ymin
              x2 = xb(2*i2-1)+xmin-xlength
              y2 = xb(2*i2)+ymin
              write(18,1007) x1,y1,x2,y2
              klink = klink+1
              write(18,1007) x1+xlength,y1,x2+xlength,y2
              klink = klink+1
            endif

          endif
        endif
      enddo
c
c  now the inter entity links
c
      do j=1,mlink
        if (lcat(j).eq.1) then
          x1 = xb(2*q1(j)-1)+xmin
          y1 = xb(2*q1(j))+ymin
          x2 = xb(2*q2(j)-1)+xmin
          y2 = xb(2*q2(j))+ymin
          iside = inside(x1,y1)+inside(x2,y2)
          if (iside.le.1) then
            write(18,1007) x1,y1,x2,y2
            klink = klink+1
          elseif (iside.eq.2) then
            write(18,1007) maptox(x1),maptoy(y1),
     x                     maptox(x2),maptoy(y2)
            klink = klink+1
          endif
        endif
      enddo
      close(18)
c
c  write out marker particles
c
      kpart = 0
      write(fnm,'(A,".m.",i4.4)') linef(1:index(linef,' ')-1),it
      open(unit=18,file=fnm,status='unknown')
      do j = 1, np
        if ( pmark(j) .ne. 0 ) then
          write(18,1004) px(j)+xmin,py(j)+ymin,pmark(j)
          kpart = kpart+1
        endif
      enddo
      close(18)
c
c  write out the header file
c
      write(fnm,'(A,".h.",i4.4)') linef(1:index(linef,' ')-1),it
      open(unit=18,file=fnm,status='unknown')
      write(18,1000) xmin, xmax, ymin, ymax, time
      write(18,1010) nx/ivdens, ny/ivdens, h
      write(18,1002) kpoint, 0, 2
      write(18,1001) 0, 0
      write(18,1001) nx*ny, 2
      write(18,1002) klink, kpart
      write(18,1000) vlmax, flmax
      write(18,1000) vlmin, flmin
      write(18,1000) vlmax, flmax
      write(18,1000) vlmin, flmin
      close(18)
      fmax = flmax
c
c update visual.dat
c
      open(unit=65,file='ibisdat/lplot.dat',status='unknown')
      write (65,*) it
      close(65)
c
      fmaxg = dmax1(flmax,fmaxg)
      vmaxg = dmax1(vlmax,vmaxg)
      umax = vmaxg
      open(19,file='ibisdat/vmax.dat',status='unknown')
      write(19,*) 'fvmax1   ',sngl(vmaxg)
      write(19,*) 'fvmax2   ',sngl(fmaxg)
      write(19,*) 'pvmax1   ',sngl(vmaxg)
      write(19,*) 'pvmax2   ',sngl(fmaxg)
      close(19)
c
c shutdown
c
      return
 998  format('  Saving line velocity data in ',A40)
 999  format('  Saving line force data in ',A40)
 1000 format(6(1x,e15.7))
 1001 format(2(1x,i6))
 1002 format(3(1x,i6))
 1003 format(5(1x,i6))
 1004 format(2(1x,e15.7),i6)
 1005 format(3(1x,i6),1x,e15.7)
 1006 format(6(1x,e15.7))
 1007 format(4(1x,e15.7))
 1008 format(6(1x,e15.7))
 1010 format(2(1x,i6),1x,e15.7)
      end
c
c----------------------------------------------------------------
c
      subroutine rsdata(rsfile,nxp2,nyp1,u,mlink,np)
c
c  restart data output
c  global include
c
      implicit none
c
c  global common variables
c
      include 'active.inc'
      include 'domain.inc'
      include 'fluid.inc'
      include 'graph.inc'
      include 'ibp.inc'
      include 'links.inc'
      include 'plat.inc'
c
c  global variable
c
      integer rsfile,nxp2,nyp1,mlink,np
      double precision u(0:nxp2,0:nyp1,2)
c
c  local variables
c
      integer ient,inum,ione,iend,jpt,ilink,ipart
      character*1024 fnm
c
c  open the restart data file
c
      write(6,*) ' Saving restart data'
c
      open(unit=rsfile,file='ibisdat/rsd',status='unknown')
      write (rsfile,*) 'error'
      close (rsfile)
c
      write(fnm,'("ibisdat/rsdata.",i2.2)') rsfile
      open(unit=rsfile,file=fnm,form='unformatted')
c
c  write the name list data
c
      write(rsfile) umax,nt,time,ccount,lcount
c
c  write the number of active entities
c
      inum = 0
      do ient = 1, ment
        if ( categor(ient).ne.0 ) inum = inum+1
      enddo
      write(rsfile) inum
      write(rsfile) jfil,jplat,jpoly,nlinke
c
c  write the entity data
c
      inum = 0
      do ient = 1, ment
        if ( categor(ient).ne.0 ) then
          ione = firstb(ient)
          iend = lastb(ient)
          write(rsfile)'rsrt'
          write(rsfile) iend-ione+1, iclose(ient), 
     x      categor(ient), activ1(ient), activ2(ient),
     x      xcm(ient)+xmin, ycm(ient)+ymin
          do jpt = ione, iend
            inum = inum+1
            imap(jpt) = inum
            write(rsfile) inum, 
     x        xb(2*jpt-1)+xmin, xb(2*jpt)+ymin,
     x        xteth(jpt)+xmin, yteth(jpt)+ymin,
     x        dlp(jpt), swp(jpt), csp(jpt), sp(jpt),
     x        sthp(jpt)
          enddo
        endif
      enddo
c
c  write the link data
c
      write(rsfile) nlink
      do ilink = 1, mlink
        if ( lcat(ilink).eq.1 ) then
          write(rsfile) imap(q1(ilink)),imap(q2(ilink)),
     x        p1(ilink),p2(ilink),r1(ilink),r2(ilink),
     x        stiffb(ilink),sbreak(ilink),restb(ilink)
        endif
      enddo
c
c  write the fluid velocities
c
      write (rsfile) u
c
c  write the particles
c
      do ipart = 1, np
        write(rsfile) px(ipart), py(ipart), pmark(ipart)
      enddo
      close(rsfile)
c
      open(unit=rsfile,file='ibisdat/rsd',status='unknown')
      write (rsfile,*) 'done'
      close(rsfile)
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine prout (nt,fluxx,fluxy,vmax,cfl,time)
c
c   inform the screen
c
      integer nt
      double precision fluxx,fluxy,vmax,cfl,time
c
      write(6,*)' -----------------------------------------------'
      write(6,*)' nt    = ',nt
      write(6,*)' time  = ',time
      write(6,*)' fluxx = ',fluxx
      write(6,*)' fluxy = ',fluxy
      write(6,*)' vmax  = ',vmax
      write(6,*)' cfl   = ',cfl
c
      return
      end
c
c
      subroutine ohnoo 
c
c   inform the screen that you blew it
c
      write(6,*)' '
      write(6,*)' '
      write(6,*)' -----------------------------------------------'
      write(6,*)' -----------------------------------------------'
      write(6,*)' -----------------------------------------------'
      write(6,*)' '       
      write(6,*)' The calculation is now unstable'
      write(6,*)'     Failure is imminent'
      write(6,*)' '
      write(6,*)'     Decrease the time step or spring constants'
      write(6,*)'     before running the calculation again'
      write(6,*)' '
      write(6,*)'     Saving the final state for inspection'
      write(6,*)' '
      write(6,*)' Adios'
      write(6,*)' '
      write(6,*)' -----------------------------------------------'
      write(6,*)' -----------------------------------------------'
      write(6,*)' -----------------------------------------------'
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine upflux(nxp2,nyp1,u)
c
c  update fluid fluxes
c
      implicit none
      include 'domain.inc'
      include 'fluid.inc'
      include 'graph.inc'
c
      integer nxp2, nyp1
      double precision u(0:nxp2,0:nyp1,1:2)
c
      integer i, j, nx
      double precision q,velxm,velym
c
      nx = nxp2-2
c
      vmax  = 0.0d0
      fluxx = 0.0d0
      fluxy = 0.0d0
      velxm = 0.0d0
      velym = 0.0d0
      do j = ibtube, ittube
        do i =  0, nx
          q = sqrt(u(i,j,1)**2 + u(i,j,2)**2)
          vmax = max(vmax,q)
        enddo
      enddo
c
      do j = ibtube, ittube
        fluxx = fluxx + h*u(2,j,1)
        velxm = velxm + u(2,j,1)
      enddo
c
      do j = 1, nx
        fluxy=fluxy + h*u(j,2,2)
        velym = velym + u(j,2,2)
      enddo
      pfluxx = pfluxx+(velxm*dlt/dble(ittube-ibtube))
      pfluxy = pfluxy+(velym*dlt/dble(nx))
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine pdebug (idebug)
c
c  print the debug messages
c
      implicit none
      include 'ibp.inc'
c
      integer idebug(0:4)
c
      integer i
c
      if (idebug(1).eq.1) then
        do i=1,npts
          write(100,9990) xpt(i),ypt(i),gfrc1(i),gfrc2(i)
        enddo
      endif
c
c the immersed boundary points and their link information
c
      if (idebug(2).eq.1) then
        do i=1,npts
          write(103,9991) xb(2*i-1),xb(2*i),xteth(i),yteth(i),
     x         dlp(i),swp(i),csp(i),sp(i),sthp(i)
        enddo
      endif
c
      return
 9990 format(8f15.7)
 9991 format(4f10.3,6e11.3)
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      integer function inside(x,y)
c
c  Is (x,y) is in the domain?
c
      include 'domain.inc'
c
      double precision x,y
c
      inside = 0
      if ( x.lt.xmin .or. x.gt.xmax ) inside = 1
      if ( y.lt.ymin .or. y.gt.ymax ) inside = 1
c 
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      double precision function maptox(x)
c
      include 'domain.inc'
c
c  Map x to the domain.
c
      double precision x
c
      maptox = x
      if ( x.lt.xmin ) maptox = x + xlength
      if ( x.gt.xmax ) maptox = x - xlength
c
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      double precision function maptoy(y)
c
      include 'domain.inc'
c
c  Map y to the domain.
c
      double precision y
c
      maptoy = y
      if ( y.lt.ymin ) maptoy = y + ylength
      if ( y.gt.ymax ) maptoy = y - ylength
c
      return
      end
