c
      subroutine parea
c
      implicit none
      include 'ibp.inc'
c
c  local variables
c
      integer j, jent, jpt
      double precision areamax,areamin,c1,c2,d1,d2,aarea
c
      areamin= 1000.0D+00
      areamax=-1000.0D+00
      do 100 jent=1,ment
        if(categor(jent).ge.1.and.categor(jent).le.3)then
c
c compute area
c
           aarea = 0.0D+00
           do 20 j = 1, lastb(jent)-firstb(jent)
              jpt=firstb(jent)+j-1
              c1 = xb(2*jpt-1)-xcm(jent)
              c2 = xb(2*jpt  )-ycm(jent)
              d1 = xb(2*jpt+1)-xcm(jent)
              d2 = xb(2*jpt+2)-ycm(jent)
              aarea=aarea+.5D+00*dabs(c1*d2-c2*d1)
 20        continue
           jpt=firstb(jent)
           c1=xb(2*jpt-1)-xcm(jent)
           c2=xb(2*jpt  )-ycm(jent)
           jpt=lastb(jent)+1
           d1=xb(2*jpt-1)-xcm(jent)
           d2=xb(2*jpt  )-ycm(jent)
           aarea=aarea+.5D+00*dabs(c1*d2-c2*d1)
           areamin=dmin1(aarea/area(jent),areamin)
           areamax=dmax1(aarea/area(jent),areamax)
        endif
 100  continue
      write(16,101)areamin,areamax
 101  format(' areamin=',f13.7,' areamax=',f13.7)
      return
      end
c
      subroutine adhere(cpflag)
c
c this subroutine determines whether new links should be formed between
c platelet rings and wall filaments and if so, creates these links.
c
c this version permits multiple links between a given platelet
c and wall
c
c it expects filament 1 (entity 1) to be on bottom and 
c            filament 2 (entity 2) to be on top.
c
      implicit none
c
      include 'ibp.inc'
      include 'links.inc'
      include 'domain.inc'
      include 'plat.inc'
c
c  global variables
c
      integer cpflag
c
c  local variables
c
      integer i,ic,ient,ilink,imin,i1,i2
      integer j,jc,jent,jmin,j1,j2
      integer ni,nj,nwhere
      double precision dist,sdist,smin,xi,xj,yi,yj
c
c now see if x-coordinate of cm is in the x-interval which corresponds 
c to the injured part of the wall.
c
      do 200 ient=1,ment
         if(categor(ient).ge.1)then
         if(xcm(ient).gt.xadhmin.and.xcm(ient).lt.xadhmax)then
c
c see if platelet should adhere.
c
c first determine which wall is closer.
c
           if(ycm(ient).le.ycent)then
              jent = 1
           else
              jent = 2
           endif
c
c see if platelet is within sadh of nominal y-coor of closer wall
c
           if(jent.eq.1)then
              dist=ycm(ient)-ybot
           else
              dist=ytop-ycm(ient)
           endif
           if(dist.gt.sadh)goto 200
c
c next determine whether platelet ient is already linked to wall jent
c and, if so, how many links join them.
c
        if(categor(ient).eq.3)then
           i=ient
           j=jent
           nwhere=((i-2)*(i-1))/2 + j
           if(numlink(nwhere).ge.maxlink)goto 200
        endif
c
c find point on platelet and point on injured portion of
c this wall which are closest.
c
             i1=firstb(ient)
             i2=lastb (ient)
             ni=i2-i1+1
             j1=afirstb(jent)
             j2=alastb (jent)
             nj=j2-j1+1
             imin=0
             jmin=0
             smin=1000.D+00
             do 20 ic=1,ni
                i=i1 + ic - 1
             if(status(i+1).eq.0)then
                xi=xb(2*i-1)
                yi=xb(2*i  )
             do 15 jc=1,nj
                j=j1 + jc - 1
             if(status(j+1).eq.0)then
                xj=xb(2*j-1)
                yj=xb(2*j  )
                sdist =dsqrt((xi-xj)**2 + (yi-yj)**2)
                if(sdist.lt.smin)then
                     smin=sdist
                     imin=ic
                     jmin=jc + afirstb(jent)-firstb(jent)
                endif
             endif
 15          continue    
             endif
 20          continue
c
c now see if the distance between these nearest points is close enough.
c
             write(6,*)' smin=',smin,' sagap=',sagap
             if(smin.lt.sagap)then
c
c form adhesion link between point imin on platelet ient and point jmin 
c on filament jent.  note that jent < ient by our numbering convention.
c
                ilink =lkas
                p1(lkas)=jent
                r1(lkas)=jmin
                p2(lkas)=ient
                r2(lkas)=imin
                stiffb(lkas)=stiffa
                sbreak(lkas)=sbreaka
                restb (lkas)=rlinka
c
             status( firstb(ient)+imin)=1
             status( firstb(jent)+jmin)=1
c
                  write(6 ,31)ient,imin,jent,jmin,smin
                  write(16,31)ient,imin,jent,jmin,smin
c
             if(categor(ient).eq.3)then
c
c ient is linked, just update link-data structure
c
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((ient-2)*(ient-1))/2 + jent
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1

                  nlink=nlink+1
c
             elseif(categor(ient).eq.2)then
c
c ient is activated but not linked.  change category of ient and
c update link-data structure
c
                  categor(ient)=3
                  call chgcate(listf,listb,ient,pac,pzac,pl,pzl)
                  ilink =lkas
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((ient-2)*(ient-1))/2 + jent
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
c
             elseif(categor(ient).eq.1)then
c
c ient is nonactivated.  change category of ient and
c update link-data structure
c
                  categor(ient)=3
                  call chgcate(listf,listb,jent,pac,pzac,pl,pzl)
                  ilink=lkas
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((ient-2)*(ient-1))/2 + jent
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
             endif
             endif
         endif
         endif
 200  continue
c
   31 format('  adhere   ient=',i5,' imin=',i5,' jent=',i5,' jmin=',i5,
     +       ' smin=',f13.7)
      write(6,*)' adhere nlink=',nlink
      return
      end
c
      subroutine cohere(cpflag)
c
c this subroutine determines whether new links should be formed between
c platelet rings and if so, creates these links.
c
c this version allows multiple links between a given pair of platelets
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'links.inc'
      include 'plat.inc'
c
c  global variables
c
      integer cpflag
c
c  local variables
c
      integer i,ic,ient,ilink,imin,i1,i2
      integer j,jc,jent,jmin,j1,j2
      integer ni,nj,nbig,nsmall,nwhere
      double precision scm,sdist,smin
      double precision xi,xj,yi,yj
c
c  test for closeness of the cm for all pairs of platelet rings present
c  which are activated (categor=2) or linked (categor=3)
c
      do 200 ient=1,ment
      if(categor(ient).ge.2)then
         do 190 jent=ient+1,ment
         if(categor(jent).ge.2)then
            scm = dsqrt((xcm(ient)-xcm(jent))**2 
     +               + (ycm(ient)-ycm(jent))**2)
            if(scm.lt.scoh)then
c
c the cm platelets ient and jent are close enough to make linking a
c possibility.  
c
c check their state: non-linked or linked.
c
c if both linked, see if they are already linked to one-another.
c
c see also if the separation between the closest (unlinked) points 
c on the two platelets is small enough for a link to form.
c
        if(categor(ient).eq.(3).and.categor(jent).eq.(3))then
c
c both platelets are linked, see if they are already linked to
c one another.
c
             nsmall = min0(ient,jent)
             nbig   = max0(ient,jent)
             nwhere=((nbig-2)*(nbig-1))/2 + nsmall
             if(numlink(nwhere).ge.maxlink)goto 190
        endif
c
c compute gap between nearest unlinked points on the two platelets.
c
             i1=firstb(ient)
             i2=lastb (ient)
             ni=i2-i1+1
             j1=firstb(jent)
             j2=lastb (jent)
             nj=j2-j1+1
             imin=0
             jmin=0
             smin=1000.D+00
             do 70 ic=1,ni
                i=i1 + ic - 1
             if(status(i+1).eq.0)then
                xi=xb(2*i-1)
                yi=xb(2*i  )
             do 60 jc=1,nj
                j=j1 + jc - 1
             if(status(j+1).eq.0)then
                xj=xb(2*j-1)
                yj=xb(2*j  )
                sdist =dsqrt((xi-xj)**2 + (yi-yj)**2)
                if(sdist.lt.smin)then
                     smin=sdist
                     imin=ic
                     jmin=jc
                endif
             endif
 60          continue    
             endif
 70          continue
c
             if(smin.lt.scgap)then
c
c form link between point imin on ient and point jmin on jent
c
                ilink =lkas
                if(ient.lt.jent)then
                  p1(lkas)=ient
                  r1(lkas)=imin
                  p2(lkas)=jent
                  r2(lkas)=jmin
                else
                  p1(lkas)=jent
                  r1(lkas)=jmin
                  p2(lkas)=ient
                  r2(lkas)=imin
                endif
c
                stiffb(lkas)=stiffc
                sbreak(lkas)=sbreakc
                restb (lkas)=rlinkc
c
             status(firstb(ient)+imin)=1
             status(firstb(jent)+jmin)=1
c
             if(categor(ient).eq.(3).and.categor(jent).eq.(3))then
                write(6,* )' COHERE     LL'
c
c both are already linked, just update link-data structure
c
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((p2(ilink)-2)*(p2(ilink)-1))/2 + p1(ilink)
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
                  write(6 ,31)ient,imin,jent,jmin,scm,smin
                  write(16,31)ient,imin,jent,jmin,scm,smin
c
             elseif(categor(ient).eq.(2).and.categor(jent).eq.(3))then
c
                write(6,* )' COHERE     AL'
c
c jent is already linked, ient is not linked.  change category of 
c ient and update link-data structure
c
                  write(6 ,31)ient,imin,jent,jmin,scm,smin
                  write(16,31)ient,imin,jent,jmin,scm,smin
                  categor(ient)=3
                  call chgcate(listf,listb,ient,pac,pzac,pl,pzl)
                  ilink =lkas
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((p2(ilink)-2)*(p2(ilink)-1))/2 + p1(ilink)
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
c
             elseif(categor(ient).eq.(3).and.categor(jent).eq.(2))then
c
                write(6,* )' COHERE     LA'
c
c jent is already linked, ient is not linked.  change category of 
c ient and update link-data structure
c
                  write(6 ,31)ient,imin,jent,jmin,scm,smin
                  write(16,31)ient,imin,jent,jmin,scm,smin
                  categor(jent)=3
                  call chgcate(listf,listb,jent,pac,pzac,pl,pzl)
                  ilink=lkas
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((p2(ilink)-2)*(p2(ilink)-1))/2 + p1(ilink)
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
c
             elseif(categor(ient).eq.(2).and.categor(jent).eq.(2))then
c
                write(6,* )' COHERE     AA'
c
c neither is linked.
c
                  write(6 ,31)ient,imin,jent,jmin,scm,smin
                  write(16,31)ient,imin,jent,jmin,scm,smin
                  categor(ient)=3
                  categor(jent)=3
                  call chgcate(listf,listb,ient,pac,pzac,pl,pzl)
                  call chgcate(listf,listb,jent,pac,pzac,pl,pzl)
                  ilink =lkas
                  call chgcate(listlkf,listlkb,ilink,lkas,lkzas,
     +                         lkl,lkzl)
                  nwhere=((p2(ilink)-2)*(p2(ilink)-1))/2 + p1(ilink)
                  if(numlink(nwhere).eq.0)then
c
c this link results in a new pair of coherent entities
c update coherent pair data structure
c
                     cpflag=1
                     i=nas
                     pltlnk(i)=jent
                     call chgcate(nxtlnkf,nxtlnkb,i,nas,nzas,
     +                  fstlnk(ient),lstlnk(ient))
                     j=nas
                     pltlnk(j)=ient
                     call chgcate(nxtlnkf,nxtlnkb,j,nas,nzas,
     +                  fstlnk(jent),lstlnk(jent))
                  endif
                  numlink(nwhere)=numlink(nwhere)+1
                  nlink=nlink+1
             endif
            endif
         endif
         endif
 190     continue
      endif
 200  continue   
c
   31 format('  cohere   ient=',i5,' imin=',i5,' jent=',i5,' jmin=',i5,
     +       ' scm =',f13.7,' smin=',f13.7)
      write(6,*)' cohere nlink=',nlink
c
       return
       end
c
      subroutine remove(cpflag,nring)
c
c this subroutine determines whether any platelet should be removed
c at the downstream end of the domain.
c the determination is based on the location of the platelet's
c center of mass.
c
c this subroutine also determines which links should be broken
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'links.inc'
      include 'domain.inc'
      include 'plat.inc'
c
c  global variables
c
      integer cpflag,nring
c
      integer i,ient,i1,is
      integer j,j1,j2
      integer lp,update,lps,np1,np2,npp,nwhere
c
c  local variables
c
      double precision sdist,smin
      double precision x1,x2,y1,y2
      double precision xp1,xp2,xremov
c
c
      xremov = xmax - 1.0D+00*diam
c
c next determine whether any nonactivated or activated, but
c not linked, platelets have xcm greater than xremov.
c if so, the platelet should be removed.
c
      do 20 ient=1,ment
      if(xcm(ient).gt.xremov)then
        if(categor(ient).eq.1.D+00)then
c
c remove this nonactivated platelet
c
           call chgcatb(listf,listb,ient,pua,pzua,pas,pzas)
           categor(ient)=0
           nent=nent-1
c
        elseif(categor(ient).eq.2)then
c
c remove this activated platelet
c
           call chgcatb(listf,listb,ient,pac,pzac,pas,pzas)
           categor(ient)=0
           nent=nent-1
        endif
      endif
 20   continue
c
c now check whether any linked platelet should be removed
c
c initialize changes array to 1
c
      do 30 j=1,ment
      changes(j)=1
 30   continue
c
c set changes=2 for any platelet which is currently linked.
c
      smin=10000.D+00
      lp=lkl
 35   continue
      if(lp.eq.0)go to 40
      changes(p1(lp))=2
      changes(p2(lp))=2
      lp=listlkf(lp)
      goto 35
 40   continue
c
c now sweep through the list of links.
c
      lp=lkl
 50   continue
c
      update = 0
      if(lp.eq.0)go to 210
      lps=listlkf(lp)
      np1=p1(lp)
      np2=p2(lp)
c
      if(categor(np1).eq.(-1))then
c
c link is a platelet-wall link
c
      xp2=xcm(np2)
      changes(np1)=1
c
c compute length of link
c
      j1 = firstb(np1)+r1(lp)-1
      j2 = firstb(np2)+r2(lp)-1
      x1 = xb(2*j1-1)
      y1 = xb(2*j1  )
      x2 = xb(2*j2-1)
      y2 = xb(2*j2  )
      sdist  = dsqrt((x1-x2)**2 + (y1-y2)**2)
      smin=dmin1(smin,sdist/sbreak(lp))
c
      if(xp2.gt.xremov)then
c
c np2 is beyond xremov:
c if not already changed, change category for np2 to as.
c set changes(np2)=3.
c leave changes(np1)=2.
c
          update=1
          status(firstb(np1)+r1(lp))=0
          if(changes(np2).ne.3)then
              categor(np2)=0
              call chgcatb(listf,listb,np2,pl,pzl,pas,pzas)
              nent=nent-1
              changes(np2)=3
              i1 = firstb(np2)
              do 58 j=1,nring
                 status(i1+j)=0
 58           continue
          endif
c
      elseif(sdist.gt.sbreak(lp))then
c
c length is greater than breaking length.
c break the link but do not remove the platelet
c
         status(j1+1)=0
         status(j2+1)=0
         update=1
      else
c
c platelet is not beyond xremov and tension is not 
c great enough to break the link.
c leave this link alone.
c
         changes(np2)=1
      endif
c
      else
c
c link is a platelet-platelet link
c
      xp1=xcm(np1)
      xp2=xcm(np2)
c
c compute length of link
c
      j1 = firstb(np1)+r1(lp)-1
      j2 = firstb(np2)+r2(lp)-1
      x1 = xb(2*j1-1)
      y1 = xb(2*j1  )
      x2 = xb(2*j2-1)
      y2 = xb(2*j2  )
      sdist  = dsqrt((x1-x2)**2 + (y1-y2)**2)
c
c check whether either of xp1 or xp2 is greater than xremov.  
c if so, break the link.
c
      if(xp1.gt.xremov.and.xp2.gt.xremov)then
c
c both are greater than xremov.
c
c if not already changed, change category for both platelets
c to as, update listf and categor; and set changes to 3
c
          update=1
          if(changes(np1).ne.3)then
              categor(np1)=0
              call chgcatb(listf,listb,np1,pl,pzl,pas,pzas)
              nent=nent-1
              changes(np1)=3
              i1 = firstb(np1)
              do 105 j=1,nring
                 status(i1+j)=0
 105          continue
          endif
c
          if(changes(np2).ne.3)then
              categor(np2)=0
              call chgcatb(listf,listb,np2,pl,pzl,pas,pzas)
              nent=nent-1
              changes(np2)=3
              i1 = firstb(np2)
              do 106 j=1,nring
                 status(i1+j)=0
 106          continue
          endif
c
      elseif(xp1.gt.xremov)then
c
c only np1 is beyond xremov:
c if not already changed, change category for np1 to as.
c set changes(np1)=3.
c leave changes(np2)=2.
c
          update=1
          status(firstb(np2)+r2(lp))=0
          if(changes(np1).ne.3)then
              categor(np1)=0
              call chgcatb(listf,listb,np1,pl,pzl,pas,pzas)
              nent=nent-1
              changes(np1)=3
              i1 = firstb(np1)
              do 107 j=1,nring
                 status(i1+j)=0
 107          continue
          endif
c
      elseif(xp2.gt.xremov)then
c
c only np2 is beyond xremov:
c if not already changed, change category for np2 to as.
c set changes(np2)=3.
c leave changes(np1)=2.
c
          update=1
          status(firstb(np1)+r1(lp))=0
          if(changes(np2).ne.3)then
              categor(np2)=0
              call chgcatb(listf,listb,np2,pl,pzl,pas,pzas)
              nent=nent-1
              changes(np2)=3
              i1 = firstb(np2)
              do 108 j=1,nring
                 status(i1+j)=0
 108          continue
          endif
c
      elseif(sdist.gt.sbreak(lp))then
c
c length is greater than breaking length.
c break the link but do not remove the platelets
c
         status(j1+1)=0
         status(j2+1)=0
         update=1
      else
c
c neither is beyond xremov and tension is not great enough
c to break the link.
c leave this link alone.
c
         changes(np1)=1
         changes(np2)=1
      endif
c
c end of if-then for wall-plt or plt-plt links
      endif
c
      if(update.eq.1)then
c
c update the link data structure: 
c      remove link lp. 
c      update p1,p2, and listlk.
c      update numlink
c      reduce nlink by 1
c
         nwhere=((p2(lp)-2)*(p2(lp)-1))/2 + p1(lp)
         np1=p1(lp)
         np2=p2(lp)
         p1(lp)=0
         p2(lp)=0
         r1(lp)=0
         r2(lp)=0
         call chgcatb(listlkf,listlkb,lp,lkl,lkzl,lkas,lkzas)
         numlink(nwhere)=numlink(nwhere)-1
         nlink=nlink-1
         if(numlink(nwhere).eq.0)then
c
c update coherent-pair data structure to reflect loss of pair
c
c remove np2 from np1's list
c
            cpflag=1
            i=fstlnk(np1)
            if(i.eq.0)goto 120
 110        continue
            is=nxtlnkf(i)
            if(pltlnk(i).eq.np2)then
              call chgcatb(nxtlnkf,nxtlnkb,i,fstlnk(np1),
     +             lstlnk(np1),nas,nzas)
              pltlnk(i)=0
              goto 120
            endif
            i=is
            goto 110
 120        continue
c
c remove np1 from np2's list
c
            i=fstlnk(np2)
            if(i.eq.0)goto 140
 130        continue
            is=nxtlnkf(i)
            if(pltlnk(i).eq.np1)then
              call chgcatb(nxtlnkf,nxtlnkb,i,fstlnk(np2),
     +             lstlnk(np2),nas,nzas)
              pltlnk(i)=0
              goto 140
            endif
            i=is
            goto 130
 140        continue
         endif
      endif
      lp=lps
      goto 50
  210 continue
c
c if changes(ient)=2,then categor(ient) should be 
c changed to 2 (activated).
c
      do 250 npp=1,ment
          if(changes(npp).eq.2)then
c
c this is a platelet which is in the domain but which is linked 
c to no other platelet.
c
               categor(npp)=2
               call chgcate(listf,listb,npp,pl,pzl,pac,pzac)
           endif
  250 continue
c
c      write(16,*)' remove    smin=',smin
      return
      end
c
      subroutine cmass
c
c this subroutine computes the center of mass for each ring in
c the the domain
c
      implicit none
c
c  global commons
c
      include 'ibp.inc'
c
c  local variables
c
      integer i,i1,i2,ient
c
c compute centers of mass (cm) for all platelet rings present
c in the domain
c
      do 10 ient=1,ment
         xcm(ient) = 0.0D+00
         ycm(ient) = 0.0D+00
         if(categor(ient).ge.1)then
            i1 = firstb(ient)
            i2 = lastb (ient)
            do 5 i=i1,i2
               xcm(ient) = xcm(ient) + xb(2*i-1)
               ycm(ient) = ycm(ient) + xb(2*i  )
 5          continue
            xcm(ient) = xcm(ient)/dble(i2-i1+1)
            ycm(ient) = ycm(ient)/dble(i2-i1+1)
         endif
 10      continue
         return
         end
c
      subroutine create(nring)
c
c this subroutine inserts new platelets at the upstream end
c of the computational domain.
c at present, we wish to achieve what would be a uniform 
c distribution of y-coordinates in the domain if the
c flow field were to remain parabolic.  to do this we
c use an insertion scheme with a parabolic distribution
c in y.  the scheme is also derived under the assumption that 
c the 2d flux should equal the real 3d flux.
c
      implicit none
c
c  global common variables
c
      include 'ibp.inc'
      include 'links.inc'
      include 'domain.inc'
      include 'fluid.inc'
      include 'plat.inc'
c
      integer nring
c
c  local variables
c
      integer i,i1,j,jc,jent,jx,jy,k
      integer kcount,ktry
      double precision ang,b,bprim,delta,ran1
      double precision eplat,fiy
      double precision sdiff,width,x,xdiff
      double precision y,ydiff
      double precision yleast,ymost,yn,yo,zran
      double precision poissn(4),xnew(4),ynew(4)
c
      data xnew /0.0d0,0.0d0,0.0d0,0.0d0/
      data ynew /0.0d0,0.0d0,0.0d0,0.0d0/
c
c platelet creation parameters
c
      eplat=fluxx*pdens*dlt
c
      if(eplat.lt.0.0D+00)return
c
      poissn(1)=dexp(-eplat)
      poissn(2)=poissn(1)*(1.D+00+ eplat)
      poissn(3)=poissn(1)*(1.D+00+ eplat + eplat*eplat/2.D+00)
      poissn(4)=poissn(3)+poissn(1)*(eplat*eplat*eplat)/6.D+00
c
      width=ytop-ybot
      ang=8.0D+00*datan(1.0D+00)/dble(nring)
      yleast = ybot + .70D+00*diam
      ymost  = ytop - .70D+00*diam
c 
      delta=1.0d-4
      kcount=0
c
      zran = ran1()
      if(zran.le.poissn(1))then
         k=0
      elseif(zran.le.poissn(2))then
         k=1
      elseif(zran.le.poissn(3))then
         k=2
      elseif(zran.le.poissn(4))then
         k=3
      else
         k=4
      endif
      write(6,*)' create k=',k
c
c see if one or more new platelets should be created.
c
      if(k.ge.1)then
c
      do 100 j=1,k
c
c   create a platelet
c
c   determine the y-coordinate of its center of mass.
c
      nent=nent+1
      if(nent.gt.ment)then
           write(16,1)nent
           stop 1
      endif
c
c use newton's method to determine y-coordinate of new platelet.
c
      ktry = 0
 3    continue
      ktry = ktry + 1
      if(ktry.gt.10)then
         write(6,*)' create:  could not fit new one'
         nent=nent-1
         goto 100
      endif
      kcount=0
      fiy=ran1()
           write(6,*)' fiy=',fiy
      yo=.5D+00*(ytop+ybot)
 5    continue
      zran=(yo-ybot)/width
      b=(zran**2)*(3.D+00-2.D+00*zran)-fiy
      bprim=6.D+00*zran*(1.D+00-zran)/width
      yn=yo - b/bprim
      if(dabs(yn-yo).lt.delta) go to 7
      yo=yn
      kcount=kcount+1
      if(kcount.gt.20)then
           write(6,*)' Newton failure kcount=',kcount
           go to 3
      endif
      go to 5
 7    continue
c
c newton's method converged
c
      y=yn
c
c see if platelet ring will be inside tube
c
      if(y.lt.yleast.or.y.gt.ymost)then
            write(6,*)' yleast/ymost   y=',y
            go to 3
      endif
c
c determine x-coordinate of platelet's center of mass
c
      x= .75D+00*diam + xmin
c
c see if platelet overlaps with an existing platelet
c
      do 50 jent=1,ment
         if(categor(jent).ge.1)then
            xdiff=xcm(jent)-x
            ydiff=ycm(jent)-y
            sdiff=dsqrt(xdiff**2 + ydiff**2)
            if(sdiff.le.(1.25D+00*diam))then
               write(6,*)' overlap    sdiff=',sdiff
               goto 3
            endif
         endif
 50   continue
      if(k.ge.2)then
      do 55 i=1,j-1
         xdiff=xnew(i)-x
         ydiff=ynew(i)-y
         sdiff=dsqrt(xdiff**2 + ydiff**2)
         if(sdiff.le.(1.25D+00*diam))then
            write(6,*)' overlap    sdiff=',sdiff
            goto 3
         endif
 55   continue
      endif
      xnew(j)=x
      ynew(j)=y
c
c assign to the new platelet the number of the first as, pas, 
c and put this platelet number at the end of unactivated category ua.
c
      i=pas
      write(6,*)' create     pas=',pas
c
c create unactivated platelets
c
c      call chgcate(listf,listb,i,pas,pzas,pua,pzua)
c      categor(i)=1
c
c create activated platelets
c
      call chgcate(listf,listb,i,pas,pzas,pac,pzac)
      categor(i)=2
c
c assign the locations of the points on the platelet ring
c
      write(6,*)' CREATE   x=',x,'      y=',y
      write(16,*)' CREATE   x=',x,'      y=',y
      i1=firstb(i)
      do 30 jc=1,nring
         jy = 2*(i1+jc-1)
         jx = jy - 1
         xb(jx) = x + .5D+00*diam*dcos(ang*dble(jc-1))
         xb(jy) = y + .5D+00*diam*dsin(ang*dble(jc-1))
         status(i1+jc)=0
 30   continue
c
 100  continue
      endif
      write(6,*)' create nent=',nent
c
    1 format(//,5x,'create   nent too big  nent=',i5)
      return
      end
c
c
      subroutine height(last1,last2)
c
c determine heights of wall bound aggregates
c
      implicit none
c
c  global commons
c
      include 'domain.inc'
      include 'ibp.inc'
      include 'plat.inc'
c
c  global variables
c
      integer last1,last2
c
c  local variables
c
      integer j
      double precision hbot,htop
c
      write(16,*)' ******* height'
c
c bottom wall
c
      hbot = -1000.d0
      if(last1.gt.1)then
         do 10 j=2,last1
            hbot=dmax1(hbot,ycm(wallbnd(j))-ybot)
 10      continue
         hbot = hbot + .5d0*diam
         write(16,*)' hbot=',hbot
      endif
c
c top wall
c
      htop = -1000.d0
      if(last2.gt.(last1+1))then
         do 20 j=last1+2,last2
            htop=dmax1(htop,ytop-ycm(wallbnd(j)))
 20      continue
         htop = htop + .5d0*diam
         write(16,*)' htop=',htop
      endif        

      return
      end
c
      function ran1()
c
c from Numerical Recipes (Press, Flannery, Teukoslsky, and Vetterling)
c page 196.
c
c returns a uniform random variable between 0.0 and 1.0
c
c set idum to any NEGATIVE value to initialize or re-initialize
c the sequence
c
      integer ia1,ia2,ia3,ic1,ic2,ic3,idum,iff,ix1,ix2,ix3
      integer j,m1,m2,m3
c
      double precision rp1,ran1,rm1,rm2
c
      common/fffff/iff,idum
      common/random/ rp1(97),ix1,ix2,ix3

      parameter(m1=259200,ia1=7141,ic1=54773,rm1=1.D+00/m1)
      parameter(m2=134456,ia2=8121,ic2=28411,rm2=1.D+00/m2)
      parameter(m3=243000,ia3=4561,ic3=51349)

c     data iff/0/
      save
c
      if(idum.lt.(0).or.iff.eq.(0))then
        iff=1
        ix1=mod(ic1-idum,m1)
        ix1=mod(ia1*ix1+ic1,m1)
        ix2=mod(ix1,m2)
        ix1=mod(ia1*ix1+ic1,m1)
        ix3=mod(ix1,m3)
c
        do 11 j=1,97
           ix1=mod(ia1*ix1+ic1,m1)
           ix2=mod(ia2*ix2+ic2,m2)
           rp1(j) = (dble(ix1)+dble(ix2)*rm2)*rm1
 11     continue
        idum = 1
      endif
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j = 1 + (97*ix3)/m3
      if(j.gt.(97).or.j.lt.(1))then
           write(6,*)' ran1    oops!   j=',j
           stop
      endif
      ran1 = rp1(j)
      rp1(j) = (dble(ix1)+dble(ix2)*rm2)*rm1
      return
      end

      double precision function ran1p()
c
c from Numerical Recipes (Press, Flannery, Teukoslsky, and Vetterling)
c page 196.
c
c returns a uniform random variable between 0.0 and 1.0
c
c set idum to any NEGATIVE value to initialize or re-initialize
c the sequence
c
      integer ia1,ia2,ia3,ic1,ic2,ic3,idump,iffp
      integer ix1p,ix2p,ix3p,j,m1,m2,m3
c
      double precision rm1,rm2,rp
c
      common/fffffp/iffp,idump
      common/randomp/ rp(97),ix1p,ix2p,ix3p
      parameter(m1=259200,ia1=7141,ic1=54773,rm1=1.D+00/m1)
      parameter(m2=134456,ia2=8121,ic2=28411,rm2=1.D+00/m2)
      parameter(m3=243000,ia3=4561,ic3=51349)
c     data iffp/0/
      save
c
      if(idump.lt.(0).or.iffp.eq.(0))then
        iffp=1
        ix1p=mod(ic1-idump,m1)
        ix1p=mod(ia1*ix1p+ic1,m1)
        ix2p=mod(ix1p,m2)
        ix1p=mod(ia1*ix1p+ic1,m1)
        ix3p=mod(ix1p,m3)
c
        do 11 j=1,97
           ix1p=mod(ia1*ix1p+ic1,m1)
           ix2p=mod(ia2*ix2p+ic2,m2)
           rp(j) = (dble(ix1p)+dble(ix2p)*rm2)*rm1
 11     continue
        idump = 1
      endif
      ix1p=mod(ia1*ix1p+ic1,m1)
      ix2p=mod(ia2*ix2p+ic2,m2)
      ix3p=mod(ia3*ix3p+ic3,m3)
      j = 1 + (97*ix3p)/m3
      if(j.gt.(97).or.j.lt.(1))then
           write(6,*)' ran1p    oops!   j=',j
           stop
      endif
      ran1p = rp(j)
      rp(j) = (dble(ix1p)+dble(ix2p)*rm2)*rm1
      return
      end
c
c NOTE:  put call cmass before call rw.
c
      subroutine rw
c
c platelet random walk
c
      implicit none
c
c  global commons
c
      include 'ibp.inc'
      include 'domain.inc'
      include 'plat.inc'
c
c  local variables
c
      integer i,i1,i2,ic,ient,j,j1,j2,jc,jent,ni,nj
      double precision aden,ang,anum
      double precision tpi,r1,r2
      double precision rad,radmax,ran1p,rg,wind
      double precision scmnom,s2vec1,s2vec2,scm
      double precision var,vec1x,vec1y,vec2x,vec2y
      double precision x,xi,xj,xjo
      double precision y,yi,yj,yjo
c
      tpi=8.D+00*datan(1.D+00)
      var=2.D+00*pltdif*dlt
c
      do 10 jent=1,ment
      if((categor(jent)-1)*(categor(jent)-2).eq.0)then
c
c calculate radius of platelet
c
         radmax=0.0D+00
         i1 = firstb(jent)
         i2 = lastb (jent)
         do 5 i=i1,i2
            rad=dsqrt((xcm(jent)-xb(2*i-1))**2 +
     +                (ycm(jent)-xb(2*i  ))**2)
            radmax=max(radmax,rad)
 5       continue
         radius(jent)=radmax
      endif
 10   continue

c
      do 20 jent=1,ment
      if((categor(jent)-1)*(categor(jent)-2).eq.0)then
c
c calculate the random step from a truncated symmetric
c gaussian distribution with standard deviation sqrt(var)
c
         r1=max(ran1p(),1.d-8)
         r2=ran1p()
         rg=dsqrt(-2.D+00*var*dlog(r1))
         ranx(jent) = rg*dcos(tpi*r2)
         rany(jent) = rg*dsin(tpi*r2)
         xcm (jent) = xcm(jent) + ranx(jent)
         ycm (jent) = ycm(jent) + rany(jent)
         i1 = firstb(jent)
         i2 = lastb (jent)
         do 15 i=i1,i2
            xb(2*i-1)=xb(2*i-1) + ranx(jent)
            xb(2*i  )=xb(2*i  ) + rany(jent)
 15      continue
      endif
 20   continue
c
      do 200 ient=1,ment
      if((categor(ient)-1)*(categor(ient)-2).eq.0)then
         do 190 jent=ient+1,ment
         if((categor(jent)-1)*(categor(jent)-2).eq.0)then
c
c compute separation between the centers of mass
c
            scm = dsqrt((xcm(ient)-xcm(jent))**2
     +                + (ycm(ient)-ycm(jent))**2)
            scmnom=radius(ient)+radius(jent)
            if(scm.lt.scmnom)then
c
c separation between centers of mass is close enough that overlap may
c have occured -- test using winding numbers:  if |wind| = 1, then
c rings overlap.
c
                i1=firstb(ient)
                i2=lastb (ient)
                ni=i2-i1+1
                j1=firstb(jent)
                j2=lastb (jent)
                nj=j2-j1+1
c
 30             continue
                do 70 ic=1,ni
                   i=i1 + ic - 1
                   xi=xb(2*i-1)
                   yi=xb(2*i  )
                   wind=0.0D+00
                   jc=1
                   j= j1 + jc - 1
                   xjo= xb(2*j-1)
                   yjo= xb(2*j  )
                   do 60 jc=2,nj
                      j=j1 + jc - 1
                      xj=xb(2*j-1)
                      yj=xb(2*j  )
                      vec1x=xjo-xi
                      vec1y=yjo-yi
                      vec2x=xj -xi
                      vec2y=yj -yi
                      s2vec1=vec1x**2 + vec1y**2
                      s2vec2=vec2x**2 + vec2y**2
                      anum = vec1x*vec2y - vec1y*vec2x
                      aden = dsqrt(s2vec1*s2vec2)
                      ang = dasin(anum/aden)
                      wind = wind + ang/tpi
                      xjo=xj
                      yjo=yj
 60                continue
                   jc=1
                   j= j1 + jc - 1
                   xj= xb(2*j-1)
                   yj= xb(2*j  )
                   vec1x=xjo-xi
                   vec1y=yjo-yi
                   vec2x=xj -xi
                   vec2y=yj -yi
                   s2vec1=vec1x**2 + vec1y**2
                   s2vec2=vec2x**2 + vec2y**2
                   anum = vec1x*vec2y - vec1y*vec2x
                   aden = dsqrt(s2vec1*s2vec2)
                   ang = dasin(anum/aden)
                   wind = wind + ang/tpi
c
                   if(dabs(wind).gt.0.5D+00)then
                      write(16,1001)jent,ient
c
c overlap detected, backstep on random steps for rings ient and jent
c
                      i1 = firstb(jent)
                      i2 = lastb (jent)
                      xcm(jent)=xcm(jent)  - .25D+00*ranx(jent)
                      ycm(jent)=ycm(jent)  - .25D+00*rany(jent)
                      do 45 i=i1,i2
                         xb(2*i-1)=xb(2*i-1) - .25D+00*ranx(jent)
                         xb(2*i  )=xb(2*i  ) - .25D+00*rany(jent)
 45                   continue
                      i1 = firstb(ient)
                      i2 = lastb (ient)
                      xcm(ient)=xcm(ient)  - .25D+00*ranx(ient)
                      ycm(ient)=ycm(ient)  - .25D+00*rany(ient)
                      do 50 i=i1,i2
                         xb(2*i-1)=xb(2*i-1) - .25D+00*ranx(ient)
                         xb(2*i  )=xb(2*i  ) - .25D+00*rany(ient)
 50                   continue
                      goto 30
                   endif
 70             continue
            endif
c
c no overlap detected between jent and ient
c
         endif
 190     continue
      endif
 200  continue
c
c check for overlap with walls
c
      do 500 jent=1,ment
      if((categor(jent)-1)*(categor(jent)-2).eq.0)then
         x=xcm(jent)
         y=ycm(jent)
c
c assume flat walls (modify for stenotic or bifurcating walls
c
         if    (y-radius(jent).le.ybot)then
            ient=1
c
c find points on wall close to platelet
c
            i1=firstb(ient)
            i2=lastb (ient)
            ni=i2-i1+1
            do 310 ic=1,ni
               i=i1 + ic - 1
               xi=xb(2*i-1)
               if(xi.gt.x)then
                  i1=max0(i1,i-10)
                  i2=min0(i2,i+10)
                  goto 311
               endif
 310        continue
 311        continue
            ni=i2-i1+1
            j1=firstb(jent)
            j2=lastb (jent)
            nj=j2-j1+1
            do 350 ic=1,ni
                i=i1 + ic - 1
                xi=xb(2*i-1)
                yi=xb(2*i  )
 315            continue
                wind=0.0D+00
                jc=1
                j= j1 + jc - 1
                xjo= xb(2*j-1)
                yjo= xb(2*j  )
                do 330 jc=2,nj
                   j=j1 + jc - 1
                   xj=xb(2*j-1)
                   yj=xb(2*j  )
                   vec1x=xjo-xi
                   vec1y=yjo-yi
                   vec2x=xj -xi
                   vec2y=yj -yi
                   s2vec1=vec1x**2 + vec1y**2
                   s2vec2=vec2x**2 + vec2y**2
                   anum = vec1x*vec2y - vec1y*vec2x
                   aden = dsqrt(s2vec1*s2vec2)
                   ang = dasin(anum/aden)
                   wind = wind + ang/tpi
                   xjo=xj
                   yjo=yj
 330            continue
                jc=1
                j= j1 + jc - 1
                xj= xb(2*j-1)
                yj= xb(2*j  )
                vec1x=xjo-xi
                vec1y=yjo-yi
                vec2x=xj -xi
                vec2y=yj -yi
                s2vec1=vec1x**2 + vec1y**2
                s2vec2=vec2x**2 + vec2y**2
                anum = vec1x*vec2y - vec1y*vec2x
                aden = dsqrt(s2vec1*s2vec2)
                ang = dasin(anum/aden)
                wind = wind + ang/tpi
c
                if(dabs(wind).gt.0.5D+00)then
c
c overlap detected, backstep on random step for ring jent
c
                      i1 = firstb(jent)
                      i2 = lastb (jent)
                      xcm(jent)=xcm(jent)  - .25D+00*ranx(jent)
                      ycm(jent)=ycm(jent)  - .25D+00*rany(jent)
                      do 345 i=i1,i2
                         xb(2*i-1)=xb(2*i-1) - .25D+00*ranx(jent)
                         xb(2*i  )=xb(2*i  ) - .25D+00*rany(jent)
 345                  continue
                      goto 315
                endif
 350        continue
c
         elseif(y+radius(jent).ge.ytop)then
            ient=2
c
c find points on wall close to platelet
c
            i1=firstb(ient)
            i2=lastb (ient)
            ni=i2-i1+1
            do 410 ic=1,ni
               i=i1 + ic - 1
               xi=xb(2*i-1)
               if(xi.gt.x)then
                  i1=max0(i1,i-10)
                  i2=min0(i2,i+10)
                  goto 411
               endif
 410        continue
 411        continue
            ni=i2-i1+1
            j1=firstb(jent)
            j2=lastb (jent)
            nj=j2-j1+1
            do 450 ic=1,ni
                i=i1 + ic - 1
                xi=xb(2*i-1)
                yi=xb(2*i  )
 415            continue
                wind=0.0D+00
                jc=1
                j= j1 + jc - 1
                xjo= xb(2*j-1)
                yjo= xb(2*j  )
                do 430 jc=2,nj
                   j=j1 + jc - 1
                   xj=xb(2*j-1)
                   yj=xb(2*j  )
                   vec1x=xjo-xi
                   vec1y=yjo-yi
                   vec2x=xj -xi
                   vec2y=yj -yi
                   s2vec1=vec1x**2 + vec1y**2
                   s2vec2=vec2x**2 + vec2y**2
                   anum = vec1x*vec2y - vec1y*vec2x
                   aden = dsqrt(s2vec1*s2vec2)
                   ang = dasin(anum/aden)
                   wind = wind + ang/tpi
                   xjo=xj
                   yjo=yj
 430            continue
                jc=1
                j= j1 + jc - 1
                xj= xb(2*j-1)
                yj= xb(2*j  )
                vec1x=xjo-xi
                vec1y=yjo-yi
                vec2x=xj -xi
                vec2y=yj -yi
                s2vec1=vec1x**2 + vec1y**2
                s2vec2=vec2x**2 + vec2y**2
                anum = vec1x*vec2y - vec1y*vec2x
                aden = dsqrt(s2vec1*s2vec2)
                ang = dasin(anum/aden)
                wind = wind + ang/tpi
c
                if(dabs(wind).gt.0.5D+00)then
c
c overlap detected, backstep on random step for ring jent
c
                      i1 = firstb(jent)
                      i2 = lastb (jent)
                      xcm(jent)=xcm(jent)  - .25D+00*ranx(jent)
                      ycm(jent)=ycm(jent)  - .25D+00*rany(jent)
                      do 445 i=i1,i2
                         xb(2*i-1)=xb(2*i-1) - .25D+00*ranx(jent)
                         xb(2*i  )=xb(2*i  ) - .25D+00*rany(jent)
 445                  continue
                      goto 415
                endif
 450        continue
c
         endif
      endif
 500  continue
 1001 format(' rw:  overlap   jent=',i4,' ient=',i4)
      return
      end
c
      subroutine wallagg(last1,last2)
c
c determine list of wall-bound platelets
c
      implicit none
c
c  global commons
c
      include 'ibp.inc'
      include 'links.inc'
      include 'plat.inc'
c
c  global variables
c
      integer last1,last2
c
c  local variables
c
      integer i,ient,is,j,jent,numbnd1,numbnd2
      integer pt1,pt2
c
c initialize
c
      do 5 j=1,ment
         visited(j)=0
         wallbnd(j)=0
 5    continue
c
c first bottom wall ient=1
c
      ient=1
      visited(ient)=1
      wallbnd(1   )=ient
      pt1=1
      pt2=2
 15   continue
      i=fstlnk(ient)
 20   continue
      if(i.eq.0)goto 30
      is=nxtlnkf(i)
      jent=pltlnk(i)
      if(visited(jent).eq.0)then
c
c check whether jent=2 (top wall)
c if so, do not add to list wallbnd
c
         if(jent.ne.2)then
            visited(jent)=1
            wallbnd(pt2 )=jent
            pt2=pt2+1
         endif
      endif
      i=is
      goto 20
 30   continue
      pt1=pt1+1
      if(pt1.eq.pt2)goto 40
      ient=wallbnd(pt1)
      goto 15
 40   continue
c
c numbnd = pt1 - (1 since pt1 is past end of list) 
c              - (1 to account for wall itself)
c
      last1  =pt1-1
      numbnd1=pt1-2
c
c      do 45 j=1,ment
c         write(16,46)j,wallbnd(j),visited(j)
c 45   continue
c 46   format(' j=',i3,' wb=',i5,' v=',i5)
      write(16,*)' numbnd1=',numbnd1
c
c now top wall ient=2
c
      ient=2
      visited(ient)=1
      wallbnd(pt1) =ient
      pt2=pt2+1
 115  continue
      i=fstlnk(ient)
 120  continue
      if(i.eq.0)goto 130
      is=nxtlnkf(i)
      jent=pltlnk(i)
      if(visited(jent).eq.0)then
         visited(jent)=1
         wallbnd(pt2 )=jent
         pt2=pt2+1
      endif
      i=is
      goto 120
 130  continue
      pt1=pt1+1
      if(pt1.eq.pt2)goto 140
      ient=wallbnd(pt1)
      goto 115
 140  continue
c
c numbnd = pt1 - (1 since pt1 is past end of list) 
c              - (1 to account for wall itself)
c
      last2  =pt1-1
      numbnd2=pt1-2-last1
      write(16,*)' numbnd2=',numbnd2
c
c can also add more code to determine platelets
c in each distinct free-floating aggregate
c
      return
      end
