/* cross: returns e_3 \cdot (X1 \cross X2) */
float cross(float x1, float y1, float x2, float y2)
{
    return (x1*y2)-(y1*x2);
}

/* distance: computes the Euclidean distance between to points in R2 */
float distance (float x1, float y1, float x2, float y2)
{
   return sqrt( ((x1-x2)*(x1-x2)) + ((y1-y2)*(y1-y2)) );
}


/* fdash: finds the first occurence of '-' in s, or -1 if not found */
int fdash ( char s[] )
{
#if 0
    int i=0, fd=0;
    s[MAXLINE] = '-';
    while ( s[i++] != '-' ) fd++;
    if (fd == MAXLINE) fd = 0;
    s[MAXLINE] = ' ';
#else
    char *p;
    int fd;
    p = strchr(s,'-');
    fd = (p == (char*)NULL) ? -1 : (int)(p - &s[0]);
#endif
    return fd;
}


/* getnum: given the name of an entity, return its number */
int getnum( int name ){

    extern int IBact[MAXLINE][4];
    int i=0, get = 0;

    while ( get == 0 ){
        if (IBint[i][0]==name) get = i;
        if ( i > MAXLINE ) get=-1;
        i++;
    }

    return get;    
}

/* getline: get line into s, return length */
int getline( char s[], int lim, FILE *fp ){

  int c, i = 0;
  char slash[1];
      
  while (--lim > 0 && (c = getc(fp)) != EOF && c != '\n' )
    s[i++] = c;
  if ( c == '\n' )
    s[i++] = c;
  s[i] = '\0';

  return i;

}
/* getcommand: get IBIS command into s, return length */
int getcommand( char s[], int lim, FILE *fp ){

  int c, i = 0, j, k=0, kflag = 0, rflag = 0;
  char addline[MAXLINE],slash[4];

  slash[0] = '&';

/* get the first line */

  c = getline(addline,MAXLINE,fp);
  strcpy(s,addline);
  i = c;

/* check to see if there is a continuation */

  while (k < MAXLINE) {
    if (s[k] == '&'){
      rflag = 1;
      kflag = k;
      s[k] = ' ';
      k = MAXLINE;
    }
    k++;
  }

/* get the continued lines */

  if ( rflag == 1 ){
    rflag = 0;
    for (k=0; k<MAXLINE; k++) if (s[k] == '\n') s[k] = ' ';
    c = getline(addline,MAXLINE,fp);
    strcat(s,addline);
    i = i + c;
    k=0;
    while (k < MAXLINE) {
      if (s[k] == '&'){
        rflag = 1;
        kflag = k;
        s[k] = ' ';
        k = MAXLINE;
      }
      k++;
    }
  }
  return i;
}

/* wc: word counter for parser, return number of words */
int wc ( char s[] )

{
    int i=0, nw=0, state=0, c;

    while ( (c=s[i++]) != '\0' )
     {
      if ( c == '\n' || c == ' ' || c == '\t' )
        state = 0;
      else if ( state == 0 ) 
        {
          state = 1;
          ++nw;
        }
     }
    return nw;
}



