void main(int argc, char *argv[])
{
  FILE *fp, *fpb, *fpv, *fpe;
  char name[MAXLINE], fnmi[MAXLINE], fnmo[MAXLINE], char_work[MAXLINE],
       dash[10], base[10];
  char line[MAXLINE];
  int i, j=0, k, fnum = 2, tnum = 0, err = 0, c=0, flag=0, jcount;
  int fnmof = 0;

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];
  extern float defal[MAXLINE];
  extern char fluidf[MAXLINE];
  extern int optind;
  extern char *optarg;

  fpe = fopen("ibpts.log","w");
  fprintf (fpe,"error\n");
  fclose(fpe);

  if (argc == 1) err = 1;
  if ( err == 1 )
    {
      printf ("Usage: %s in_file \n\n",argv[0]);
      return;
    }

  if ( err == 0 )
    {
      if ((fp = fopen(*++argv,"r")) == NULL ) err = 2;
      if ( err == 2 ){
         printf ("Can't find the file %s\n", *argv );
         return;
        }
    }

  if ( err == 0 )
    {
      remove("ibisdat/ibpts.dat");
      remove("ibisdat/init.dat");
      remove("ibisdat/line0.dat");
      remove("ibisdat/link.dat");
      remove("ibisdat/visual.dat");
      remove("aux.ibis");
      fpv = fopen("ibisdat/visual.dat","w");
      fprintf (fpv,"%s\n", *argv );
      fclose(fpv);
      fpe = fopen("ibisdat/link.dat","w");
      fclose(fpe);

    }

  if ( err == 0 )
    {
       for (i=0; i<MAXLINE; i++) 
           { for (j=0; j<MAXARG; j++) IBint[i][j] = 0; }
       for (i=0; i<MAXLINE; i++) 
           { for (j=0; j<MAXARG; j++) IBdata[i][j] = 0.0; }
       for (i=0; i<MAXLINE; i++) defal[i] = 0.0;
       for (i=0; i<MAXLINE; i++) {
           IBact[i][0] = 0;
           IBact[i][1] = 0;
           IBact[i][2] = 0;
           IBact[i][3] = 0;
       }

       defal[1] = 40000.;            /* some default spring values */ 
       defal[2] = 40000.;
       defal[3] = 40000.;
       defal[4] = 0.0;
       defal[5] = 0.5;
       defal[11] = 4000.0;           /* circle elastic link defaults */
       defal[12] = 4000.0;
       defal[13] = 0.0;
       defal[14] = 0.0;
       defal[15] = 0.5;
       defal[21] = 0.0;              /* singlet elastic link defaults */
       defal[22] = 0.0;
       defal[23] = 0.0;
       defal[24] = 0.0;
       defal[25] = 0.0;
       defal[31] = 4000.0;           /* tube elastic link defaults */
       defal[32] = 4000.0;
       defal[33] = 400.0;
       defal[34] = 0.0;
       defal[35] = 0.5;
       defal[41] = 4000.0;           /* arc elastic link defaults */
       defal[42] = 4000.0;
       defal[43] = 0.0;
       defal[44] = 0.0;
       defal[45] = 0.4;
       defal[51] = 4000.0;           /* ray elastic link defaults */
       defal[52] = 4000.0;
       defal[53] = 400.0;
       defal[54] = 0.0;
       defal[55] = 0.5;
       defal[61] = 4000.0;           /* file elastic link defaults */
       defal[62] = 4000.0;
       defal[63] = 0.0;
       defal[64] = 0.0;
       defal[65] = 0.4;
       defal[71] = 4000.0;           /* line elastic link defaults */
       defal[72] = 4000.0;
       defal[73] = 400.0;
       defal[74] = 0.0;
       defal[75] = 0.5;
       defal[81] = 4000.0;           /* sine elastic link defaults */
       defal[82] = 4000.0;
       defal[83] = 400.0;
       defal[84] = 0.0;
       defal[85] = 0.4;
       defal[91] = 4000.0;           /* link elastic link defaults */
       defal[92] = 8.0;
       defal[95] = 1.0;
       IBint[0][1] = 2;            /* default fluid marker density */
       IBdata[1][5] = 1.0;         /* default inverse Reynolds number */
       IBdata[1][6] = 1.0;         /* default density */
       IBdata[2][7] = 0.0;         /* default initial velocity */
       IBdata[2][8] = 0.0;         /* default background x pressure gradient */
       IBdata[2][9] = 0.0;         /* default background y pressure gradient */

       IBint[0][8]  = 0;           /* filament counter */
       IBint[0][9]  = 0;           /* circle counter */
       IBint[0][10] = 0;           /* polygon counter */
       IBint[0][11] = 1000;        /* unused_names */

       sprintf(dash,"'");
       sprintf(base,"null");
       sprintf(fluidf,"%s%s%s",dash,base,dash);
       sprintf(partf,"%s%s%s",dash,base,dash);


    }


  if ( err == 0 )
    {
      IBint[1][3] = 4;

      getcommand(line,MAXLINE,fp);         /*  parse domain statement */
      sprintf(char_work,"domain");
      if ( strncmp(line,char_work,6) != 0 ) {
        err = err+1;
        printf ("\n*************** input error ***************\n");
        printf ("  First line is required to be domain \n\n");
        return;
      }      
      else
        err = err + pdomain(line);


      getcommand(line,MAXLINE,fp);         /*  parse grid statement */ 
      sprintf(char_work,"grid");
      if ( strncmp(line,char_work,4) != 0 ) {
        err = err+1;
        printf ("\n*************** input error ***************\n");
        printf ("  Second line is required to be grid \n\n");
        return;
      }      
      else
        err = err + pgrid(line);


      fpb = fopen("ibisdat/bbgons.dat","w");
      while ( getcommand(line,MAXLINE,fp) > 0)
       {
         flag = 0;
         fnum++;
         sprintf(name,"#            ");
         sscanf(line, "%s", name);

         if ( wc(line) == 0 )           /* allow for blank lines */
           {
             fnum--;
             flag = 1;
           }
         
         if ( name[0] == '#' )          /* allow for comment lines */
           {
             fnum--;
             flag = 1;
           }

         sprintf(char_work,"adhere");        /* parse the adhere statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             flag = 1;
             fnum--;
             err = err + padhere(line);
           }

         sprintf(char_work,"bforce");        /* parse the adhere statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             flag = 1;
             fnum--;
             err = err + pbforce(line);
           }

         sprintf(char_work,"cohere");        /* parse the cohere statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             flag = 1;
             fnum--;
             err = err + pcohere(line);
           }

         sprintf(char_work,"circle");        /* parse the circle statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             flag = 1;
             err = err + pcircle(line);
           }

         sprintf(char_work,"ellipse");        /* parse the ellipse statement */
         if ( strncmp(name,char_work,7) == 0 ) 
           {
             flag = 1;
             err = err + pellipse(line);
           }

         sprintf(char_work,"file");         /* parse the file statement */
         if ( strncmp(name,char_work,4) == 0 ) 
           {
             flag = 1;
             err = err + pfile(line,fpb);
           }

         sprintf(char_work,"fluid");         /* parse the fluid statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + pfluid(line);
           }

         sprintf(char_work,"graph");         /* parse the graph statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + pgraph(line);
           }

/*       sprintf(char_work,"itube");
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + pitube(line);
           }  */

         sprintf(char_work,"iwall");
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + pitube(line);
           }

         sprintf(char_work,"line");          /* parse the line statement */
         if ( strncmp(name,char_work,4) == 0 ) 
           {
             flag = 1;
             err = err + pline(line);
           }

         sprintf(char_work,"link");          /* parse the links statement */
         if ( strncmp(name,char_work,4) == 0 ) 
           {
             flag = 1;
             err = err + plink(line);
           }

         sprintf(char_work,"blink");          /* parse the links statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             flag = 1;
             err = err + pblink(line);
           }

         sprintf(char_work,"olink");          /* parse the links statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             flag = 1;
             err = err + polink(line);
           }

         sprintf(char_work,"slink");          /* parse the links statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             flag = 1;
             err = err + pslink(line);
           }

         sprintf(char_work,"particle");        /* parse the particle statement */
         if ( strncmp(name,char_work,8) == 0 ) 
           {
             flag = 1;
             fnum--;
             err = err + pparticle(line);
           }

         sprintf(char_work,"pfile");         /* parse the file statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             flag = 1;
             err = err + pfile(line,fpb);
           }

         sprintf(char_work,"platelet");        /* parse the platelet statement */
         if ( strncmp(name,char_work,8) == 0 ) 
           {
             flag = 1;
             fnum--;
             err = err + pplatelet(line);
           }

         sprintf(char_work,"poly");          /* parse the polygons */
         if ( strncmp(name,char_work,4) == 0 ) 
           {
             flag = 1;
             err = err + ppoly(line,fp,fpb) ;
           }

         sprintf(char_work,"singlet");          /* parse a singlet */
         if ( strncmp(name,char_work,7) == 0 ) 
           {
             flag = 1;
             err = err + psing(line);
           }

         sprintf(char_work,"source");         /* parse source statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + psource(line);
           }

         sprintf(char_work,"spring");         /* parse the spring statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             flag = 1;
             err = err + pspring(line);
           }

/*       sprintf(char_work,"tube");
 *       if ( strncmp(name,char_work,4) == 0 ) 
 *         {
 *           flag = 1;
 *           err = err + ptube(line);
 *         }
 */

         sprintf(char_work,"visual");        /* parse the visual statement */
         if ( strncmp(name,char_work,6) == 0 ) 
           {
             fnum--;
             flag = 1;
             err = err + pvisual(line);
           }

         sprintf(char_work,"wheel");         /* parse the spring statement */
         if ( strncmp(name,char_work,5) == 0 ) 
           {
             flag = 1;
             err = err + pwheel(line);
           }

         if ( flag == 0 )
           {
             ++fnum;
             ++err;
             printf ("\n*************** input error -");
             printf (" line number %d \n",fnum);
             printf ("Unknown statement;\n");
             printf ("    %s \n", line );
           }
       }
    }

  fclose(fpb);

  IBint[1][2] = 2*IBint[3][2];
  for ( i=4; i<=IBint[1][3]; i++ )
    {
      IBint[1][2] = IBint[1][2] + IBint[i][2];
    }

  if ( err == 0 )                           /* output the result table */
    {
      (void)wparm();                  /* write the parameter file */
      (void)wname();                  /* write the result */
      (void)wdat(fnum);               /* write the data file */
      /*      (void)wgraph();                  write the result */ 
      fpe = fopen("ibpts.log","w");
      fprintf (fpe,"success\n");
      fclose(fpe);
    }

  remove("ibisdat/bbgons.dat");
  return;

}
