/* ppoly: parses polygons, return status */

int ppoly ( char line[], FILE *fp, FILE *fpb )
{
  int err = 0, i = 0, j = 0, k;
  char name[100],sline[100], opt[10];
  float wrk, x1, x2, y1, y2, teth, dr;

  extern int IBint[MAXLINE][MAXARG];
  extern int IBact[MAXLINE][4];
  extern float IBdata[MAXLINE][MAXARG];

  IBint[1][3]++;
  i = IBint[1][3];
  IBint[i][1] = 6;                  /* defaults for global parms */
  IBdata[i][0]  = 0;
  IBint[0][10]++;
  IBint[i][4] = 0;

  while ((k=fdash(line)) >= 0){

    for (j=0; j<=MAXLINE - k; j++) line[j] = line[k+j];
    sscanf(line, "%s %e",opt, &dr);
    if ( opt[0] == '-' )
     {
      line[0] = ' ';
      switch (opt[1])              /* check to see if its active */
        {
          case 'A':                /* active elements */
            IBact[1][1]++;
            IBact[i][1] = 1;
            IBint[i][0] = dr;
            break;
          case 'N':                /* named elements */
            IBint[i][0] = dr;
            break;
          case '0': case '1': case '2': case '3': case '4':
          case '5': case '6': case '7': case '8': case '9':
            break;
          default:
            err = 1;
        }
     }
   }

  getcommand(line,MAXLINE,fp);         /*  parse first statement */ 
  err = err + pqfirst(i,line);

  getcommand(line,MAXLINE,fp);         /* get the second line */
  sscanf(line, "%s", name);
  while ( name[0] != 'e' )          /* parse until the end statement */
    {
      IBint[1][3]++;
      j = IBint[1][3];

      if ( wc(line) == 0 ){           /* allow for spaces */
             IBint[1][3]--;
        }
      else if ( name[0] == 'b' )     /* parse the bcurv statement */
        {
           IBint[i][4]++;
           err = err + pqarc(i,line,fp,fpb);
        }
      else if ( name[0] == 'c' )     /* parse the circular arc statement */
        {
           IBint[i][4]++;
           err = err + pqcarc(i,line,fp,fpb);
        }
      else if ( name[0] == 'r' )     /* parse the ray statement */
        {
           IBint[i][4]++;
           err = err + pqray(i,line,fpb);
        }
      else if ( name[0] == 's' )     /* parse the singlet statement */
        {
           IBint[i][4]++;
           err = err + pqsing(i,line,fpb);
        }
      else if ( name[0] == '#' )     /* allow for comments */
        {
           IBint[1][3]--;
        }
      else if ( name[0] == ' ' )     /* allow for blank lines */
        {
           IBint[1][3]--;
        }
      else                           /* mistake! */
        {
           err = err + 1;
        }

      IBint[i][2] = IBint[i][2] + IBint[j][2];
      getcommand(line,MAXLINE,fp);
      sscanf(line, "%s", name);

    }

  if ( err == 0 )
    {
      j = IBint[1][3];
      IBint[i][3] = 1;
      wrk = distance(IBdata[i][3],IBdata[i][4],IBdata[j][3],IBdata[j][4]);
      IBint[i][3] = 1;
      if ( wrk <= IBdata[2][6]/2 )     /* determine closure status    */
        { 
          x1 = IBdata[i+1][30];        /* compute connecting angle of */
          y1 = IBdata[i+1][31];        /* first and last segments */
          x2 = IBdata[j][32];
          y2 = IBdata[j][33];
          IBdata[i+1][17] = cross(x1,y1,x2,y2);
        }
      else                             /* flags to zero bend of open polygons */
        { 
          IBint[i][3] = 0;
          IBdata[i+1][16] = 0.0;       /* zero end spring on unclosed polygon */
          IBdata[i+1][18] = 0.0;
          IBint[1][3]++;
          sprintf(sline,"sing %f %f -b 0.0 -d 0.0",IBdata[j][3],IBdata[j][4]);
          if ( wc(line) == 1 )
            sprintf(line,"%s -t %f",sline,IBdata[j][8]);
          else
            {
              sscanf(line, "%s %e", name, &teth );
              sprintf(line,"%s -t %f",sline,teth);
            } 
          IBint[i][2]++;
          IBint[i][4]++;
          err = err + pqsing(i,line,fpb);
        }
    }

  return err;
}

/* pqarc: parse the polygon arc statement, return status */
int pqarc ( int i, char line[], FILE *fp, FILE *fpb )
{
  int err = 0, k = 0, N = 0, dim = 0, warn;
  float dr, x1, y1, x2, y2;
  char name[100], opt[10];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];
  extern float work[2][MAXLINE];

  k = IBint[1][3];

  IBint[k][1] = 8;
  IBdata[k][1] = IBdata[k-1][3];
  IBdata[k][2] = IBdata[k-1][4];

  IBdata[k][17]  = 0.0;     /* connecting rest angle = 0 */

  if ( wc(line) < 3 ) err = 1;
  else sscanf(line, "%s %s %d", name, opt, &dim ); 

  if ( err == 0 )                   /* get and check the arguments */
    {
      if ( dim <= 0 ) err = 1;
      if ( dim > 10 ) warn = 1;

      if ( opt[0] <= 'f' ) IBint[k][8] = 0;
      else if ( opt[0] <= 's' ) IBint[k][8] = 1;
      else if ( opt[0] <= 't' ) IBint[k][8] = 2;
      else err = 1;

      err = err + popt(40,k,line);
      err = err + pqbbgon(i,k,dim,fp,fpb);
    }

  if ( err == 0 )                   /* get the number of data sites */
    {

      x1 = IBdata[k][9]*(IBdata[k][3]-IBdata[k][1]);
      y1 = IBdata[k][9]*(IBdata[k][4]-IBdata[k][2]);
      x2 = IBdata[k-1][9]*(IBdata[k][1]-IBdata[k-1][1]);
      y2 = IBdata[k-1][9]*(IBdata[k][2]-IBdata[k-1][2]);
      IBdata[k][30] = x1;
      IBdata[k][31] = y1;
      IBdata[k][32] = x1;
      IBdata[k][33] = y1;
      IBdata[k][17] = cross(x1,y1,x2,y2);

      if ( IBint[k][8] == 0 ) {
           IBint[k][1] = 9;
           x1 = IBdata[k][30];
           y1 = IBdata[k][31];
           x2 = IBdata[k-1][32];
           y2 = IBdata[k-1][33];
           IBdata[k][17] = cross(x1,y1,x2,y2);
        }
      else if ( IBint[k][8] == 1 ) {
           x1 = IBdata[k][1];
           y1 = IBdata[k][2];
           x2 = IBdata[k][3];
           y2 = IBdata[k][4];
           IBdata[k][9] = distance(x1,y1,x2,y2)/IBint[k][2];
           IBdata[k][10] = 0.0;

        }
      else {
           IBdata[k][9] = IBdata[k][9]*IBdata[2][6];
           IBdata[k][10] = -IBdata[k][9]*IBdata[k][9]*sin(IBdata[k][13]);
           IBdata[k][17] = -IBdata[k][9]*IBdata[k][9]*sin(IBdata[k][17]);
           IBdata[k][32] = IBdata[k][9]*(IBdata[k][3]-IBdata[k][1]);
           IBdata[k][33] = IBdata[k][9]*(IBdata[k][4]-IBdata[k][2]);
        }

      IBint[k][6] = 1;
      IBint[k][7] = 1;
      IBdata[k][15] = IBdata[k][9];       /* first stuff not flagged */
      IBdata[k][16] = IBdata[k][6];
      IBdata[k][18] = IBdata[k][7];
    }

  if ( err >= 1 )
    {
       printf ("\n*********** input error - bcurv \n");
       printf ("Usage: bcurv k dim [-options] \n");
       printf ("  k specifies the resting position of hte BB polygon\n");
       printf ("  dim is the number of data pairs in the BB polygon\n");
       printf ("  [-options] specify defaults for polygon arguments\n");
    }

  if ( warn == 1 )
    {
       printf ("\n*********** input warning - bcurv \n");
       printf ("Usage: bcurv k dim [-options] \n");
       printf ("  dim is greater than 10\n");
    }

  if ( err >= 2 )
    {
       printf ("\n*********** input error - BB points \n");
       printf ("Usage: bcurv k dim [-options] \n");
       printf ("         x_1 y_1 \n");
       printf ("         x_2 y_2 \n");
       printf ("                 \n");
       printf ("         x_dim y_dim \n");
       printf ("  Data pairs must repeated on dim lines. \n");
       printf ("  No spaces or comments are allowed within \n");
       printf ("  the data pairs \n");
    }

  return err;
}

/* pqbbgon: parse the BB control polygons, return status */
int pqbbgon ( int i, int k, int dim, FILE *fp, FILE *fpb )

{
  int err = 0, j = 0, L = 0, m = 0, N=0, idecast, jdecast;
  float dist, theta, x, y, x0, y0, IBbb[10000];
  float xa, xb, c, xc;
  float xd1, yd1, xd2, yd2;
  float work2[3][MAXLINE], tr, tl;

  char line[MAXARG];

  extern char colorf[MAXLINE],linef[MAXLINE];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];


  IBbb[1] = IBdata[k][1];        /* get the bb polygon points */
  IBbb[2] = IBdata[k][2];
  for (j=1; j<=dim; j++)
    {
       getcommand(line,MAXLINE,fp);
       if ( wc(line) != 2 ) err = 2;
       else sscanf(line, "%e %e", &x0, &y0);
       IBbb[(2*j)+1] = x0;
       IBbb[(2*j)+2] = y0;
    }
  IBdata[k][3] = x0;
  IBdata[k][4] = y0;

  IBdata[k][30] = -IBdata[k][1];
  IBdata[k][31] = -IBdata[k][2];

  if ( err == 0 ) {

    if ( IBint[k][2] == 0 ) {
      dist  = IBdata[k][14]*IBdata[2][6];
    }
    if ( IBint[k][2] != 0 ) {   /* estimate the length of the curve */
      dist = 0;
      xd1 =IBbb[1]; yd1 =IBbb[2]; 
      for (j=1; j<=500; j++ ) {
         xd2 = xd1; yd2 = yd1; 
         for (L=0; L<=dim; L++) {
            work2[1][L] = IBbb[(2*L)+1];
            work2[2][L] = IBbb[(2*L)+2];
	 }
         theta = j; theta = theta/500.;    /* deCasteljau algorithm */
         tl = 1.-theta;  tr = theta;
         for (idecast=dim; idecast>=0; idecast--) {
           for (jdecast=0; jdecast<= idecast-1; jdecast++){
             work2[1][jdecast] = (work2[1][jdecast]*tl) + (work2[1][jdecast+1]*tr);
             work2[2][jdecast] = (work2[2][jdecast]*tl) + (work2[2][jdecast+1]*tr);
	   }
	 }
         xd1  = work2[1][0];  yd1  = work2[2][0];
         dist = dist + distance(xd1,yd1,xd2,yd2);
      }
      dist = dist/IBint[k][2];      /* set the number of points */
    }
    
    theta = 0.0;
    x    = IBbb[1];
    y    = IBbb[2];
    for (j=1; j<=3; j++) {       /* write the points */
      N++;
      fprintf(fpb,"  %.13e %.13e \n",x,y);
      xa = theta;   xb = 1.0;
      for ( m=0; m<=24; m++){
        xc = (xa+xb)/2.;
        for ( L=0; L<=dim; L++) {
           work2[1][L] = IBbb[(2*L)+1];
           work2[2][L] = IBbb[(2*L)+2];
        }
        tl = 1.-xc;  tr = xc;    /* deCasteljau algorithm */
        for (idecast=dim; idecast>=0; idecast--) {
           for (jdecast=0; jdecast<= idecast-1; jdecast++){
             work2[1][jdecast] = (work2[1][jdecast]*tl) + (work2[1][jdecast+1]*tr);
             work2[2][jdecast] = (work2[2][jdecast]*tl) + (work2[2][jdecast+1]*tr);
	   }
	}
        c = distance(work2[1][0],work2[2][0],x,y) - dist;
        if ( c < 0 ) xa = xc;
        if ( c >= 0 ) xb = xc;
      }
      theta = xc;
      x    = work2[1][0];
      y    = work2[2][0];
      if ( j == 1 ) {
        IBdata[k][30] = IBdata[k][30]+x;
        IBdata[k][31] = IBdata[k][31]+y;
      }
    }


    while ( distance(x,y,x0,y0) > dist ){
      N++;
      fprintf(fpb,"  %.13e %.13e \n",x,y);
      xa = theta;   xb = 1.0;        
      for ( m=0; m<=24; m++){
        xc = (xa+xb)/2.;
        for ( L=0; L<=dim; L++) {
           work2[1][L] = IBbb[(2*L)+1];
           work2[2][L] = IBbb[(2*L)+2];
        }
        tl = 1.-xc;  tr = xc;    /* deCasteljau algorithm */
        for (idecast=dim; idecast>=0; idecast--) {
           for (jdecast=0; jdecast<= idecast-1; jdecast++){
             work2[1][jdecast] = (work2[1][jdecast]*tl) + (work2[1][jdecast+1]*tr);
             work2[2][jdecast] = (work2[2][jdecast]*tl) + (work2[2][jdecast+1]*tr);
	   }
	}
        c = distance(work2[1][0],work2[2][0],x,y) - dist;
        if ( c < 0 ) xa = xc;
        if ( c >= 0 ) xb = xc;
      }
      theta = xc;
      x    = work2[1][0];
      y    = work2[2][0];
    }
    N++;
    fprintf(fpb,"  %.13e %.13e \n",x,y);
    IBdata[k][32] = IBdata[k][3]-x;
    IBdata[k][33] = IBdata[k][4]-y;
    IBint[k][2] = N;
  }
  return err;
      
}

/* pqcarc: parse the polygon circular arc statement, return status */
int pqcarc ( int i, char line[], FILE *fp, FILE *fpb )
{
  int err = 0, j, k = 0, N = 0, dim = 0, warn, sgna;
  float dist, x1, y1, x2, y2, S, pi = 3.1415927;
  float xc, yc, xp, yp, xf, yf, norm, Smax, xmax, ymax;
  float a0, a1, a2, beta, dotp, theta, cth, sth;
  char name[100], opt[10], carc_arg[100];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];
  extern float work[2][MAXLINE];

  k = IBint[1][3];

  IBint[k][1] = 11;
  IBdata[k][1] = IBdata[k-1][3];    /* the previous point */
  IBdata[k][2] = IBdata[k-1][4];
  xf = IBdata[k][1]; yf = IBdata[k][2];
  IBdata[k][17]  = 0.0;             /* connecting rest angle = 0 */

  getcommand(carc_arg,MAXLINE,fp);         /*  get the endpoints */ 
  if ( wc(carc_arg) < 2 ) err = 1;
  sscanf(carc_arg, "%e %e", &x1, &y1);
  getcommand(carc_arg,MAXLINE,fp);      /*  get the arclength and direction */ 
  if ( wc(carc_arg) < 2 ) err = 1;
  sscanf(carc_arg, "%e %i", &S, &sgna ); 

  if ( x1 < IBdata[1][1] ) err = 1;
  if ( x1 > IBdata[1][2] ) err = 1;
  if ( y1 < IBdata[1][3] ) err = 1;
  if ( y1 > IBdata[1][4] ) err = 1;

  IBdata[k][3] = x1;                /* last points of the carc */
  IBdata[k][4] = y1;
  IBint[k][6] = 1;
  IBint[k][7] = 1;

  err = err + popt(40,k,line);      /* get and check the arguments */

/* 
/    compute the radius and center 
*/

  dist = distance(IBdata[k][1],IBdata[k][2],IBdata[k][3],IBdata[k][4]);
  if ( S < dist ) err = 1;
  if ( S == dist*pi/2.0 )
    {
      S = S + (sgna*0.000001);
      warn = 1;
    }

  xmax = IBdata[1][2]-IBdata[1][1];
  ymax = IBdata[1][4]-IBdata[1][3];

  if ( err == 0 )
    {
      xc = (IBdata[k][1]+IBdata[k][3])/2.0;
      yc = (IBdata[k][2]+IBdata[k][4])/2.0;
      xp = IBdata[k][2]-IBdata[k][4];
      yp = IBdata[k][3]-IBdata[k][1];
      norm = sqrt(pow(xp,2)+pow(yp,2));
      xp = xp/norm;
      yp = yp/norm;

      if ( S > dist*pi/2 )          /* long arc case */
        {
         a0 = 0.0;
         a1 = xmax + ymax;
         for (j=0; j<=60; j++)
	   {
            a2 = (a0 + a1)/2;
            x2 = xc + (sgna*a2*xp);
            y2 = yc + (sgna*a2*yp);
            dist = distance(x2,y2,x1,y1);
            dotp = ((x1-x2)*(xc-x2)) + ((y1-y2)*(yc-y2));
            beta = acos(dotp/(a2*dist));
            if ( 2.0*(pi-beta)*dist <= S ) a0 = a2;
            else a1 = a2;
	   }
         theta = sgna*2.0*(pi-beta);
        }
      else                          /* short arc case */
        {
         a0 = 0.0;
         a1 = xmax + ymax;
         for (j=0; j<=60; j++)
	   {
            a2 = (a0 + a1)/2;
            x2 = xc + (sgna*a2*xp);
            y2 = yc + (sgna*a2*yp);
            dist = distance(x2,y2,x1,y1);
            dotp = ((x1-x2)*(xc-x2)) + ((y1-y2)*(yc-y2));
            beta = acos(dotp/(a2*dist));
            if ( 2.0*beta*dist <= S ) a1 = a2;
            else a0 = a2;
	   }
         theta = -sgna*2.0*beta;
        }

      xc = x2; yc = y2;
    }

/* 
/    compute the number of points and change in angle
*/

  if ( err == 0 )
    {
      if ( IBint[k][2] != 0 ) IBdata[k][9] = S / IBint[k][2]; 
      else
        {
          IBint[k][2] = S / (IBdata[2][6]*IBdata[k][9]);
          IBdata[k][9] = IBdata[2][6]*IBdata[k][9];
        }
      theta = theta/(IBint[k][2]-1);
     }

/* 
/    setup for the connecting angle calculation
/    use a rotation matrix product to write out the ibps to temp file
/      make sure the points are in the domain
*/

  if ( err == 0 )
    {
      IBdata[k][30] = xf - xc + (cos(theta)*(xf-xc)) + (sin(theta)*(yf-yc));
      IBdata[k][31] = yf - yc - (sin(theta)*(xf-xc)) + (cos(theta)*(yf-yc));
      fprintf(fpb," %.13e %.13e\n",xf,yf);
      for ( j=1; j<=IBint[k][2]-1; j++ )
        {
         xf = xc + (cos(theta)*(xf-xc)) + (sin(theta)*(yf-yc));
         yf = yc - (sin(theta)*(xf-xc)) + (cos(theta)*(yf-yc));
         if ( x1 < IBdata[1][1] ) err = 2;
         if ( x1 > IBdata[1][2] ) err = 2;
         if ( y1 < IBdata[1][3] ) err = 2;
         if ( y1 > IBdata[1][4] ) err = 2;
         fprintf(fpb," %.13e %.13e\n",xf,yf);
        }
      IBdata[k][32] = x1-xf;
      IBdata[k][33] = y1-yf;
    }

/* 
/    compute the connecting angle
*/

  if ( err == 0 )
    {
      x1 = IBdata[k][30];
      y1 = IBdata[k][31];
      x2 = IBdata[k-1][32];
      y2 = IBdata[k-1][33];
      IBdata[k][17] = cross(x1,y1,x2,y2);
    }


  if ( err == 1 )
    {
        printf ("\n*********** input error - carc statement\n");
        printf ("Required useage: carc  [-options] s\n");
        printf ("                   x0 y0 \n");
        printf ("                   S sgn(S) \n");
        printf ("  (x0,y0) is the endpoint of the circular arc \n");
        printf ("  S is the arclength \n");
        printf ("  sgn(S) = pm 1 determines direction of the arc \n");
     }
  if ( err == 2 )
    {
        printf ("\n*********** input error - carc statement\n");
        printf ("A point on the arc was outside the domain\n");
     }
  if ( err >= 3 )
    {
        printf ("\n*********** input error - carc statement\n");
        printf ("Circle may be unpredictable because you have chosen\n");
        printf ("  an exact half circle.  You may get better results\n");
        printf ("  by increasing or decreasing S slightly.\n");
     }
  return err;
}

/* pqfirst: parse the polygon first statement, return status */
int pqfirst ( int i, char line[] )
{
  int err = 0;
  float dr, x0, y0;
  char name[100], opt[10];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  if ( wc(line) != 3 ) err = 1;
  else sscanf(line, "%s %e %e", name, &x0, &y0);

  if ( name[0] != 'f' ) err = 1;
  if ( x0 < IBdata[1][1] ) err = 1;
  if ( x0 > IBdata[1][2] ) err = 1;
  if ( y0 < IBdata[1][3] ) err = 1;
  if ( y0 > IBdata[1][4] ) err = 1;

  if ( err == 0 )
     {
        IBdata[i][3] = x0;
        IBdata[i][4] = y0;
     }

  if ( err == 1 )
    {
        printf ("\n*********** input error - first statement\n");
        printf ("Required useage: first x0, y0\n");
        printf ("first must follow immediately after polygon\n");
        printf ("i.e. no spaces or comments.\n");
     }
  return err;
}


/* pqray: parse the polygon ray statement, return status */
int pqray ( int i, char line[], FILE *fpb )
{
  int err = 0, j = 0, k = 0, l=0;
  float wrk, x0, y0, dr, x1, x2, y1, y2;
  char name[100], opt[10];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  k = IBint[1][3];
  IBint[k][1] = 7;
  IBdata[k][1]  = IBdata[k-1][3];    /* first points of the ray */
  IBdata[k][2]  = IBdata[k-1][4];
  IBdata[k][17]  = 0.0;              /* connecting rest angle = 0 initially */

  if ( wc(line) < 3 ) err = 1;
  else                               /* get the arguments */
    {
      sscanf(line, "%s %e %e", name, &x0, &y0 );
      if ( x0 < IBdata[1][1] ) err = 1;
      if ( x0 > IBdata[1][2] ) err = 1;
      if ( y0 < IBdata[1][3] ) err = 1;
      if ( y0 > IBdata[1][4] ) err = 1;
      IBdata[k][3] = x0;              /* last points of the ray */
      IBdata[k][4] = y0;
      IBint[k][6] = 1;
      IBint[k][7] = 1;
      err = err + popt(50,k,line);
    }

  if ( err == 0 )                      /* compute number of ibps and spacing */
    {
      wrk = distance(IBdata[k][1],IBdata[k][2],x0,y0);
      if ( IBint[k][2] == 0 )
        {
          IBdata[k][9] = IBdata[k][9]*IBdata[2][6];
          IBint[k][2] = wrk/IBdata[k][9];
        }
      else if ( IBint[k][2] == 1 )
        {
          IBdata[k][9] = wrk / IBint[k][2];
        }
      else
        {
          IBint[k][2] = IBint[k][2]-1;
          IBdata[k][9] = wrk / IBint[k][2];
        }
    }

  if ( err == 0 )                      /* compute the connection information */
    {
      IBdata[k][10] = 0.0;
      x1 = IBdata[k][9]*(IBdata[k][3]-IBdata[k][1]);
      y1 = IBdata[k][9]*(IBdata[k][4]-IBdata[k][2]);
      x2 = IBdata[k-1][32];            /* the angle */
      y2 = IBdata[k-1][33];
      IBdata[k][17] = cross(x1,y1,x2,y2);

      IBdata[k][30] = x1;              /* for the next connection */
      IBdata[k][31] = y1;
      IBdata[k][32] = x1;
      IBdata[k][33] = y1;

      IBdata[k][15] = IBdata[k][9];    /* more spring stuff at connection */
      IBdata[k][16] = IBdata[k][6];
      IBdata[k][18] = IBdata[k][7];
    }

  if ( err == 0 )                       /* now write out the ibps to temp file */
    {
      x1 = IBdata[k][1];
      y1 = IBdata[k][2];
      x2 = (IBdata[k][3] - IBdata[k][1])/IBint[k][2];
      y2 = (IBdata[k][4] - IBdata[k][2])/IBint[k][2];
      for ( j=0; j<=IBint[k][2]-1; j++ )
         fprintf(fpb," %.13e %.13e \n",x1+(j*x2),y1+(j*y2));
    }

  if ( err == 1 )
    {
       printf ("\n*********** input error - ray \n");
       printf ("Usage: ray x0 y0 [-options] \n");
       printf ("  (x0,y0) is the ray endpoint \n");
       printf ("  [-options] arguments\n");
    }

  return err;
}

/* pqsing: parse the polygon singlet statement, return status */
int pqsing ( int i, char line[], FILE *fpb )
{
  int err = 0, j = 0, k = 0, l=0;
  float x0, y0, dr;
  char name[100], opt[10];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  k = IBint[1][3];
  IBint[k][1] = 10;
  IBdata[k][1]  = IBdata[k-1][3];     /* previous ibp */
  IBdata[k][2]  = IBdata[k-1][4];
  IBdata[k][17]  = 0.0;               /* connecting rest angle = 0 */


  if ( wc(line) < 3 ) err = 1;
  else                                /* get the arguments */
    {
      sscanf(line, "%s %e %e", name, &x0, &y0 );
      if ( x0 < IBdata[1][1] ) err = 1;
      if ( x0 > IBdata[1][2] ) err = 1;
      if ( y0 < IBdata[1][3] ) err = 1;
      if ( y0 > IBdata[1][4] ) err = 1;
      IBdata[k][3] = x0;              /* current ibp */
      IBdata[k][4] = y0;
      err = err + popt(60,k,line);
    }


  if ( err == 0 )                     /* connecting angle info */
    {
      IBdata[k][9] = 0.;
      IBdata[k][10] = 0.;
      IBint[k][2] = 1;
      for ( j=1; j<=IBint[k][2]; j++ )
         fprintf(fpb," %.13e %.13e \n",x0,y0);
    }

  if ( err == 1 )
    {
       printf ("\n*********** input error - sing \n");
       printf ("Usage: sing x0 y0 [-options] \n");
       printf ("  (x0,y0) is the point \n");
       printf ("  [-options] arguments\n");
    }

  return err;
}


