/* wname: writes namelist file for fogelson's code */
void wname()
{
  extern int IBint[MAXLINE][MAXARG];
  extern int IBact[MAXLINE][4];
  extern float IBdata[MAXLINE][MAXARG];
  extern char colorf[MAXLINE],linef[MAXLINE];
  extern char fluidf[MAXLINE],partf[MAXLINE];

  char dash[10], base[10];
  int itube, err=0;

  FILE *fdat;
  fdat = fopen("ibisdat/init.dat","w");

  sprintf(dash,"'");
  sprintf(base,"null");

  fprintf(fdat," $IBPTS\n");
  fprintf(fdat,"  rsflag     = 0,\n");
  fprintf(fdat,"  colorf     = %s,\n", colorf);
  fprintf(fdat,"  linef      = %s,\n", linef);
  fprintf(fdat,"  fluidf     = %s,\n", fluidf);
  fprintf(fdat,"  ibptsf     = %sibisdat/ibpts.dat%s\n",dash,dash);
  fprintf(fdat,"  linkf      = %sibisdat/link.dat%s\n",dash,dash);
  fprintf(fdat,"  partf      = %s,\n", partf);

  fprintf(fdat,"  xmin       = %.13e,\n", IBdata[1][1]);
  fprintf(fdat,"  xmax       = %.13e,\n", IBdata[1][2]);
  fprintf(fdat,"  ymin       = %.13e,\n", IBdata[1][3]);
  fprintf(fdat,"  ymax       = %.13e,\n", IBdata[1][4]);
  fprintf(fdat,"  dlt        = %.13e,\n", IBdata[2][3]);
  fprintf(fdat,"  h          = %.13e,\n", IBdata[2][4]);
  fprintf(fdat,"  mu         = %.13e,\n", IBdata[1][5]);
  fprintf(fdat,"  ro         = %.13e,\n", IBdata[1][6]);
  fprintf(fdat,"  umax       = %.13e,\n", IBdata[2][7]);
  fprintf(fdat,"  fbpx       = %.13e,\n", IBdata[2][8]);
  fprintf(fdat,"  fbpy       = %.13e,\n", IBdata[2][9]);
  fprintf(fdat,"  ntstart    = %i,\n", IBint[2][0]);
  fprintf(fdat,"  ntmax      = %i,\n", IBint[2][3]);
  fprintf(fdat,"  time       = %.13e,\n", IBint[2][0]*IBdata[2][3]);
  fprintf(fdat,"  ccount     = 0,\n");
  fprintf(fdat,"  cfreq      = %i,\n", IBint[1][4]);
  fprintf(fdat,"  lcount     = 0,\n");
  fprintf(fdat,"  lfreq      = %i,\n", IBint[1][5]);
  fprintf(fdat,"  ivdens     = %i,\n", IBint[1][6]);
  fprintf(fdat,"  usave      = %i,\n", IBint[2][6]);
  fprintf(fdat,"  fsave      = %i,\n", IBint[2][5]);
  fprintf(fdat,"  ipbx       = %i,\n", IBint[3][3]);
  fprintf(fdat,"  ipby       = %i,\n", IBint[3][4]);
  itube = IBdata[3][2]/IBdata[2][4];
  fprintf(fdat,"  ibtube     = %i,\n", itube);
  itube = IBdata[3][4]/IBdata[2][4];
  fprintf(fdat,"  ittube     = %i,\n", itube);

  itube = IBdata[1][7]*IBint[3][2];
  fprintf(fdat,"  btubil     = %i,\n", itube);
  itube = IBdata[1][8]*IBint[3][2];
  fprintf(fdat,"  btubir     = %i,\n", itube);

  itube = IBdata[1][9]*IBint[3][2];
  fprintf(fdat,"  ttubil     = %i,\n", itube);
  itube = IBdata[1][10]*IBint[3][2];
  fprintf(fdat,"  ttubir     = %i,\n", itube);

  fprintf(fdat,"  pwalk      = %.13e,\n", IBdata[2][11]);
  fprintf(fdat,"  iplat      = %i,\n", IBint[4][2]);
  fprintf(fdat,"  maxlink    = %i,\n", IBint[4][1]);
  fprintf(fdat,"  pltdif     = %.13e,\n", IBdata[3][5]);
  fprintf(fdat,"  pdens      = %.13e,\n", IBdata[2][10]);
  fprintf(fdat,"  scoh       = %.13e,\n", IBdata[4][6]);
  fprintf(fdat,"  scgap      = %.13e,\n", IBdata[4][7]);
  fprintf(fdat,"  sadh       = %.13e,\n", IBdata[4][1]);
  fprintf(fdat,"  sagap      = %.13e,\n", IBdata[4][2]);
  fprintf(fdat,"  sbreaka    = %.13e,\n", IBdata[4][4]);
  fprintf(fdat,"  sbreakc    = %.13e,\n", IBdata[4][9]);
  fprintf(fdat,"  stiffa     = %.13e,\n", IBdata[4][3]);
  fprintf(fdat,"  stiffc     = %.13e,\n", IBdata[4][8]);
  fprintf(fdat,"  rlinkc     = %.13e,\n", IBdata[4][10]);
  fprintf(fdat,"  rlinka     = %.13e,\n", IBdata[4][5]);
  fprintf(fdat," $END\n");
  fclose(fdat);
  return;
 }

/* wparm: writes parameter file for fogelsons code */
void wparm(){
  int  i, j, k, kx, ky, kpt, nring, nlnk;
  int  i_int, j_int, ments=120, nps, err=0;
  FILE  *fp;
  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  fp = fopen("parm.inc","w");
  i = IBint[2][1];
  j = IBint[2][2];
  kx = IBint[0][1];
  ky = IBint[0][0];

  fprintf(fp,"c\nc  This file is automatically generated.\n");
  fprintf(fp,"c  PLEASE don't change it\nc\n");

  fprintf(fp,"      implicit none\n\n");

  fprintf(fp,"      integer l2nx\n");
  fprintf(fp,"      parameter(l2nx=%d)\n\n",i);

  fprintf(fp,"      integer l2ny\n");
  fprintf(fp,"      parameter(l2ny=%d)\n\n",j);

  fprintf(fp,"      integer nx\n");
  fprintf(fp,"      parameter(nx=%d)\n\n",IBint[1][7]);

  fprintf(fp,"      integer ny\n");
  fprintf(fp,"      parameter(ny=%d)\n\n",IBint[1][8]);

  fprintf(fp,"      integer nxp1\n");    i_int = IBint[1][7]+1;
  fprintf(fp,"      parameter(nxp1=%d)\n\n", i_int);

  fprintf(fp,"      integer nyp1\n");    j_int = IBint[1][8]+1;
  fprintf(fp,"      parameter(nyp1=%d)\n\n", j_int);

  fprintf(fp,"      integer nxp2\n");    i_int = IBint[1][7]+2;
  fprintf(fp,"      parameter(nxp2=%d)\n\n", i_int);

  fprintf(fp,"      integer nyp2\n");    j_int = IBint[1][8]+2;
  fprintf(fp,"      parameter(nyp2=%d)\n\n", j_int);

/*  fprintf(fp,"      integer nyv4\n");    j_int = IBint[1][8]/4;
    fprintf(fp,"      parameter(nyv4=%d)\n\n", j_int); */

  fprintf(fp,"      integer nxx\n");
  fprintf(fp,"      parameter(nxx=%d)\n\n",IBint[0][2]);

  fprintf(fp,"      integer nyy\n");
  fprintf(fp,"      parameter(nyy=%d)\n\n",IBint[0][3]);

  fprintf(fp,"      integer npdx\n");
  if (kx*ky==0) 
    fprintf(fp,"      parameter(npdx=%d)\n\n",IBint[0][2]);
  else {
    fprintf(fp,"      parameter(npdx=%d)\n\n",kx);
  }

  fprintf(fp,"      integer npdy\n");
  if (kx*ky==0) 
    fprintf(fp,"      parameter(npdy=%d)\n\n",IBint[0][3]);
  else {
    fprintf(fp,"      parameter(npdy=%d)\n\n",ky);
  }

  fprintf(fp,"      integer np\n");
  if (kx*ky==0) kpt = 1;
  else {
    kpt = 2*IBint[0][2]*IBint[0][3]/(kx*ky);
  }
  fprintf(fp,"      parameter(np=%d)\n\n",kpt);

  nring = max(IBint[4][3],1);
  ments = max(IBint[1][0],120);
 
  fprintf(fp,"      integer ments\n");
  fprintf(fp,"      parameter(ments=%d)\n\n",ments);

/*  nps = max(IBint[3][2],1);
    fprintf(fp,"      integer nfil\n");
    fprintf(fp,"      parameter(nfil=%d)\n\n",nps); */

  fprintf(fp,"      integer nring\n");
  fprintf(fp,"      parameter(nring=%i)\n\n",nring);

  nps = IBint[1][2]+(ments*nring)+kpt+ments;
  fprintf(fp,"      integer mpts\n");
  fprintf(fp,"      parameter(mpts=%i)\n\n",nps);

  i_int = 2*nps;
  fprintf(fp,"      integer mcoor\n");
  fprintf(fp,"      parameter(mcoor=%i)\n\n",i_int);

  i_int = 9*ments + IBint[0][12]; 
  fprintf(fp,"      integer mlink\n");
  fprintf(fp,"      parameter(mlink=%i)\n\n",i_int);

  i_int = 6*ments + IBint[0][12]; 
  fprintf(fp,"      integer mlkpt\n");
  fprintf(fp,"      parameter(mlkpt=%i)\n\n",i_int);

  i_int = (ments*(ments-1))/2;
  fprintf(fp,"      integer mwhere\n");
  fprintf(fp,"      parameter(mwhere=%i)\n\n",i_int);

  fprintf(fp,"      integer nact\n");
  j = 1; for ( i = 5; i <= IBint[1][3]; i++ ) j = max(j,IBint[i][2]+100);
  fprintf(fp,"      parameter (nact=%d)\n\n",j);

  fprintf(fp,"      integer nsrc\n");
  j = IBint[3][5]+5;
  fprintf(fp,"      parameter (nsrc=%i)\n\n",j);

  fclose(fp);
  return;

}

/* wlink: check of the link file for compatibility */
void wlink()
{
  extern int IBint[MAXLINE][MAXARG];

  int ent1, ent2, num;
  float rest, stiff, brake;

  FILE  *fpl;
  int check1, check2, err=0, i, j;

  fpl = fopen("ibisdat/link.dat","r");
  for (i=1; i<=IBint[1][9]; i++) {
    fscanf(fpl,"%i %i %i ",&ent1, &ent2, &num);
    fscanf(fpl,"%.13e %.13e %.13e ", &stiff, &rest, &brake);
    check1 = 1;
    check2 = 1;
    for (j=4; j<=MAXLINE; j++) {
      if ( ent1 == IBint[j][0] ) check1=0;
      if ( ent2 == IBint[j][0] ) check2=0;
      printf("%i %i %i \n", ent1, ent2, IBint[j][0]);
    }
    if ( check1 |= 0 ) err=1;
    if ( check2 != 0 ) err=1;
  }
  fclose(fpl);

  return;
}
/* wgraph: writes graph file for visualization of ibis code */
void wgraph()
{
  extern int IBint[MAXLINE][MAXARG];
  extern int IBact[MAXLINE][4];
  extern float IBdata[MAXLINE][MAXARG];

  int i, j, k, number, close, cat, color = 16;
  char line[2*MAXLINE], junk[2*MAXLINE];
  float x, y, xt, yt;
  float s1, s2, s3, s4, s5;
  int i1, i2, i3;

  FILE *fdat, *fpb;
  fdat = fopen("ibisdat/line0.dat","w");
  fpb = fopen("ibisdat/ibpts.dat","r");

  fprintf(fdat,"%.13e %.13e ", IBdata[1][1],IBdata[1][2]);
  fprintf(fdat,"%.13e %.13e \n", IBdata[1][3],IBdata[1][4]);
  fprintf(fdat,"%i %.13e \n", 0, IBdata[2][4]);
  fprintf(fdat,"0 0 0 0.0 \n");
  fprintf(fdat,"%i 0.0 \n", IBint[1][0]);

  for (i=1; i<=IBint[1][0]; i++) {
    fscanf(fpb,"%s", line);
    fscanf(fpb,"%d %d %d %d %d %d %.13e %.13e",
        &number, &close, &cat, &i1, &i2, &i3, &s4, &s5);
    fprintf(fdat,"%i %i %i %i \n", number, color, cat, close);
    for (j=1; j<=number; j++) {
      fscanf(fpb,"%i %.13e %.13e %.13e %.13e %.13e %.13e %.13e %.13e %.13e", 
          &k, &x, &y, &xt, &yt, &s1, &s2, &s3, &s4, &s5);
      fprintf(fdat,"%.13e %.13e\n", x, y);
    }
  }

  fclose(fdat);
  fclose(fpb);
  return;
}

/* wdat: writes immersed boundary points file for fogelsons code */

void wdat ( int fnum )
{
  FILE *fp, *fpb;
  int i, j, k, k1, ising = 0, one=1, first, kfile;
  float pi=3.1415926535897, zero = 0.0;
  float angle, x0, y0, r, h, xn, yn, d, xmin, x1, y1, x2, y2;
  float r1,r2,th;
  float cos_direction, sin_direction, xhat, yhat;

  extern int IBact[MAXLINE][4];
  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];
  extern float work[2][MAXLINE];

  fp = fopen("ibisdat/ibpts.dat","w");
  fpb = fopen("ibisdat/bbgons.dat","r");

  fprintf(fp,"%6d %6d %6d %6d\n", IBint[0][8],IBint[0][9],
          IBint[0][10],IBint[1][9]);

  IBint[1][0] = 0;

  xmin = IBdata[1][1];

  if ( IBint[3][1] == 3 )    /*  print the tube points */
   {
     h = (IBdata[1][2]-IBdata[1][1])/IBint[3][2];
     fprintf(fp,"btub\n");
     fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e \n",
          IBint[3][2], 0, -1, IBact[3][1], IBint[3][0],
          (IBdata[3][1]+IBdata[3][3])/2.0,IBdata[3][2]);
     IBint[1][0]++;
     for ( i=1; i<IBint[3][2]; i++ )
       {
        fprintf(fp," %d",one);
        fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
        fprintf(fp," %.13e",IBdata[3][2]);
        fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
        fprintf(fp," %.13e",IBdata[3][2]);
        fprintf(fp," %.13e",IBdata[3][9]);
        fprintf(fp," %.13e",IBdata[3][6]);
        fprintf(fp," %.13e",IBdata[3][10]);
        fprintf(fp," %.13e",IBdata[3][7]);
        fprintf(fp," %.13e",IBdata[3][8]);
        fprintf(fp,"\n");
       }
     fprintf(fp," %d",zero);
     fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
     fprintf(fp," %.13e",IBdata[3][2]);
     fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
     fprintf(fp," %.13e",IBdata[3][2]);
     fprintf(fp," %.13e",IBdata[3][9]);
     fprintf(fp," %.13e",IBdata[3][6]);
     fprintf(fp," %.13e",IBdata[3][10]);
     fprintf(fp," %.13e",IBdata[3][7]);
     fprintf(fp," %.13e",IBdata[3][8]);
     fprintf(fp,"\n");

     fprintf(fp,"ttub\n");
     fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
          IBint[3][2], 0, -1, IBact[3][1], IBint[3][0],
          (IBdata[3][1]+IBdata[3][3])/2.0,IBdata[3][4]);
     IBint[1][0]++;
     for ( i=1; i<IBint[3][2]; i++ )
       {
        fprintf(fp," %d",one);
        fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
        fprintf(fp," %.13e",IBdata[3][4]);
        fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
        fprintf(fp," %.13e",IBdata[3][4]);
        fprintf(fp," %.13e",IBdata[3][9]);
        fprintf(fp," %.13e",IBdata[3][6]);
        fprintf(fp," %.13e",IBdata[3][10]);
        fprintf(fp," %.13e",IBdata[3][7]);
        fprintf(fp," %.13e",IBdata[3][8]);
        fprintf(fp,"\n");
       }
     fprintf(fp," %d",zero);
     fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
     fprintf(fp," %.13e",IBdata[3][4]);
     fprintf(fp," %.13e",xmin + (h/2.) + ((i-1)*h));
     fprintf(fp," %.13e",IBdata[3][4]);
     fprintf(fp," %.13e",IBdata[3][9]);
     fprintf(fp," %.13e",IBdata[3][6]);
     fprintf(fp," %.13e",IBdata[3][10]);
     fprintf(fp," %.13e",IBdata[3][7]);
     fprintf(fp," %.13e",IBdata[3][8]);
     fprintf(fp,"\n");
   }

  for ( i = 5; i <= MAXLINE; i++ )
   {
     if ( IBint[i][1] == 22 )    /*  print the periodic lines  */
       {
         IBint[1][0]++;
         x0    = IBdata[i][1];
         y0    = IBdata[i][2];
         xn    = IBdata[i][3];
         yn    = IBdata[i][4];
         h     = IBdata[i][9];
         fprintf(fp,"plne\n");
         fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2]-1, 0, -1, IBact[i][1], IBint[i][0],
           (IBdata[i][1]+IBdata[i][3])/2.0,IBdata[i][2]); 
         for ( j=1; j<IBint[i][2]-1; j++ )
          {
            d = j;  r = (IBint[i][2]-1);  d = d/r;
            fprintf(fp," %d",one);
            fprintf(fp," %.13e",x0 + (d*(xn-x0)));
            fprintf(fp," %.13e",y0 + (d*(yn-y0)));
            fprintf(fp," %.13e",x0 + (d*(xn-x0)));
            fprintf(fp," %.13e",y0 + (d*(yn-y0)));
            fprintf(fp," %.13e",IBdata[i][9]);
            fprintf(fp," %.13e",IBdata[i][6]);
            fprintf(fp," %.13e",IBdata[i][10]);
            fprintf(fp," %.13e",IBdata[i][7]);
            fprintf(fp," %.13e",IBdata[i][8]);
            fprintf(fp,"\n");
          }
         fprintf(fp," %d",zero);
         fprintf(fp," %.13e",xn);
         fprintf(fp," %.13e",yn);
         fprintf(fp," %.13e",xn);
         fprintf(fp," %.13e",yn);
         fprintf(fp," %.13e",IBdata[i][9]);
         fprintf(fp," %.13e",IBdata[i][6]);
         fprintf(fp," %.13e",IBdata[i][10]);
         fprintf(fp," %.13e",IBdata[i][7]);
         fprintf(fp," %.13e",IBdata[i][8]);
         fprintf(fp,"\n");
       }
   }

  for ( i = 5; i <= MAXLINE; i++ )
   {
     if ( IBint[i][1] == 2 )    /*  print the open lines  */
       {
         IBint[1][0]++;
         x0    = IBdata[i][1];
         y0    = IBdata[i][2];
         xn    = IBdata[i][3];
         yn    = IBdata[i][4];
         h     = IBdata[i][9];

         fprintf(fp,"line\n");
         fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2], 0, -3, IBact[i][1], IBint[i][0],
           (IBdata[i][1]+IBdata[i][3])/2.0,IBdata[i][2]); 
         fprintf(fp," %d",one);
         fprintf(fp," %.13e %.13e %.13e %.13e",x0,y0,x0,y0);
         fprintf(fp," %.13e",IBdata[i][9]);
         fprintf(fp," %.13e",IBdata[i][6]);
         fprintf(fp," %.13e %.13e", zero, zero);
         fprintf(fp," %.13e",IBdata[i][19]);
         fprintf(fp,"\n");
         for ( j=1; j<=IBint[i][2]-2; j++ )
          {
            d = j;  r = (IBint[i][2]-1);  d = d/r;
            fprintf(fp," %d",one);
            fprintf(fp," %.13e",x0 + (d*(xn-x0)));
            fprintf(fp," %.13e",y0 + (d*(yn-y0)));
            fprintf(fp," %.13e",x0 + (d*(xn-x0)));
            fprintf(fp," %.13e",y0 + (d*(yn-y0)));
            fprintf(fp," %.13e",IBdata[i][9]);
            fprintf(fp," %.13e",IBdata[i][6]);
            fprintf(fp," %.13e",IBdata[i][10]);
            fprintf(fp," %.13e",IBdata[i][7]);
            fprintf(fp," %.13e",IBdata[i][8]);
            fprintf(fp,"\n");
          }
         fprintf(fp," %d",zero);
         fprintf(fp," %.13e %.13e %.13e %.13e",xn,yn,xn,yn);
         fprintf(fp," %.13e %.13e %.13e %.13e",zero, zero, zero, zero);
         fprintf(fp," %.13e",IBdata[i][19]);
         fprintf(fp,"\n");
      }
   }

  for ( i = 5; i <= MAXLINE; i++ )
   {
     if ( IBint[i][1] == 32 )    /*  print the sines  */
       {
         IBint[1][0]++;
         IBint[i][1] = 2;
         x0    = IBdata[i][1];
         y0    = IBdata[i][2];
         h     = IBdata[i][9];

         cos_direction = cos(IBdata[i][3]);
         sin_direction = sin(IBdata[i][3]);

         fprintf(fp,"sine\n");
         fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2], 0, -3, IBact[i][1], IBint[i][0],
           IBdata[i][1],IBdata[i][2]); 
         fprintf(fp," %d",one);
         fprintf(fp," %.13e %.13e %.13e %.13e",x0,y0,x0,y0);
         fprintf(fp," %.13e",IBdata[i][9]);
         fprintf(fp," %.13e",IBdata[i][6]);
         fprintf(fp," %.13e %.13e", zero, zero);
         fprintf(fp," %.13e",IBdata[i][15]);
         fprintf(fp,"\n");

         for ( j=1; j<=IBint[i][2]-2; j++ )
          {
            d = j;  r = (IBint[i][2]-1);  d = d/r;
            xhat = d*IBdata[i][13];
            yhat = sin(xhat);
            xn = (xhat*cos_direction) + (yhat*sin_direction);
            yn = (yhat*cos_direction) - (xhat*sin_direction);
            fprintf(fp," %d",one);
            fprintf(fp," %.13e %.13e %.13e %.13e",xn,yn,xn,yn);
            fprintf(fp," %.13e",IBdata[i][9]);
            fprintf(fp," %.13e",IBdata[i][6]);
            fprintf(fp," %.13e",IBdata[i][10]);
            fprintf(fp," %.13e",IBdata[i][7]);
            fprintf(fp," %.13e",IBdata[i][8]);
            fprintf(fp,"\n");
          }

         xhat = IBdata[i][13];
         yhat = sin(xhat);
         xn = (xhat*cos_direction) + (yhat*sin_direction);
         yn = (yhat*cos_direction) - (xhat*sin_direction);
         fprintf(fp," %d",zero);
         fprintf(fp," %.13e %.13e %.13e %.13e",xn,yn,xn,yn);
         fprintf(fp," %.13e %.13e %.13e %.13e",zero, zero, zero, zero);
         fprintf(fp," %.13e",IBdata[i][15]);
         fprintf(fp,"\n");
      }
   }

  for ( i = 5; i <= MAXLINE; i++ )
   {
     if ( IBint[i][1] == 6 )    /*  print the polygons  */
       {
         IBint[1][0]++;
         k = IBint[i][4];
         fprintf(fp,"poly\n");
         fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2], IBint[i][3], -3+IBint[i][3], IBact[i][1], 
           IBint[i][0], IBdata[i][1],IBdata[i][2]); 
         first = 1;         
         for ( j = 1; j <= k; j++ )
          {
            if (j == k) first = 0;
            if ( IBint[i+j][1] == 7 )
              k1 = wpray(i+j,fp,fpb,first);
            if ( IBint[i+j][1] == 8 )
              k1 = wparc(i+j,fp,fpb,first);
            if ( IBint[i+j][1] == 9 )
              k1 = wpfarc(i+j,fp,fpb,first);
            if ( IBint[i+j][1] == 10 )
              k1 = wpsing(i+j,fp,fpb,first);
            if ( IBint[i+j][1] == 11 )
              k1 = wpfarc(i+j,fp,fpb,first);
            if ( IBint[i+j][1] == 12 ){
              kfile = IBint[i][2];
              k1 = wpfile(kfile,fp,fpb);
	    }
          }
       }
   }

  for ( i = 5; i <= MAXLINE; i++ )
    if ( IBint[i][1] == 5 ) ising++;

  if ( ising > 0 )
   {
     IBint[1][0]++;
     for ( i = 4; i <= MAXLINE; i++ )
       {
        if ( IBint[i][1] == 5 )    /*  print the singlets  */
         {
           fprintf(fp,"sing\n");
           fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
                1, 0, -3, IBact[i][1], IBint[i][0],
                IBdata[i][1],IBdata[i][2]); 
           fprintf(fp," %d",zero);
           fprintf(fp," %.13e",IBdata[i][1]);
           fprintf(fp," %.13e",IBdata[i][2]);
           fprintf(fp," %.13e",IBdata[i][1]);
           fprintf(fp," %.13e",IBdata[i][2]);
           fprintf(fp," %.13e %.13e %.13e %.13e",zero, zero, zero, zero);
           fprintf(fp," %.13e",IBdata[i][8]);
           fprintf(fp,"\n");
         }
       }
   }

  for ( i = 5; i <= MAXLINE; i++ )
   {
     if ( IBint[i][1] == 4 )    /*  print the circles  */
       {
         IBint[1][0]++;
         angle = 2.*pi/IBint[i][2];
         x0    = IBdata[i][1];
         y0    = IBdata[i][2];
         r     = IBdata[i][3];

         fprintf(fp,"circ\n");
         fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2], 1, 1, IBact[i][1], IBint[i][0], 
           IBdata[i][1],IBdata[i][2]); 
         for ( j=0; j<=IBint[i][2]-2; j++ )
           {
             fprintf(fp," %d",one);
             fprintf(fp," %.13e",x0 + (r*cos(j*angle)));
             fprintf(fp," %.13e",y0 + (r*sin(j*angle)));
             fprintf(fp," %.13e",x0 + (r*cos(j*angle)));
             fprintf(fp," %.13e",y0 + (r*sin(j*angle)));
             fprintf(fp," %.13e",IBdata[i][9]);
             fprintf(fp," %.13e",IBdata[i][6]);
             fprintf(fp," %.13e",IBdata[i][10]);
             fprintf(fp," %.13e",IBdata[i][7]);
             fprintf(fp," %.13e",IBdata[i][8]);
             fprintf(fp,"\n");
           }
         j = IBint[i][2]-1;
         fprintf(fp," %d",zero);
         fprintf(fp," %.13e",x0 + (r*cos(j*angle)));
         fprintf(fp," %.13e",y0 + (r*sin(j*angle)));
         fprintf(fp," %.13e",x0 + (r*cos(j*angle)));
         fprintf(fp," %.13e",y0 + (r*sin(j*angle)));
         fprintf(fp," %.13e",IBdata[i][9]);
         fprintf(fp," %.13e",IBdata[i][6]);
         fprintf(fp," %.13e",IBdata[i][10]);
         fprintf(fp," %.13e",IBdata[i][7]);
         fprintf(fp," %.13e",IBdata[i][8]);
         fprintf(fp,"\n");
       }


     if ( IBint[i][1] == 14 ){    /*  print the ellipses  */

       IBint[1][0]++;
       angle = 2.*pi/IBint[i][2];
       x0    = IBdata[i][1];
       y0    = IBdata[i][2];
       r1    = IBdata[i][3];
       r2    = IBdata[i][4];
       th    = IBdata[i][5];

       fprintf(fp,"ellp\n");
       fprintf(fp,"%6d %6d %6d %6d %6d %.13e %.13e\n",
           IBint[i][2], 1, 1, IBact[i][1], IBint[i][0], 
           IBdata[i][1],IBdata[i][2]); 

/* for all points on the ellipse, calculate in standard position,
   i.e. with the major axis on the x axis, the minor axis on the
   y axis, then rotate (using a rotation matrix) by theta */

/* first point */
       x1 = x0 + ( cos(th)*r1);
       y1 = y0 + (-sin(th)*r1);

/* second point */
       x2 = x0 + (cos(th)*r1*cos(angle)) + (sin(th)*r2*sin(angle));
       y2 = y0 - (sin(th)*r1*cos(angle)) + (cos(th)*r2*sin(angle));

/* last point */
       xn = x0 + (cos(th)*r1*cos(angle)) - (sin(th)*r2*sin(angle));
       yn = y0 - (sin(th)*r1*cos(angle)) - (cos(th)*r2*sin(angle));

/* print the first point */
       fprintf(fp," 1 %.13e %.13e %.13e %.13e",x1,y1,x1,y1);
       fprintf(fp," %.13e",distance(x1,y2,x2,y2));
       fprintf(fp," %.13e",IBdata[i][6]);
       fprintf(fp," %.13e",cross(x2-x1,y2-y1,x1-xn,y1-yn));
       fprintf(fp," %.13e %.13e \n",IBdata[i][7],IBdata[i][8]);

/* print the middle points */
       for ( j=2; j<IBint[i][2]; j++ ){
         xn =x1; yn = y1; x1 = x2; y1=y2;
         x2 = x0 + (cos(th)*r1*cos(j*angle)) + (sin(th)*r2*sin(j*angle));
         y2 = y0 - (sin(th)*r1*cos(j*angle)) + (cos(th)*r2*sin(j*angle));
         fprintf(fp," 1 %.13e %.13e %.13e %.13e",x1,y1,x1,y1);
         fprintf(fp," %.13e",distance(x1,y2,x2,y2));
         fprintf(fp," %.13e",IBdata[i][6]);
         fprintf(fp," %.13e",cross(x2-x1,y2-y1,x1-xn,y1-yn));
         fprintf(fp," %.13e %.13e \n",IBdata[i][7],IBdata[i][8]);
       }     

/* print the last point */
       xn =x1; yn = y1; x1 = x2; y1=y2;
       x2 = ( cos(th)*(x0+r1)) + (sin(th)*(y0+r2));
       y2 = (-sin(th)*(x0+r1)) + (cos(th)*(y0+r2));
       fprintf(fp," 0 %.13e %.13e %.13e %.13e",x1,y1,x1,y1);
       fprintf(fp," %.13e",distance(x1,y2,x2,y2));
       fprintf(fp," %.13e",IBdata[i][6]);
       fprintf(fp," %.13e",cross(x2-x1,y2-y1,x1-xn,y1-yn));
       fprintf(fp," %.13e %.13e \n",IBdata[i][7],IBdata[i][8]);
     }

   }

  fclose(fp);
  fclose(fpb);

}

/* wpray: writes immersed boundary points from polygon rays */
int wpray ( int i, FILE *fp, FILE *fpb, int first )

{
  int j;
  float x, y;
  char line[MAXLINE];
  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &x, &y );

  fprintf(fp," 1");
  fprintf(fp," %.13e",x);                 /* print the first point with */
  fprintf(fp," %.13e",y);                 /* the connecting angle and   */
  fprintf(fp," %.13e",x);                 /* end point tethering        */
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",IBdata[i][15]);
  fprintf(fp," %.13e",IBdata[i][16]);
  fprintf(fp," %.13e",IBdata[i][17]);
  fprintf(fp," %.13e",IBdata[i][18]);
  fprintf(fp," %.13e",IBdata[i][19]);
  fprintf(fp,"\n");

  for ( j=2; j<IBint[i][2]; j++ )
   {
     getline(line,MAXLINE,fpb);
     sscanf(line, "%e %e", &x, &y );
     fprintf(fp," 1");
     fprintf(fp," %.13e",x);              /* print the middle points */
     fprintf(fp," %.13e",y);
     fprintf(fp," %.13e",x);
     fprintf(fp," %.13e",y);
     fprintf(fp," %.13e",IBdata[i][9]);
     fprintf(fp," %.13e",IBdata[i][6]);
     fprintf(fp," %.13e",IBdata[i][10]);
     fprintf(fp," %.13e",IBdata[i][7]);
     fprintf(fp," %.13e",IBdata[i][8]);
     fprintf(fp,"\n");
   }

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &x, &y );
  fprintf(fp," %d",first);
  fprintf(fp," %.13e",x);
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",x);
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",IBdata[i][9]);
  fprintf(fp," %.13e",IBdata[i][6]);
  fprintf(fp," %.13e",IBdata[i][10]);
  fprintf(fp," %.13e",IBdata[i][7]);
  fprintf(fp," %.13e",IBdata[i][8]);
  fprintf(fp,"\n");
  return;

}

/* wparc: writes immersed boundary points from polygon arcs */
int wparc ( int i, FILE *fp, FILE *fpb, int first )

{
  int j;
  float x, y;
  char line[MAXLINE];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];
  extern float work[2][MAXLINE];

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &x, &y );
  fprintf(fp," 1");
  fprintf(fp," %.13e",x);              /* print the first point with */
  fprintf(fp," %.13e",y);              /* the connecting angle and   */
  fprintf(fp," %.13e",x);              /* end point tethering        */
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",IBdata[i][15]);
  fprintf(fp," %.13e",IBdata[i][16]);
  fprintf(fp," %.13e",IBdata[i][17]);
  fprintf(fp," %.13e",IBdata[i][18]);
  fprintf(fp," %.13e",IBdata[i][19]);
  fprintf(fp,"\n");

  for ( j=2; j<IBint[i][2]; j++ )
   {
     getline(line,MAXLINE,fpb);
     sscanf(line, "%e %e", &x, &y );
     fprintf(fp," 1");
     fprintf(fp," %.13e",x);              /* print the middle points */
     fprintf(fp," %.13e",y);
     fprintf(fp," %.13e",x);
     fprintf(fp," %.13e",y);
     fprintf(fp," %.13e",IBdata[i][9]);
     fprintf(fp," %.13e",IBdata[i][6]);
     fprintf(fp," %.13e",IBdata[i][10]);
     fprintf(fp," %.13e",IBdata[i][7]);
     fprintf(fp," %.13e",IBdata[i][8]);
     fprintf(fp,"\n");
   }

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &x, &y );
  fprintf(fp," %d",first);
  fprintf(fp," %.13e",x);
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",x);
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",IBdata[i][9]);
  fprintf(fp," %.13e",IBdata[i][6]);
  fprintf(fp," %.13e",IBdata[i][10]);
  fprintf(fp," %.13e",IBdata[i][7]);
  fprintf(fp," %.13e",IBdata[i][8]);
  fprintf(fp,"\n");
  return 0;
}

/* wpfarc: writes immersed boundary points from polygon fixed arcs */
int wpfarc ( int i, FILE *fp, FILE *fpb, int first )

{
  int j;
  float xc, yc, xf, yf, xl, yl, xs, ys;
  char line[MAXLINE];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &xl, &yl );
  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &xc, &yc );

  fprintf(fp," 1");
  fprintf(fp," %.13e",xl);
  fprintf(fp," %.13e",yl);
  fprintf(fp," %.13e",xl);
  fprintf(fp," %.13e",yl);
  fprintf(fp," %.13e",distance(xl,yl,xc,yc));
  fprintf(fp," %.13e",IBdata[i][6]);
  fprintf(fp," %.13e",IBdata[i][17]);
  fprintf(fp," %.13e",IBdata[i][7]);
  fprintf(fp," %.13e",IBdata[i][19]);
  fprintf(fp,"\n");
  
  for ( j=2; j<IBint[i][2]; j++ )
   {
     getline(line,MAXLINE,fpb);
     sscanf(line, "%e %e", &xf, &yf );
     fprintf(fp," 1");
     fprintf(fp," %.13e",xc);
     fprintf(fp," %.13e",yc);
     fprintf(fp," %.13e",xc);
     fprintf(fp," %.13e",yc);
     fprintf(fp," %.13e",distance(xc,yc,xf,yf));
     fprintf(fp," %.13e",IBdata[i][6]);
     fprintf(fp," %.13e",cross(xf-xc,yf-yc,xc-xl,yc-yl));
     fprintf(fp," %.13e",IBdata[i][7]);
     fprintf(fp," %.13e",IBdata[i][8]);
     fprintf(fp,"\n");
     xl = xc;  yl = yc;  xc = xf;  yc = yf;
   }

  xf = IBdata[i][3];
  yf = IBdata[i][4];
  fprintf(fp," %d",first);
  fprintf(fp," %.13e",xc);
  fprintf(fp," %.13e",yc);
  fprintf(fp," %.13e",xc);
  fprintf(fp," %.13e",yc);
  fprintf(fp," %.13e",distance(xc,yc,xf,yf));
  fprintf(fp," %.13e",IBdata[i][6]);
  fprintf(fp," %.13e",cross(xf-xc,yf-yc,xc-xl,yc-yl));
  fprintf(fp," %.13e",IBdata[i][7]);
  fprintf(fp," %.13e",IBdata[i][8]);
  fprintf(fp,"\n");

  return 0;

}

/* wpfile: writes immersed boundary points from files */
int wpfile ( int N, FILE *fp, FILE *fpb)
{
  int j;
  float x, y, xt, yt, s, r, b, a, t;
  char line[MAXLINE];

  for ( j=1; j<N; j++ ){
    fscanf(fpb, "%e %e %e %e %e %e %e %e %e", 
                &x, &y, &xt, &yt, &s, &r, &b, &a, &t);
    fprintf(fp," 1 %.13e %.13e %.13e %.13e %.13e",x,y,xt,yt,s);
    fprintf(fp," %.13e %.13e %.13e %.13e\n",r,b,a,t);
  }
  fscanf(fpb, "%e %e %e %e %e %e %e %e %e", 
                &x, &y, &xt, &yt, &s, &r, &b, &a, &t);
  fprintf(fp," 0 %.13e %.13e %.13e %.13e %.13e",x,y,xt,yt,s);
  fprintf(fp," %.13e %.13e %.13e %.13e\n",r,b,a,t);
  return 0;
}

/* wpsing: writes immersed boundary points from polygon singlets */

int wpsing ( int i, FILE *fp, FILE *fpb, int first )

{
  int j;
  float x, y;
  char line[MAXLINE];

  extern int IBint[MAXLINE][MAXARG];
  extern float IBdata[MAXLINE][MAXARG];

  getline(line,MAXLINE,fpb);
  sscanf(line, "%e %e", &x, &y );

  fprintf(fp," %d",first);
  fprintf(fp," %.13e",x);                 /* print the first point with */
  fprintf(fp," %.13e",y);                 /* the connecting angle and   */
  fprintf(fp," %.13e",x);                 /* end point tethering        */
  fprintf(fp," %.13e",y);
  fprintf(fp," %.13e",IBdata[i][9]);
  fprintf(fp," %.13e",IBdata[i][6]);
  fprintf(fp," %.13e",IBdata[i][10]);
  fprintf(fp," %.13e",IBdata[i][7]);
  fprintf(fp," %.13e",IBdata[i][8]);
  fprintf(fp,"\n");

  return 0;

}



