/*
 *  getcolor.c
 *  This program gets the rbg values from an indexed
 *  colormap file given the index.
 *
 *  Author:     David J. Eyre
 *              Department of Mathematics
 *              University of Utah
 *  Date:       December 7, 1996
 *
 *  Copyright @ 1996, David J. Eyre
 *
 */
#include <stdio.h>

void main(int argc, char** argv)
{

  FILE *fd;
  int r, g, b, i, err=0, index=0;

  extern int optind;
  extern char *optarg;

/*  
 *  Parse the input arguments
 */
  if (argc == 1) err = 1;
  while ((i = getopt(argc,argv,"n:")) != EOF) {
    switch (i)
      {
        case 'n':
          index = atoi(optarg);
          break;
        default:
          err = 1;
      }
  }

/*  
 *  Error condition -- print usage
 */
  if (err == 1) 
   {
    fprintf(stderr, "Usage: getcolor [-n index] < infile \n");
    exit(0);
   }

/*  
 *  Read the data file
 */

  for (i=0; i<=index; i++)
    {
       fscanf(stdin, "%i %i %i", &r, &g, &b);
    }
   printf(" %3i %3i %3i %3i", r, g, b, index);
   exit(0);

}
