/*
 *  getindex.c
 *  This program extracts the color index from an
 *  IBIS graphics file.
 *
 *  Author:     David J. Eyre
 *              Department of Mathematics
 *              University of Utah
 *  Date:       December 9, 1996
 *
 *  Copyright @ 1996, David J. Eyre
 *
 */
#include <stdio.h>

void main(int argc, char** argv)
{
  unsigned char image;
  int err, i, index=0, skip_bytes = 4, color;
  extern int optind;
  extern char *optarg;

/* 
 * parse the input
 */
  if (argc == 1) err = 1;
  while ((i = getopt(argc,argv,"n:s:")) != EOF) 
   {
    switch (i)
      {
        case 'n':
          index = atoi(optarg);
          break;
        case 's':
          skip_bytes = atoi(optarg);
          break;
        default:
          err = 1;
      }
   }

/*  
 *  Error condition -- print usage
 */
  if (err == 1) 
   {
    fprintf(stderr,"Usage: getindex [-n index] [-s skip_bytes] \n");
    fprintf(stderr,"  defaults: -n 0 -s 4\n");
    exit(0);
   }

/*  
 *  Read the data file
 */

  fseek (stdin, skip_bytes+index-1, 0);
  color = getc(stdin);
  printf(" %3i", color);

  exit(0);

}
