/*
 *  savecolor.c
 *
 *  This program read an existing colormap and writes
 *    a new colormap that has one different color.
 *
 *  Author:     David J. Eyre
 *              Department of Mathematics
 *              University of Utah
 *  Date:       December 9, 1996
 *
 *  Copyright @ 1996, David J. Eyre
 *
 */
#include <stdio.h>

void main(int argc, char** argv)
{
 
  int r, g, b, red, green, blue, i, err=0, index=0;

  extern int optind;
  extern char *optarg;

/* 
 * parse the input
 */
  if (argc == 1) err = 1;
  while ((i = getopt(argc,argv,"b:g:n:r:")) != EOF) 
   {
    switch (i)
      {
        case 'b':
          blue = atoi(optarg);
          break;
        case 'g':
          green = atoi(optarg);
          break;
        case 'n':
          index = atoi(optarg);
          break;
        case 'r':
          red = atoi(optarg);
          break;
        default:
          err = 1;
      }
   }

/*  
 *  Error condition -- print usage
 */
  if (err == 1) 
   {
    fprintf(stderr,"Usage: savecolor -n index -r red -g green -b blue \n");
    exit(0);
   }

/*  
 *  Read the old data file and write the new
 */

  for (i=0; i<index; i++)
    {
       fscanf(stdin, "%i %i %i", &r, &g, &b);
       fprintf(stdout, "%3i %3i %3i\n", r, g, b);
    }
  fprintf(stdout, "%3i %3i %3i\n", red, green, blue);
  for (i=index+1; i<=255; i++)
    {
       fscanf(stdin, "%i %i %i", &r, &g, &b);
       fprintf(stdout, "%3i %3i %3i\n", r, g, b);
    }
  exit(0);

}
